; _Ps Codice

; Include "HJConst.JSH"; file costanti predefinito di Jaws
Include "_PsConst.JSH"; File personale delle costanti
Include "_PsGlobals.JSH"; file personale delle variabili globali
Include "_PsMessages.JSM"; File personale dei messaggi

Script InserisceFirma ()
MetteTesto (INIZIO_PERSONALE, RIGA_VUOTA); invia l'etichetta Personale alla funzione
EndScript

Script MuoveElementoSuccessivo ()
If !SiamoNellaFinestra (MANAGER) Then; se non si  nella finestra corretta,
PronunciaEsegue (CONTROL_FRECCIAGIU); attiva lo script di Jaws con i tasti indicati,
Return; e interrompe il flusso
EndIf; fine controllo finestra
TypeKey (F2); richiama il comando originale
Refresh (); resetta la schermata
SayLine (); legge la riga corrente
EndScript

Script MuoveElementoPrecedente ()
If !SiamoNellaFinestra (MANAGER) Then; se non si  nella finestra corretta,
PronunciaEsegue (CONTROL_FRECCIASU); attiva lo script di Jaws con i tasti indicati,
Return; ed interrompe il flusso
EndIf; fine controllo finestra
TypeKey (SHIFT_F2); richiama il comando originale
Refresh (); resetta la schermata
SayLine (); legge la riga corrente
EndScript

Script TrovaTesto ()
GestisceDato (SALVA); tenta il salvataggio della posizione corrente
ComandoTrova (); richiama il comando dell'applicativo per la ricerca testo
EndScript

Script SelezionaDalContrassegno ()
If NumeroVersione () >= NUOVE Then; se quella in uso  una versione di Jaws dalla 2018,
PerformScript SelectTextBetweenMarkedPlaceAndCurrentPosition (); esegue lo script nativo
Else; Altrimenti, per le versioni precedenti,
SelectFromSavedLocationToCurrent (); chiama la funzione originale
EndIf; fine controllo versione
EndScript

Script SalvaContrassegno ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script SostituisceTesto ()
GestisceDato (SALVA, CHIUDE); salva la posizione simulando la chiusura del documento
PronunciaEsegue (); ripete i tasti premuti, leggendo il nome dello script
EndScript

Script DataOra ()
Var
Int iOre, ; ore rimanenti alla mezzanotte
Int iMinuti, ; minuti mancanti all'ora successiva
String sOre; messaggio testuale sul tempo rimanente

SayMessage (OT_ERROR, SysGetDate (msgDataEstesa)); pronuncia la data,
SayMessage (OT_ERROR, SysGetTime (msgOraEstesa)); e legge anche l'orario
Let iOre = 24 - (StringToInt (SysGetTime ("H")) + 1); calcola le ore alla mezzanotte,
Let iMinuti = 60 - StringToInt (SysGetTime ("m")); poi calcola anche i minuti rimanenti
Let sOre = FormatString ( ; compone il messaggio, specificando:
msgMezzanotte, ; parametro1, il messaggio creato con i due segnaposti numerati,
iOre, ; parametro2, il dato sulle ore, da sostituire al segnaposto %1,
iMinuti); parametro3, il dato sui minuti, da sostituire al segnaposto %2
SayMessage (OT_ERROR, sOre); legge il messaggio formattato
EndScript

Script AvviaCronometro ()
Var String sMessaggio; l'avviso formattato
Let gnTempoIniziale = GetTickCount (); registra i millisecondi trascorsi dall'avvio
Let sMessaggio = FormatString ( ; formatta l'avviso da leggere
msgOraAvvio, ; parametro1, il messaggio base
SysGetTime ()); parametro2, l'ora da inserire nell'avviso
SayMessage (OT_ERROR, sMessaggio); legge l'avviso formattato
Beep (); emette un segnale acustico
EndScript

Script TempoTrascorso ()
Var
Int iValore, ; il tempo trascorso in millisecondi
Int iSecondi, ; i secondi trascorsi
String sUltimaParte, ; la parte finale dei millisecondi convertiti in testo
String sCentesimi, ; la stringa con i centesimi di secondo
Int iMinuti, ; numero dei minuti trascorsi
Int iOre; numero delle ore trascorse

Let iValore = GetTickCount () - gnTempoIniziale; sottrae il tempo di partenza all'attuale
Let iSecondi = iValore / 1000; converte il valore in secondi
Let sUltimaParte = StringRight (IntToString (iValore), 3); estrae le tre cifre a destra
Let sCentesimi = StringLeft (sUltimaParte, 2); preleva le prime due cifre a sinistra
If iSecondi < MINUTO Then; se il tempo trascorso  inferiore al minuto, legge l'avviso
SayFormattedMessage (OT_HELP, msgBaseTempo, NULLO, iSecondi, sCentesimi)
ElIf iSecondi < ORA Then; se invece siamo sotto all'ora,
Let iMinuti = iSecondi / MINUTO; calcola i minuti trascorsi,
Let iSecondi = iSecondi - (iMinuti * MINUTO); sottrae ai secondi quelli relativi ai minuti,
SayFormattedMessage (OT_HELP, msgMinuti, NULLO, iMinuti, iSecondi, sCentesimi);
Else; se invece siamo sopra all'ora di tempo trascorso,
Let iOre = iSecondi / ORA; calcola le ore trascorse suddividendo i secondi,
; quindi calcola i minuti dividendo i secondi rimasti dopo aver tolto quelli delle ore,
Let iMinuti = (iSecondi - (iOre * ORA)) / MINUTO
; e infine aggiorna i secondi togliendo quelli compresi nelle ore e nei minuti
Let iSecondi = iSecondi - ((iOre * ORA) + (iMinuti * MINUTO))
SayFormattedMessage (OT_HELP, msgOre, NULLO, iOre, iMinuti, iSecondi); legge l'avviso
EndIf; fine controllo tempo
EndScript

Script Saluto ()
Var
Int iOra, ; ora corrente
Int iValore; dato da estrarre

Let iOra = StringToInt (SysGetTime (_H)); rileva l'ora corrente
If iOra >= MATTINO && iOra < POMERIGGIO Then; se si  nel mattino,
Let iValore = 1; imposta il numero del dato da estrarre
ElIf iOra >= POMERIGGIO && iOra < SERA Then; se invece si  nel pomeriggio,
Let iValore = 2; imposta il dato relativo
ElIf iOra >= SERA && iOra < NOTTE Then; se si  in orario serale,
Let iValore = 3; imposta il dato
ElIf iOra >= NOTTE || iOra < MATTINO Then; se infine si  nell'orario notturno,
Let iValore = 4; imposta il dato
EndIf; fine controllo ora corrente
SayMessage (OT_HELP, StringSegment (lstSaluti, PIPE, iValore)); legge il saluto estratto
EndScript

Script CopiaRiga ()
If !StringTrimLeadingBlanks (GetLine ()) Then; se nella riga non  presente del testo,
SayMessage (OT_HELP, msgRigaVuota, msgRigaVuota_corto); avvisa dell'errore,
Return; e interrompe il flusso
EndIf; fine controllo riga corrente
SpeechOff (); spegne la sintesi
JAWSEnd (); porta il cursore a fine riga
SelectFromStartOfLine (); seleziona la riga corrente
SpeechOn (); riattiva la sintesi
Refresh (); resetta la schermata
PerformScript CopySelectedTextToClipboard (); esegue lo script nativo
EndScript

Script AggiungeRiga ()
If !StringTrimLeadingBlanks (GetLine ()) Then; se nella riga non  presente del testo,
SayMessage (OT_HELP, msgRigaVuota, msgRigaVuota_corto); avvisa dell'errore,
Return; e interrompe il flusso
EndIf; fine controllo riga corrente
SpeechOff (); spegne la sintesi
JAWSEnd (); porta il cursore a fine riga
SelectFromStartOfLine (); seleziona la riga corrente
SpeechOn (); riattiva la sintesi
Refresh (); resetta la schermata
PerformScript AppendSelectedTextToClipboard (); esegue lo script nativo
EndScript

Script AperturaCodice ()
MetteTesto (lstApreScript, RIGA_VUOTA); invia le dichiarazioni di apertura alla funzione
EndScript

Int Function SceltaLivello ()
Return DlgSelectItemInList (; restituisce la scelta effettuata
VociScelta (), ; parametro1, la nostra funzione che compone le voci di scelta
FormatString (ttlSelezione, ttlLivelloFinestra, gsNomeFinestra), ; parametro2, testo a video
FALSE); parametro3, valore per disattivare l'ordinamento alfabetico
EndFunction

Handle Function LivelloFinestra (int iLivello)
If iLivello == CORRENTE Then; se stata scelta la prima voce,
Return GetCurrentWindow (); restituisce l'Handle della finestra corrente
ElIf iLivello == REALE Then; se invece si  scelta la seconda voce,
Return GetRealWindow (GetFocus ()); restituisce l'Handle per la prima finestra col titolo
ElIf iLivello == PRINCIPALE Then; Se invece  stata scelta l'ultima voce,
Return GetAppMainWindow (GetFocus ()); restituisce l'Handle della finestra Principale
EndIf; fine controllo livello
EndFunction

Script InfoFinestra ()

Var
int iScelta, ; scelta effettuata
Handle h, ; finestra da leggere
String sLivello, ; livello della finestra
String sInfo; testo del messaggio

Let gsNomeFinestra = NULLO; azzera l'eventuale valore impostato
Let iScelta = SceltaLivello (); imposta il livello della finestra di cui leggere i dati

If !iScelta Then; nel caso la variabile sia 0, essendo stato premuto il tasto Esc o Annulla,
Return; interrompe lo script
EndIf; fine controllo annullamento

Let h = LivelloFinestra (iScelta); imposta l'Handle, sulla base del livello appena scelto

; estrae il nome del livello della finestra e lo imposta nella variabile
Let sLivello = StringSegment (lstLivelliFinestra, PIPE, iScelta)

Let sInfo = FormatString ( ; crea il testo da visualizzare mettendo i dati nei segnaposto
msgDatiFinestra, ; parametro1, nome del messaggio base
sLivello, ; parametro2, testo della voce scelta, al posto di %1,
h, ; parametro3, Handle, al posto di %2
GetControlID (h), ; parametro4, Control ID, al posto di %3
GetWindowName (h), ; parametro5, nome della finestra, al posto di %4
GetWindowType (h), ; parametro6, tipo della finestra, al posto di %5
GetWindowTypeCode (h), ; parametro 7, codice di tipo, al posto di %6
GetWindowSubtypeCode (h), ; parametro 8, codice di Sottotipo, al posto di %7
GetWindowClass (h), ; parametro9, classe della finestra, al posto di %8
hlpFineInfo); parametro10, formula di fine informazioni, al posto di %9

SayMessage (OT_USER_BUFFER, sInfo); invia i dati al Visualizzatore Virtuale

EndScript

String Function CodiceFinestra (int iLivello)
Var Handle h; l'Handle della finestra

Let h = LivelloFinestra (iLivello); determina l'Handle sulla base del livello indicato
If iLivello == CORRENTE Then; se si  richiesto un codice del primo tipo,
Return FormatString ( ; restituisce un messaggio formattato con tre termini
msg3Trattino, ; parametro1, messaggio base con tre segnaposti
GetWindowTypeCode (h), ; parametro2, codice di tipo, al posto di %1
GetWindowSubtypeCode (h), ;parametro3, codice di Sottotipo, al posto di %2
GetWindowClass (h));parametro4, classe della finestra al posto di %3.
ElIf iLivello == REALE ; Se invece si  scelto il livello Reale,
|| iLivello == PRINCIPALE Then; oppure quello principale,
Return FormatString ( ; restituisce un messaggio formattato con due soli termini
msg2Trattino, ; parametro1, messaggio base con due segnaposti
GetWindowName (h), ; parametro2, nome della finestra da mettere al posto di %1
GetWindowClass (h));parametro3, classe della finestra al posto di %2.
EndIf; fine controllo livello
EndFunction

String Function VociScelta ()
Var
Int i, ; contatore del ciclo
String sVoci, ; elenco da restituire
String sNome; nome del livello di finestra

Delay (ATTESA); sospende il flusso per i decimi di secondo impostati
For i = 1 To StringSegmentCount (lstLivelliFinestra, PIPE); scorre le voci nella stringa
If i > 1 Then; se si  dal secondo passaggio in poi,
Let sVoci = sVoci + BELL; inserisce il separatore delle voci
EndIf; fine controllo passaggi
Let sNome = StringSegment (lstLivelliFinestra, PIPE, i); estrae la prima parte della voce
Let sVoci = sVoci + FormatString (msg2Punto, sNome, CodiceFinestra (i)); accoda il codice
EndFor; fine ciclo di scansione livelli
Return sVoci; restituisce l'elenco ricostruito
EndFunction

Void Function MetteTesto (string sDati, int iRitorni)
If CodiceFinestra (CORRENTE) != CODICE_EDITOR Then; se la finestra non  corretta,
TypeCurrentScriptKey (); ripristina i tasti premuti,
Return; e interrompe il flusso
EndIf; fine controllo finestra
Var
Int i, ; contatore del ciclo
Int iRighe, ; numero delle righe copiate
String sRiga; singolo segmento da scrivere

SpeechOff (); spegne la sintesi
; rimuove dal testo eventuali caratteri di ritorno a capo, Ascii 13
Let sDati = StringReplaceSubstrings (sDati, CR, NULLO)
; esegue un ciclo, ripetendolo per il numero di segmenti nella stringa
For i = 1 To StringSegmentCount (sDati, LF)
If i > 1 Then; dal secondo passaggio in poi,
EnterKey (); simula la pressione di Invio, per creare una nuova riga
Let iRighe = iRighe + 1; aggiorna il contatore delle righe copiate
Pause (); sospende momentaneamente il flusso
EndIf; fine controllo passaggi
Let sRiga = StringSegment (sDati, LF, i); estrae il segmento equivalente ad una riga,
TypeString (sRiga); e lo trascrive nel documento
EndFor; fine ciclo scansione testo
If StringRight (sDati, 1) == LF Then; se l'ultimo carattere del testo  quello di nuova linea,
Let iRitorni = iRitorni + 1; aggiunge una unit ai ritorni a capo da creare
EndIf; fine controllo ultimo carattere
For i = 1 To iRitorni; aggiunge eventuali o ulteriori ritorni a capo
EnterKey (); crea un'ulteriore nuova riga
Let iRighe = iRighe + 1; aggiorna il contatore delle righe copiate
EndFor; fine ciclo ritorni a capo
SpeechOn (); riattiva la sintesi
If iRighe Then; se sono state copiate delle righe intere,
If iRighe > 1 Then; se le righe sono pi di una,
Let sDati =FormatString (msgMettiRighe, iRighe); formatta il dato con il numero di righe
EndIf; fine controllo numero righe
SayMessage (OT_ERROR, sDati); legge il messaggio in tono minore
EndIf; fine controllo righe copiate
Refresh (); resetta la schermata
SayLine (); legge la riga corrente
EndFunction

String Function Nota (int iValore)
Var Int iBase; aggiunta per conversione in lettera
If iValore <= 5 Then; se le note sono fino al Sol,
Let iBase = INIZIO_C; imposta una base per lettere dalla C alla G
Else; altrimenti, se sono note dal La al Do alto,
Let iBase = INIZIO_A; imposta una base per lettere dalla A alla C
EndIf; fine impostazione base
; restituisce il nome del file, opportunamente formattato
Return FormatString (lstFileNote, iValore, MakeCharacterFromValue (iBase + iValore))
EndFunction

Void Function Suona (string sFile, int iRitardo)
PlaySound (FindJAWSSoundFile (sFile + WAV)); suona il file di suoni specificato
If iRitardo Then; se un valore  stato specificato,
Delay (iRitardo); sospende il flusso per i decimi di secondo indicati
EndIf; fine controllo ritardo
EndFunction

Script FraMartino ()
Var
Int iTempo1, ; primo intervallo di tempo
Int iTempo2, ; secondo intervallo di tempo
Int i; contatore dei cicli
Let iTempo1 = 4; imposta il valore intero
Let iTempo2 = 2; imposta un tempo dimezzato
For i = 1 To 2; esegue le prime due battute
Suona (Nota (1), iTempo1)
Suona (Nota (2), iTempo1)
Suona (Nota (3), iTempo1)
Suona (Nota (1), iTempo1)
EndFor; fine prime due battute
For i = 1 To 2; esegue terza e quarta battuta
Suona (Nota (3), iTempo1)
Suona (Nota (4), iTempo1)
Suona (Nota (5), iTempo1)
Delay (iTempo1)
EndFor; fine terza e quarta battuta
For i = 1 To 2; esegue quinta e sesta battuta
Suona (Nota (5), iTempo2)
Suona (Nota (6), iTempo2)
Suona (Nota (5), iTempo2)
Suona (Nota (4), iTempo2)
Suona (Nota (3), iTempo2)
Delay (iTempo2)
Suona (Nota (1), iTempo2)
Delay (iTempo2)
EndFor; fine quinta e sesta battuta
For i = 1 To 2; esegue penultima ed ultima battuta
Suona (Nota (2), iTempo1)
Suona (Nota (5), iTempo1)
Suona (Nota (1), iTempo1)
Delay (iTempo1)
EndFor; fine penultima e ultima battuta
EndScript

String Function NomeArchivio (int iTipo)
If iTipo == CORRENTE Then; se l'archivio da elaborare  quello dell'applicazione attiva,
Return GetActiveConfiguration () + JCF; ne restituisce il nome aggiungendo l'estensione
ElIf iTipo == PERSONALE Then; se invece l'archivio da elaborare  quello personale,
Return PS_FILE + JCF; ne restituisce il nome aggiungendo l'estensione
ElIf iTipo == APP Then; per il file Tasti dell'applicazione attiva,
Return ApplicativoCorrente () + JKM; restituisce il file tasti dell'applicazione
ElIf iTipo == JAWS Then; per il file Tasti Predefinito,
Return JAWS_FILE + JKM; utilizza l'altra costante impostata
ElIf iTipo == SEGNI Then; se l'archivio da elaborare  quello per i contrassegni,
; rimuove i riferimenti ai suffissi inglesi dei nomi, ed aggiunge etichetta ed estensione
Return FormatString ( ; restituisce il nome formattato,
msg2, ; messaggio base,
StringReplaceSubstrings (GetActiveConfiguration (), CLASSIC, NULLO), ; rimuove un suffisso,
SUFFISSO_JSI); e ne aggiunge un altro, comprensivo d'estensione
ElIf iTipo == TEMPORANEO Then; se infine  richiesto un archivio solo per la sessione,
Return FormatString ( ; restituisce nome e percorso dell'archivio temporaneo
msg3Controbarra, ; messaggio base,
GetUserSettingsDirectory (), ; percorso completo delle Impostazioni personali,
CARTELLA_SESSIONE, ; nome della sottocartella dove salvare le annotazioni,
GetActiveConfiguration () + TMP); etichetta dell'applicativo corrente
EndIf; fine controllo tipo archivio
EndFunction

String Function ScriveLivelloFinestra (string sNomeTipo, int iLivello)
If IniWriteInteger ( ; Tenta di scrivere il valore nella configurazione Personale
TIPI_FINESTRE, ; parametro1, sezione del file, dato fisso
sNomeTipo, ; parametro2, il tipo di finestra che funge da chiave
iLivello, ; parametro3, il valore numerico con il livello di finestra
NomeArchivio (PERSONALE)); parametro4, il file configurazione Personale, dato fisso
Then; se la scrittura riesce, prima legge l'avviso,
SayFormattedMessage (OT_ERROR, hlpScritturaOk, hlpScritturaOk_corto, sNomeTipo)
Return TRUE; poi restituisce l'esito positivo
Else; altrimenti, prima avvisa dell'errore,
SayFormattedMessage (OT_ERROR, hlpNoScrittura, hlpNoScrittura_corto, sNomeTipo)
Return FALSE; poi restituisce un risultato nullo
EndIf; fine controllo esito
EndFunction

Int Function LeggeLivelloFinestra (string sNomeTipo)
Return IniReadInteger ( ; restituisce il valore memorizzato nel file configurazione Personale
TIPI_FINESTRE, ; parametro1, sezione del file, dato fisso
sNomeTipo, ; parametro2, il tipo di finestra che funge da chiave
FALSE, ; parametro3, il valore restituito in caso di mancata lettura, dato fisso
NomeArchivio (PERSONALE)) ; parametro4, file di configurazione Personale
EndFunction

Int Function ScriveCodiceFinestra (string sNomeTipo, string sCodice)
If IniWriteString ( ; Tenta di scrivere il dato nel file dell'applicazione corrente
DATI_FINESTRE, ; parametro1, sezione del file, dato fisso
sNomeTipo, ; parametro2, il tipo di finestra che funge da chiave
sCodice, ; parametro3, il dato testuale con il codice della finestra
NomeArchivio (CORRENTE)); parametro4, file configurazione dell'applicativo corrente
Then; se la scrittura riesce, prima legge l'avviso,
SayFormattedMessage (OT_ERROR, hlpScritturaOk, hlpScritturaOk_corto, sNomeTipo)
Return TRUE; poi restituisce l'esito positivo
Else; altrimenti, prima avvisa dell'errore,
SayFormattedMessage (OT_ERROR, hlpNoScrittura, hlpNoScrittura_corto, sNomeTipo)
Return FALSE; poi restituisce un risultato nullo
EndIf; fine controllo esito
EndFunction

String Function LeggeCodiceFinestra (string sNomeTipo)
Return IniReadString ( ; restituisce il dato memorizzato nel file per l'applicazione corrente
DATI_FINESTRE, ; parametro1, sezione del file, dato fisso
sNomeTipo, ; parametro2, il tipo di finestra che funge da chiave
NULLO, ; parametro3, la stringa vuota restituita in caso di mancata lettura, dato fisso
NomeArchivio (CORRENTE)); parametro4, file archivio dell'applicativo ottenuto dalla funzione
EndFunction

Script Prova ()
Var
String sNomeFile, ; nome completo del documento
String sEstensione; estensione del file
If DocumentoCorrente (sNomeFile, sEstensione, IsSameScript ()) Then; se i dati ci sono,
SayFormattedMessage (OT_HELP, msg2Virgola, NULLO, sNomeFile, sEstensione); li legge
EndIf; fine controllo Nome del documento
EndScript

String Function LeggeChiavi (int iTipo, string sSezione)
Return IniReadSectionKeys ( ; legge i dati specificati dall'archivio impostato
sSezione, ; parametro1, nome della sezione da cui leggere i dati
NomeArchivio (iTipo)); parametro2, nome dell'archivio del tipo specificato
EndFunction

Int Function DefinisceLivello (string sNomeTipo, int ByRef iLivello)
Var Int iScelta; un valore da impostare
; trasmette con una variabile globale il nome del tipo di finestra di cui scegliere il livello
Let gsNomeFinestra = sNomeTipo
While !iScelta; esegue un ciclo, proponendo la richiesta finch la scelta rimane a zero
Let iScelta = SceltaLivello (); determina il livello cui leggere i dati della finestra
If !iScelta Then; se non  stata effettuata nessuna scelta,
Let iScelta = ExMessageBox (; propone una conferma all'uscita
msgConfermaUscita, ; parametro1, messaggio per il corpo della finestra di dialogo
ttlConfermaUscita, ; titolo della finestra di conferma
MB_YESNO|MB_ICONQUESTION); parametro3, tipo di controllo e dell'icona
If iScelta == IDNO Then; se  stato scelto No,
Let iScelta = FALSE; azzera il valore per consentire un ritorno all'inizio del ciclo
EndIf; fine controllo conferma
EndIf; fine controllo scelta effettuata
EndWhile; fine del ciclo di scelta
If iScelta == IDYES Then; se si  confermata l'uscita dalla procedura,
Return FALSE; restituisce un risultato nullo
ElIf ScriveLivelloFinestra (sNomeTipo, iScelta) Then; se la scrittura dei dati riesce,
Let iLivello = iScelta; trasmette la scelta effettuata
Return TRUE; restituisce l'esito positivo
Else; altrimenti,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo ritorno
EndFunction

Void Function NuovoTipoFinestra (string ByRef sNomeTipo, int ByRef iLivello)
Var Int iTasto; il valore del tasto premuto
Let sNomeTipo = gsNomeFinestra; si premette il nome casomai segnalato dalla procedura
Let iTasto = InputBox ( ; Consente di specificare un nuovo tipo di finestra
msgInserisciRiga, ; parametro1, l'avviso per il prompt della casella di editazione
ttlTipoNuovoFinestra, ; parametro2, titolo della finestra di dialogo
sNomeTipo); parametro3, il nome da impostare, per riferimento
If sNomeTipo Then; se un nuovo tipo  stato definito,
If DefinisceLivello (sNomeTipo, iLivello) Then; se viene scelto anche un livello,
Return TRUE; restituisce l'esito positivo
Else; altrimenti, se la scelta  stata annullata,
Let sNomeTipo = NULLO; cancella il dato
EndIf; fine controllo scelta livello
EndIf; fine controllo impostazione tipo
Return FALSE; se nessun altro controllo  intervenuto, restituisce un risultato nullo
EndFunction

Int Function CancellaChiave (int iTipo, string sSezione, string sChiave)
Return IniRemoveKey ( ; cancella il dato della chiave specificata
sSezione, ; parametro1, nome della sezione in cui cercare il dato
sChiave, ; parametro2, chiave del dato da rimuovere
NomeArchivio (iTipo)); parametro3, nome dell'archivio del tipo specificato
EndFunction

Int Function ControllaScritturaCodice (string sNomeTipo, string sCodice)
Var
String sMessaggio, ; il testo da presentare a video
Int iTasto; il tasto premuto
; formatta il messaggio base aggiungendo tipo finestra e nome applicativo
Let sMessaggio = FormatString (msgConfermaDati, sNomeTipo, GetActiveConfiguration ())
Let iTasto = ExMessageBox ( ; chiede conferma alla scrittura del codice
sMessaggio, ; parametro1, il testo per la casella di sola lettura
ttlConfermaDati, ; parametro2, titolo della schermata
MB_YESNOCANCEL|MB_USERICON); parametro3, tipo di conferma e icona di avviso

If iTasto == IDYES Then; se si  confermata la registrazione del codice identificativo,
Return ScriveCodiceFinestra (sNomeTipo, sCodice); tenta la scrittura e ne restituisce l'esito
ElIf iTasto == IDNO Then; se invece si  scelto di non confermarla tramite l'omonimo pulsante,
ScriveCodiceFinestra (sNomeTipo, NESSUNO); inibisce ulteriori controlli per l'applicazione
EndIf; fine controllo conferma
Return FALSE; se non si conferma la scelta, si restituisce comunque un risultato nullo
EndFunction

Script DefinisceTipiFinestra ()
Var
String sElenco, ; elenco tipi di finestra registrati
Int iScelta, ; scelta effettuata
String sNomeTipo, ; il tipo di finestra scelto
Int iLivello; il livello di finestra di cui rilevare i dati

Let sElenco = LeggeChiavi (PERSONALE, TIPI_FINESTRE); rileva l'elenco delle voci
If sElenco Then; se sono stati rilevati dei tipi di finestra,
Let sElenco = sElenco + PIPE + lstNuovoTipo; aggiunge la voce per sceglierne una nuova
; Consente di scegliere un tipo di finestra esistente o di impostarne uno nuovo
Let iScelta = DlgSelectItemInList (sElenco, ; parametro1, elenco delle scelte possibili
FormatString (ttlTipiFinestre, lstNuovoTipo, msgInfoScelte), ; parametro2, messaggio
FALSE);parametro3, ordinamento alfabetico disattivato
If iScelta == FALSE Then; se non  stata impostata alcuna scelta,
Return; interrompe il flusso
ElIf iScelta < StringSegmentCount (sElenco, PIPE) Then; se la voce scelta non  l'ultima
Let sNomeTipo = StringSegment (sElenco, PIPE, iScelta); estrae la voce dall'elenco
Let iLivello = LeggeLivelloFinestra (sNomeTipo); rileva il livello salvato per il tipo di finestra
EndIf; fine controllo scelta
EndIf; fine controllo tipi registrati
If !sNomeTipo Then; se il tipo di finestra non  stato definito,
NuovoTipoFinestra (sNomeTipo , iLivello); imposta, e trasmette, tipo e livello della finestra
EndIf; fine controllo presenza dato
If sNomeTipo Then; se un tipo di finestra  impostato,
If ControllaScritturaCodice (sNomeTipo, CodiceFinestra (iLivello)) Then; se i dati si salvano,
Return TRUE; restituisce l'esito positivo
EndIf; fine controllo scrittura
EndIf; fine controllo tipo finestra
Return FALSE; se nessun altro controllo  intervenuto, restituisce un risultato nullo
EndScript

Int Function SiamoNellaFinestra (string sNomeTipo, int iAiuto)
Var
Int iLivello, ; il livello della finestra di cui leggere i dati
String sCodiceConfronto ; il dato registrato da confrontare

; Rileva il livello del tipo di finestra specificato
Let iLivello = LeggeLivelloFinestra (sNomeTipo)
If !iLivello Then; se il livello non  stato ancora registrato,
If !iAiuto Then; se non  attiva la fase,
If LeggeChiavi (CORRENTE, DATI_FINESTRE) ; se sono salvati dei dati per le finestre,
&& gsNomeFinestra != sNomeTipo Then; e se un messaggio non  gi stato letto,
SayFormattedMessage (OT_ERROR, hlpNoLivello, NULLO, sNomeTipo); avvisa dell'errore,
Let gsNomeFinestra = sNomeTipo; poi evita la ripetizione immediata del messaggio
EndIf; fine controllo registrazione dati
Return FALSE; interrompe il flusso, restituendo un risultato nullo
ElIf !DefinisceLivello (sNomeTipo, iLivello) Then; anche se un livello non viene poi scelto,
Return FALSE; si interrompe il flusso
EndIf; fine controllo Aiuto
EndIf; fine controllo presenza livello

; rileva il dato registrato per l'applicativo corrente
Let sCodiceConfronto = LeggeCodiceFinestra (sNomeTipo)
If sCodiceConfronto Then; se un dato  stato rilevato,
If CodiceFinestra (iLivello) == sCodiceConfronto Then; se i due codici corrispondono,
Return TRUE; restituisce l'esito positivo
ElIf sCodiceConfronto == NESSUNO Then; se invece il codice  quello di annullamento,
Return FALSE; interrompe il flusso restituendo un valore nullo
Else; altrimenti, se il confronto fallisce,
If iAiuto Then; se  attiva la fase,
SayMessage (OT_ERROR, hlpNoFinestra, hlpNoFinestra_corto); legge l'avviso
EndIf; fine controllo aiuto
Return FALSE; in ogni caso, interrompe il flusso restituendo un risultato nullo
EndIf; fine controllo confronto
EndIf; fine controllo presenza codice

If iAiuto Then; se  attiva la fase,
Return ControllaScritturaCodice (sNomeTipo, CodiceFinestra (iLivello)); chiede conferma
Else; altrimenti, dato che il controllo  fallito,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo aiuto
EndFunction

Script CercaRipetiSuccessivo ()
If SiamoNellaFinestra (EDITING, IsSameScript ()) Then; se si  in una finestra di editazione,
TypeKey (F3); richiama il comando originale
Pause ()
SayLine (); legge la riga corrente
Else; altrimenti, se non si tratta della finestra corretta,
TypeCurrentScriptKey (); ripete i tasti di attivazione dello script
EndIf; fine controllo finestra
EndScript

Script CercaRipetiPrecedente ()
If SiamoNellaFinestra (EDITING, IsSameScript ()) Then; se si  in una finestra di editazione,
TypeKey (SHIFT_F3); richiama il comando originale
Pause ()
SayLine (); legge la riga corrente
Else; altrimenti, se non si tratta della finestra corretta,
TypeCurrentScriptKey (); ripete i tasti di attivazione dello script
EndIf; fine controllo finestra
EndScript

Void Function PronunciaEsegue (string sTasti, int iRipeti)
If sTasti; se  sono stati specificati dei tasti,
&& !iRipeti Then; e non si  indicato alcun secondo parametro,
PerformScriptByName (GetScriptAssignedTo (sTasti)); esegue lo script abbinato ai tasti,
Return; e interrompe il flusso
EndIf; fine controllo esecuzione
If !sTasti Then; se non  stato indicato alcun tasto,
Let sTasti = GetCurrentScriptKeyName (); rileva gli ultimi tasti premuti
EndIf; fine controllo tasti
TypeKey (sTasti); invia i tasti all'applicazione o al sistema operativo
If iRipeti Then; se  stata impostata la forzatura della ripetizione tasti,
Let sTasti = GetCurrentScriptKeyName (); imposta i tasti solo per la lettura del nome script
EndIf; fine controllo ripetizione forzata
SayMessage (OT_ERROR, GetScriptAssignedTo (sTasti)); legge il nome del relativo script
EndFunction

Int Function ComprimeDati (string sFile, string sSezioni, ; intestazione con i primi due parametri,
string ByRef sChiavi, string ByRef sDati); seconda riga, con gli altri due
Var
Int j, ; contatore del ciclo primario
Int k, ; contatore del secondo ciclo
String sSezione, ; sezione del file da leggere
String sElenco, ; elenco temporaneo delle chiavi
String sChiave, ; chiave del dato
String sDato; singolo dato da leggere

Let sChiavi = NULLO; resetta l'elenco dei tasti,
Let sDati = NULLO; ed anche dei nomi di script
For j = 1 To StringSegmentCount (sSezioni, PIPE); scorre le sezioni da leggere
Let sSezione = StringSegment (sSezioni, PIPE, j); estrae una singola sezione
Let sElenco = ChiaviUtente (sFile, sSezione); rileva le chiavi dei dati dell'Utente
For k = 1 To StringSegmentCount (sElenco,PIPE); scorre l'eventuale elenco rilevato
Let sChiave = StringSegment (sElenco, PIPE, k); ne estrae la singola chiave
If !StringSegmentIndex (sChiavi, PIPE, sChiave, TRUE) Then; se la chiave non c',
Let sChiavi = CambiaCampo (sChiavi, sChiave, ULTIMA); la aggiunge all'elenco esistente
Let sDato = LeggeUtente (sFile, sSezione, sChiave); poi rileva il nome di script,
Let sDati = CambiaCampo (sDati, sDato, ULTIMA); e lo aggiunge al relativo elenco
EndIf; fine controllo chiavi registrate
EndFor; fine scorrimento chiavi
EndFor; fine scorrimento sezioni
If sChiavi Then; se, alla fine, dei tasti sono stati rilevati,
Return TRUE; restituisce l'esito positivo
Else; altrimenti,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo esito
EndFunction

Script AiutoInLinea ()
Var
Int j, ; contatore del ciclo primario
Int iStart, ; valore iniziale del ciclo
Int k, ; contatore del secondo ciclo
String sFile, ; file tasti da elaborare
String sTitolo, ; titolo per inizio informazioni
String sPrimi, ; elenco iniziale dei tasti
String sChiavi, ; elenco combinazioni tasti rilevate
String sDati, ; nomi di script abbinati ai tasti
String sTasto, ; singola combinazione tasti che funge da chiave
String sNome, ; singolo script abbinato
String sInfo, ; informazioni da visualizzare
String sAlias, ; nome alternativo dello script
Int iSerie, ; indica una serie avviata
String sBufferTasto, ; stringa registrata delle combinazioni tasti
String sBufferNome, ; stringa registrata del nome di script
String sBufferAlias, ; stringa registrata con l'alias dello script
String sBufferInfo, ; stringa registrata delle informazioni sugli script
String s1, ; primo carattere variabile
String s2, ; ultimo carattere variabile
String sPrimoDiverso, ; carattere variabile iniziale della serie
String sUltimoDiverso; carattere variabile finale della serie

EnsureNoUserBufferActive (); chiude eventuali schermate del Visualizzatore Virtuale
If InHJDialog () Then; se si  in una procedura Jaws,
If !gsTitolo ; se nessun titolo  registrato per la finestra corrente,
|| !gsEtichette Then; oppure, se non ci sono pulsanti di scelta,
SayMessage (OT_ERROR, hlpNoInLinea, hlpNoInLinea_corto); pronuncia l'avviso,
Return; e interrompe il flusso
Else; altrimenti,
ComponeAiuto (); crea e visualizza le informazioni di contesto,
Return; e interrompe il flusso
EndIf; fine controllo titolo
EndIf; fine controllo tipo finestra
If ApplicativoCorrente () != JAWS_FILE Then; se non si  nell'Editor di Script
Let iStart = APP; imposta di iniziare dal file tasti dell'applicativo corrente
Else; altrimenti,
Let iStart = JAWS; riduce la scansione al solo file tasti predefinito
EndIf; fine controllo valore iniziale
For j = iStart To JAWS; scorre i tipi di file tasti
Let sFile = NomeArchivio (j); imposta il nome del file tasti da elaborare
; crea gli elenchi leggendo dalle sezioni del file tasti da elaborare
If ComprimeDati (sFile, ElencoSezioni (), sChiavi, sDati) Then; se dei tasti sono stati rilevati,
If j == APP Then; se si sta elaborando il file tasti dell'applicazione corrente,
; formatta il titolo dell'Aiuto con il nome dell'applicativo
Let sTitolo = FormatString (hlpInfoApp, GetActiveConfiguration ())
Let sPrimi = sChiavi; registra il primo elenco di tasti
ElIf j == JAWS Then; se si sta invece elaborando il file tasti predefinito,
Let sTitolo = hlpInfoJaws; imposta il relativo titolo per l'Aiuto
If UserBufferGetLength ()Then; se nel Visualizzatore Virtuale  presente del testo,
UserBufferAddText (FormatString (msgTraVuote, sTitolo)); inizializza la seconda parte
EndIf; fine controllo testo Aiuto
EndIf; fine controllo passaggi
For k = 1 To StringSegmentCount (sChiavi, PIPE); scorre le combinazioni tasti rilevate
Let sTasto = StringSegment (sChiavi, PIPE, k); estrae la combinazione tasti da verificare
If j == APP ; se si  al primo passaggio,
|| !StringSegmentIndex (sPrimi, PIPE, sTasto, TRUE) Then; o, se i tasti non ci sono gi,
If !UserBufferGetLength ()Then; se il Visualizzatore Virtuale   vuoto,
UserBufferAddText (sTitolo + LF); lo inizializza con l'apposito titolo
EndIf; fine controllo creazione testo
If sTasto != GetCurrentScriptKeyName () Then; se i tasti non sono quelli di attivazione,
; memorizza il nome reale dello script abbinato, e dell'alias proposto nelle informazioni
Let sNome = ImpostaNomi (StringSegment (sDati, PIPE, k), sAlias)
; legge il sommario, tramite la nostra funzione creata con il nome di quella nativa
Let sInfo = GetScriptSynopsis (sNome)
If !sInfo Then; se nessuna informazione  stata rilevata,
Let sInfo = sAlias; usa come informazione il nome assegnato allo script
EndIf; fine controllo presenza informazioni
If !TrovaSerie (sBufferTasto, sBufferInfo, sTasto, sInfo, s1, s2, iSerie) ; se le ultime due voci non sono in serie,
&& !iSerie Then; e una serie non  gi stata rilevata,
If sBufferTasto Then; se i dati dello script precedente sono stati rilevati,
AggiornaVisualizzatore (sBufferTasto, sBufferNome, sBufferAlias, sBufferInfo, NULLO, NULLO)
EndIf; fine controllo presenza buffer
Else; altrimenti, se una serie  stata rilevata,
If !iSerie Then; se si  all'avvio della serie,
Let sPrimoDiverso = StringUpper (s1); memorizza il primo carattere diverso della serie, portandolo i maiuscolo qualora sia una lettera,
Let iSerie = TRUE; e ne annota l'avvio
ElIf iSerie == 1 Then; se invece la serie continua,
Let sUltimoDiverso = StringUpper (s2); annota l'ultimo carattere, portandolo i maiuscolo qualora sia una lettera
Else; altrimenti, se una serie si conclude,
AggiornaVisualizzatore (sBufferTasto, NULLO, NULLO, sBufferInfo, sPrimoDiverso, sUltimoDiverso)
Let iSerie = FALSE; annulla il valore
EndIf; fine controllo serie attiva
EndIf; fine controllo presenza serie
; aggiorna i dati memorizzati per:
Let sBufferTasto = sTasto; combinazione tasti
Let sBufferNome = sNome; nome dello script
Let sBufferAlias = sAlias; alias dello script
Let sBufferInfo = AggiungePunto (sInfo); informazioni sullo script
EndIf; fine controllo tasti validi
EndIf; fine controllo tasti gi elaborati
EndFor; fine ciclo scorrimento chiavi
If !iSerie Then; se non  attiva alcuna serie,
AggiornaVisualizzatore (sBufferTasto, sBufferNome, sBufferAlias, sBufferInfo, NULLO, NULLO); trascrive l'ultima voce
Else; altrimenti,
AggiornaVisualizzatore (sBufferTasto, NULLO, NULLO, sBufferInfo, sPrimoDiverso, sUltimoDiverso); annota l'ultima serie,
Let iSerie = FALSE; e ne annulla il valore
EndIf; fine controllo attivazione serie
Let sBufferTasto = NULLO; resetta il dato, per il successivo inizio
EndIf; fine controllo presenza chiavi
EndFor; fine ciclo scorrimento file
If UserBufferGetLength ()Then; se nel Visualizzatore Virtuale  presente del testo,
UserBufferActivate (); visualizza la schermata d'informazioni,
; quindi, prima formatta un testo con i tasti dello script chiamante e la formula di chiusura,
Let sInfo = FormatString (hlpUltimaInfo, GetCurrentScriptKeyName (), hlpFineInfo);
; poi, la trasmette al Buffer, avviandone la lettura.
RedirectToUserBuffer (sInfo)
EndIf; fine controllo presenza testo
EndScript

Int Function ScriveValore (int iTipo, string sSezione, string sChiave, int iValore, int iAiuto)
Var String sArchivio; il nome dell'archivio in cui scrivere
Let sArchivio = NomeArchivio (iTipo); ricava il nome dell'archivio dall'apposita funzione
; Tenta di scrivere il valore numerico nell'archivio del tipo specificato
If IniWriteInteger (sSezione, sChiave, iValore, sArchivio) Then; se la scrittura riesce,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayFormattedMessage (OT_ERROR, hlpScritturaOk, hlpScritturaOk_corto, sArchivio)
EndIf; fine controllo Aiuto
Return TRUE; in ogni caso, restituisce l'esito positivo
Else; altrimenti, se la scrittura fallisce,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayFormattedMessage (OT_ERROR, hlpNoScrittura, hlpNoScrittura_corto, sArchivio)
EndIf; fine controllo Aiuto
Return FALSE; in ogni caso, restituisce un risultato nullo
EndIf; fine controllo esito
EndFunction

Int Function LeggeValore (int iTipo, string sSezione, string sChiave)
; restituisce il valore numerico memorizzato nell'archivio del tipo indicato
Return IniReadInteger (sSezione, sChiave, FALSE, NomeArchivio (iTipo))
EndFunction

Int Function ScriveDato (int iTipo, string sSezione, string sChiave, string sDato, int iAiuto)
Var String sArchivio; il nome dell'archivio in cui scrivere
Let sArchivio = NomeArchivio (iTipo); ricava il nome dell'archivio dall'apposita funzione
; Tenta di scrivere il dato testuale nell'archivio del tipo indicato
If IniWriteString (sSezione, sChiave, sDato, sArchivio) Then; se la scrittura riesce,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayFormattedMessage (OT_ERROR, hlpScritturaOk, hlpScritturaOk_corto, sArchivio)
EndIf; fine controllo Aiuto
Return TRUE; in ogni caso, restituisce l'esito positivo
Else; altrimenti,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayFormattedMessage (OT_ERROR, hlpNoScrittura, hlpNoScrittura_corto, sArchivio)
EndIf; fine controllo Aiuto
Return FALSE; in ogni caso, restituisce un risultato nullo
EndIf; fine controllo esito
EndFunction

String Function LeggeDato (int iTipo, string sSezione, string sChiave)
; restituisce il dato testuale memorizzato nell'archivio del tipo indicato
Return IniReadString (sSezione, sChiave, NULLO, NomeArchivio (iTipo))
EndFunction

String Function NomeNelTitolo (string sPrima, string sDopo, int iAiuto)
Var
String sAttiva, ; nome dell'applicazione corrente
Int iParte, ; segmento di stringa individuato
String sTitolo, ; titolo da salvare per l'applicativo
Int iPrima, ; punteggiatura trovata nella prima stringa
Int iDopo, ; punteggiatura nella seconda stringa
String sNome; dato da restituire

Let sAttiva = StringLower (GetActiveConfiguration ());fissa l'etichetta per l'applicazione
; se l'etichetta si rileva nella parte iniziale della stringa,
If StringContains (StringLower (sPrima), sAttiva) Then
Let iParte = SECONDA; allora il nome si trova nella seconda parte
; se invece l'etichetta si trova nella seconda parte,
ElIf StringContains (StringLower (sDopo), sAttiva) Then
Let iParte= PRIMA; allora il nome si trova in quella iniziale
Else; se invece l'etichetta dell'applicativo non  stata rilevata,
Let iPrima = StringContains (sPrima, PUNTO); cerca un carattere Punto nella parte iniziale,
Let iDopo = StringContains (sDopo, PUNTO); e lo cerca anche nella parte finale del dato
If iPrima && !iDopo Then; se il punto  presente nella prima parte e non nella seconda,
Let iParte = PRIMA; allora il nome deve trovarsi nella prima parte
ElIf iDopo && !iPrima Then; se invece il punto  nella seconda parte e non nella prima,
Let iParte = SECONDA; allora il nome dovrebbe essere nella seconda parte
EndIf; fine controllo punto nel dato
EndIf; fine controllo etichetta applicativo

If !iParte ; se la parte dove si trova il nome non  stata rilevata,
&& iAiuto Then; ma la fase omonima  stata specificata,
If LeggeDato (CORRENTE, DATI_FILE, AIUTO) == NESSUNO Then; se la fase non  attiva,
SayMessage (OT_ERROR, hlpNoAiuto, hlpNoAiuto_corto); avvisa di tale annullamento,
Return NULLO; e restituisce una stringa vuota
EndIf; fine controllo annullamento Aiuto
Delay (1, TRUE); sospende momentaneamente il flusso e disattiva funzioni di autolettura
; consente di scegliere in quale tra le due parti del titolo sia presente il nome del file
Let iParte = DlgSelectItemInList (FormatString (lstParti, sPrima, sDopo), ttlParti, FALSE)
If iParte == TERZA Then; se si  scelto di annullare l'analisi,
ScriveDato (CORRENTE, DATI_FILE, AIUTO, NESSUNO); annota la scelta,
Return NULLO; e restituisce una stringa vuota
EndIf; fine controllo scelte
EndIf; fine primo controllo rilevazione parte

If !iParte Then; se la porzione dove si trova il nome non  ancora stata individuata,
Return NULLO; restituisce una stringa vuota
EndIf; fine secondo controllo rilevazione parte
If iParte == PRIMA Then; se il nome  stato rilevato nella parte iniziale,
Let sNome = sPrima; ne memorizza il testo per restituirlo,
Let sTitolo = SEPARA_NOME + sDopo; e compone anche il titolo da salvare nell'archivio
ElIf iParte == 2 Then; se invece il nome  stato individuato nella parte finale,
Let sNome = sDopo; ne copia il testo per la restituzione,
Let sTitolo = sPrima + SEPARA_NOME; e compone anche il titolo da archiviare
EndIf; fine controllo parte
; salva il nome dell'applicativo rilevato nel titolo, per semplificare le successive ricerche
ScriveDato (CORRENTE, DATI_FILE, TITOLO, FormatString (msgVirgolette, sTitolo))
Return sNome; e restituisce il dato rilevato
EndFunction

String Function TagliaSpazi (string sTesto)
; restituisce il testo senza gli spazi iniziali, finali e consecutivi
Return StringTrimLeadingBlanks (StringTrimTrailingBlanks (sTesto))
EndFunction

String Function TogliePercorso (string sNome)
If !sNome Then; se il parametro passato  vuoto,
Return NULLO; restituisce una stringa vuota, interrompendo il flusso
EndIf; fine controllo parametro
Var
Int i, ; contatore del ciclo
String sTrova; carattere da cercare

For i = 1 To 3; compie le tre iterazioni del ciclo
If i == 1 Then; se si  al primo passaggio,
Let sTrova = CONTROBARRA; imposta il carattere di separazione per i percorsi Windows
ElIf i == 2 Then; se invece si  al secondo,
Let sTrova = BARRA; imposta il separatore nei percorsi web
Else; altrimenti,
Let sTrova = DUE_PUNTI; imposta il separatore tra il nome ed eventuali dati accessori
EndIf; fine controllo passaggio
If StringContains (sNome, sTrova) Then; se il carattere  stato trovato,
; riduce la stringa al segmento a destra dell'ultima occorrenza del carattere
Let sNome = TagliaSpazi (StringSegment (sNome, sTrova, ULTIMA))
EndIf; fine controllo carattere
EndFor; fine ciclo ricerca
Return TagliaSpazi (sNome); restituisce il dato , eliminando gli spazi in eccesso
EndFunction

Int Function DocumentoCorrente (string ByRef sNomeFile, ; intestazione con un parametro,
string ByRef sEstensione, int iAiuto); e seconda riga con gli altri due
Var
String sDato, ; testo del titolo originale
String sTitolo, ; nome dell'applicativo nel titolo
Int iPosiz, ; posizione di un testo in una stringa
int iLungo, ; lunghezza della stringa
String sPrima, ; porzione di testo che precede il separatore
String sDopo, ; porzione del nome che segue il separatore
String sNome; il solo nome del documento

Let sDato = GetWindowName (GetRealWindow (GetFocus ())); rileva il dato originario
Let sTitolo = LeggeDato (CORRENTE, DATI_FILE, TITOLO); legge l'eventuale titolo salvato
If sTitolo Then; se un nome dell'applicativo  stato gi registrato,
Let iPosiz = StringContains (sDato, sTitolo ); cerca tale titolo nel dato
If iPosiz Then; se il titolo  stato individuato,
Let iLungo = StringLength (sTitolo); rileva la lunghezza del titolo
If iPosiz == 1 Then; se il titolo  stato rilevato ad inizio stringa, ne estrae la parte col nome
Let sNomeFile = TagliaSpazi (SubString (sDato, iLungo + 1, StringLength (sDato) - iLungo))
Else; se invece il nome  stato rilevato nella parte iniziale,
Let sNomeFile = StringLeft (sDato, iPosiz - 1); ne estrae il testo prima
EndIf; fine controllo posizione titolo
EndIf; fine controllo presenza titolo
EndIf; fine controllo registrazione titolo

If !sNomeFile Then; se il nome non  stato ancora individuato,
Let iPosiz = StringContains (sDato, SEPARA_NOME); cerca un separatore nel nome
If iPosiz Then; se tale separatore  stato trovato,
Let sPrima = TagliaSpazi (StringLeft (sDato, iPosiz - 1)); ne estrae la prima parte,
Let iLungo = iPosiz + (StringLength (SEPARA_NOME) - 1); ne segna l'inizio della seconda,
; e la estrae dal dato
Let sDopo = TagliaSpazi (SubString (sDato, iLungo + 1, StringLength (sDato) - iLungo))
; infine, assegna al nome la parte corretta del titolo
Let sNomeFile = NomeNelTitolo (sPrima, sDopo, iAiuto)
Else; se invece il separatore non  stato trovato,
Let sNomeFile = sDato; memorizza il dato nella forma originale
EndIf; fine controllo separatore
EndIf; fine controllo presenza nome del file

If !sNomeFile Then; se non  stato individuato alcun Nome nel titolo,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayFormattedMessage (OT_ERROR, hlpNoDato, hlpNoDato_corto, msgTitolo)
EndIf; fine controllo Aiuto
Return FALSE; in ogni caso, restituisce un valore nullo
EndIf; fine controllo rilevazione del NomeFile
Let sNomeFile = TogliePercorso (sNomeFile); toglie l'eventuale percorso dal dato
Let sNome = PathRemoveExtension (sNomeFile); toglie casomai l'estensione nel NomeFile
If sNome != sNomeFile Then; se i due nomi sono diversi, e quindi esiste una estensione,
; trasmette per riferimento anche l'estensione del nome rilevato
Let sEstensione = StringRight (sNomeFile, StringLength (sNomeFile) - StringLength (sNome))
ElIf StringRight (sNomeFile, 1) == QUADRA_CHIUSA Then; se invece a fine stringa vi  una parentesi quadra,
Let sNome = StringTrimTrailingBlanks (StringSegment (sNomeFile, QUADRA_APERTA, PRIMA))
If PathRemoveExtension (sNome) != sNome Then; se nella stringa  presente un'estensione,
Let sNomeFile = sNome; aggiorna il nome del file completo
Let sNome = PathRemoveExtension (sNomeFile); crea la versione del nome senza estensione,
; trasmette per riferimento l'estensione del nome rilevato
Let sEstensione = StringRight (sNomeFile, StringLength (sNomeFile) - StringLength (sNome))
Else; altrimenti, se un'estensione non c',
Let sEstensione = NULLO; trasmette una stringa vuota
EndIf; fine controllo blocco tra parentesi quadre
Else; altrimenti, se la ricerca di un'estensione ha avuto esito negativo,
Let sEstensione = NULLO; trasmette una stringa vuota
EndIf; fine controllo presenza estensione
Return TRUE; restituisce l'esito positivo
EndFunction

Int Function ControllaSintesi (int iStato, int iAzzera)
If !IsSpeechOff () Then; se la sintesi non  spenta,
If iStato == FALSE Then; se si  impostato un valore nullo,
SpeechOff (iAzzera); spegne la sintesi
EndIf; fine controllo impostazione
Return TRUE; annota di mantenerla accesa, o di riaccenderla, alla successiva chiamata
ElIf iStato == TRUE Then; se invece si  indicata la riattivazione, mentre la sintesi  spenta,
SpeechOn (iAzzera); riattiva la sintesi
EndIf; fine controllo spegnimento
Return FALSE; restituisce un valore nullo
EndFunction

String Function EstraeNumero (string ByRef sTesto, string sOrigine)
Let sTesto = TagliaSpazi (sTesto); rimuove eventuali spazi iniziali e finali
Let sOrigine = TagliaSpazi (sOrigine); li rimuove anche dall'eventuale stringa di origine
If !sOrigine Then; se non  stata indicata una stringa di origine,
If sTesto Then; se per ne  stata indicata una per riferimento,
Let sOrigine = sTesto; la duplica per semplificare il flusso
Else; altrimenti, se nemmeno come primo parametro  stato espresso un testo,
Return NULLO; restituisce una stringa vuota
EndIf; fine controllo primo parametro
EndIf; fine controllo secondo parametro
Var
Int iPartenza, ; lunghezza della stringa indicata
Int iPosiz, ; puntatore di estrazione testo
String sCarattere; singolo carattere testuale

Let iPartenza = StringLength (sOrigine); registra la lunghezza del dato testuale
Let iPosiz = iPartenza; duplica il valore, per far partire il ciclo
While iPosiz; continua finch il contatore rimane positivo
Let sCarattere = SubString (sOrigine, iPosiz, 1); estrae un singolo carattere dal testo
If sCarattere == ZERO ; se il testo corrisponde alla cifra 0 in forma testuale,
|| StringToInt (sCarattere) Then; oppure se tale carattere  un valore numerico,
Let iPosiz = iPosiz - 1; aggiorna il puntatore all'indietro
Else; altrimenti, se il carattere non  un numero,
Let sTesto = StringLeft (sOrigine, iPosiz); trasmette il resto del dato testuale prima della cifra,
Return StringRight (sOrigine, iPartenza - iPosiz); e restituisce come cifra la parte rimanente di stringa
EndIf; fine controllo carattere
EndWhile; fine ciclo scorrimento stringa
Let sTesto = NULLO; a fine scansione, trasmette solo una stringa vuota,
Return sOrigine; perch restituisce tutto il testo originale come cifra
EndFunction

String Function SeparaParole (string ByRef sPrima, ; prima riga dell'intestazione,
string ByRef sSeconda, string ByRef sUltima); e seconda riga, con gli altri due parametri
Var
String sChiamante, ; il nome dello script chiamante
String sParole, ; Parole in maiuscolo presenti nel nome
Int iConta; numero delle parole rilevate

Let sChiamante = GetScriptAssignedTo (GetCurrentScriptKeyName ()); rileva il nome,
Let sParole = StringMixedCaseToMultiword (sChiamante); e ne separa le parole maiuscole
Let iConta = StringSegmentCount (sParole, SPACE); conta il numero di parole rilevate
Let sPrima = StringSegment (sParole, SPACE, PRIMA); preleva la parola iniziale dello script
If iConta == PRIMA Then; se vi  un'unica parola,
; restituisce l'eventuale numero progressivo a destra del termine trasmesso
Return EstraeNumero (sPrima)
Else; altrimenti, se ci sono altre parole,
Let sUltima = StringSegment (sParole, SPACE, ULTIMA); preleva la parola finale
If iConta > SECONDA Then; se sono rilevate pi di due parole,
Let sSeconda = StringSegment (sParole, SPACE, SECONDA); trasmette la seconda parola
EndIf; fine secondo controllo parole
; restituisce l'eventuale numero progressivo a destra del termine trasmesso
Return EstraeNumero (sUltima)
EndIf; fine primo controllo parole
EndFunction

String Function BarraStato ()
Var String sTesto; il contenuto nella Barra di stato
Let sTesto = GetBottomLineOfWindow (); rileva l'ultima riga in basso con la funzione nativa
If sTesto ; se un qualche contenuto  stato rilevato,
&& (StringContains (sTesto, DIVIDE_ZONE) ; e se nel testo vi  o, il carattere separatore,
|| StringContains (sTesto, SPACE)) Then; oppure, almeno un carattere Spazio,
Return sTesto; restituisce il contenuto rilevato
Else; altrimenti,
Return NULLO; restituisce una stringa vuota
EndIf; fine controllo contenuto
EndFunction

Int Function ControllaSeparatore (string sTesto, string ByRef sDivide)
Var Int iScrivi; valore che attiva la scrittura dei dati

; tenta di leggere un dato dall'archivio dell'applicazione attiva
Let sDivide = LeggeDato (CORRENTE, BARRA_STATO, SEPARATORE)
If !sDivide Then; se nessun separatore delle voci  stato rilevato,
Let sDivide = DIVIDE_ZONE; imposta il carattere di separazione standard
Let iScrivi = TRUE; imposta il valore per la trascrizione
EndIf; fine controllo presenza separatore
If sDivide != NESSUNO ; se il separatore non  quello nullo,
&& StringContains (sTesto, sDivide) Then; e se nella Barra di stato vi  un separatore,
If iScrivi Then; se la trascrizione del dato  stata attivata,
ScriveDato (CORRENTE, BARRA_STATO, SEPARATORE, sDivide); trascrive il separatore,
CancellaChiave (CORRENTE, BARRA_STATO, TESTO); e rimuove un'eventuale trascrizione lineare
EndIf; fine controllo scrittura
Return TRUE; restituisce l'esito positivo
Else; altrimenti, se il carattere non  stato trovato,
Let sDivide = NULLO; resetta il dato,
Return FALSE; e restituisce un risultato nullo
EndIf; fine controllo presenza separatore
EndFunction

Void Function AssegnaEsadecimali (int ByRef iOpzioni, int ByRef iDettagli)
If iOpzioni == OK Then; se  stato impostato il primo tipo di finestra di dialogo,
Let iOpzioni = MB_OK; lo aggiorna con il relativo valore esadecimale,
Let iDettagli = MB_ICONHAND; e l'abbinato valore per icona e suoni
ElIf !iOpzioni || iOpzioni == OK_ANNULLA Then; se non  stato specificato nulla, oppure il secondo tipo,
Let iOpzioni = MB_OKCANCEL; aggiorna il valore con il relativo esadecimale
Let iDettagli = MB_ICONQUESTION; e l'abbinato valore per icona e suoni
ElIf iOpzioni == INTERROMPI_RIPROVA_IGNORA Then; se  stato impostato il terzo tipo,
Let iOpzioni = MB_ABORTRETRYIGNORE; aggiorna il valore con il relativo esadecimale
Let iDettagli = MB_ICONASTERISK; e l'abbinato valore per icona e suoni
ElIf iOpzioni == SI_NO_ANNULLA Then; se  stato impostato il quarto tipo,
Let iOpzioni = MB_YESNOCANCEL; aggiorna il valore con il relativo esadecimale,
Let iDettagli = MB_ICONQUESTION; e l'abbinato valore per icona e suoni
ElIf iOpzioni == SI_NO Then; se  stato impostato il quinto tipo,
Let iOpzioni = MB_YESNO; aggiorna il valore con il relativo esadecimale,
Let iDettagli = MB_ICONQUESTION; e l'abbinato valore per icona e suoni
ElIf iOpzioni == RIPROVA_ANNULLA Then; se  stato impostato il sesto tipo,
Let iOpzioni = MB_RETRYCANCEL; aggiorna il valore con il relativo esadecimale
Let iDettagli = MB_ICONASTERISK; e l'abbinato valore per icona e suoni
EndIf; fine controllo tipo
EndFunction

Int Function ChiedeConferma (string sTitolo, string sMessaggio, ; intestazione con due parametri,
int iOpzioni, int iTasto, int iNoSuoni); seconda riga con gli altri tre
Var
Int iStato, ; attivazione della sintesi vocale
String sBufferTitolo, ; eventuale precedente contenuto del titolo predefinito
String sBufferEtichette, ; eventuale precedente contenuto delle etichette dei pulsanti
int iDettagli, ; valore esadecimale per icona e suoni
Int iScelta; valore della scelta effettuata

Let iStato = ControllaSintesi (TRUE, TRUE); riattiva la sintesi, annotandone lo stato d'attivazione
If !sTitolo ; se nessun titolo  stato specificato,
&& !sMessaggio Then; e se non lo  stato neppure un messaggio,
Let sTitolo = msgConfermaUscita; imposta un messaggio come titolo
EndIf; fine controllo titolo e messaggio
; memorizza gli eventuali contenuti di titolo ed etichette della finestra di dialogo
ScambiaTitoli (FormatString (msg2Spazi, sTitolo, sMessaggio), sBufferTitolo, sBufferEtichette)
AssegnaEsadecimali (iOpzioni, iDettagli); imposta i valori tramite l'apposita funzione
If !iTasto || iTasto == PRIMA Then; se non  stato indicato nulla, oppure il primo valore,
Let iTasto = MB_DEFBUTTON1; aggiorna come predefinito il primo pulsante nella linea dei tasti Tab
ElIf iTasto == SECONDA Then; se invece  stato indicato il secondo valore,
Let iTasto = MB_DEFBUTTON2; aggiorna come predefinito il secondo pulsante
ElIf iTasto == TERZA Then; se invece  stato indicato il terzo valore,
Let iTasto = MB_DEFBUTTON3; aggiorna come predefinito il terzo pulsante
Else; altrimenti,
Let iTasto = MB_DEFBUTTON4; aggiorna come predefinito il quarto pulsante
EndIf; fine controllo tasto predefinito
If !iNoSuoni Then; se non  stata indicata la cancellazione dei suoni,
Let iScelta = ExMessageBox (sMessaggio, sTitolo, iOpzioni|iTasto|iDettagli); propone la classica conferma
Else; altrimenti,
Let iScelta = ExMessageBox (sMessaggio, sTitolo, iOpzioni|iTasto); la propone senza icona e suoni
EndIf; fine controllo sintassi
ControllaSintesi (iStato, TRUE); ripristina, o lascia invariato, il precedente stato di attivazione della sintesi
ScambiaTitoli (NULLO, sBufferTitolo, sBufferEtichette); ripristina le variabili globali
If iScelta == IDNO Then; se si  premuto il tasto No,
Return -1; restituisce un risultato negativo
ElIf iScelta == IDCANCEL Then; se invece si  premuto Escape o Annulla,
Return FALSE; restituisce un risultato nullo
Else; altrimenti,
Return iScelta; restituisce la scelta operata
EndIf; fine controllo scelta
EndFunction

Int Function DatiStato (string sNome, string sDivide, ; intestazione con due parametri,
string ByRef sInfo, int ByRef iPosiz, int iAiuto); seconda riga con gli altri tre
Var
String sElenco, ; chiavi dei dati registrati
String sChiave, ; singola chiave del dato
Int i, ; contatore del ciclo
Int iValidi; numero dei dati da considerare

; tenta di leggere le informazioni sul dato da estrarre, trasmettendole casomai per riferimento
Let sInfo = StringLower (LeggeDato (CORRENTE, BARRA_STATO, sNome))
If sInfo Then; se delle voci sono state rilevate,
Let iPosiz = StringToInt (StringSegment (sInfo, PIPE, PRIMA)); ne trasmette la posizione,
Return TRUE; e restituisce l'esito positivo
Else; altrimenti, se non  registrata alcuna informazione sul dato richiesto,
If !iAiuto Then; se la fase omonima non  attiva,
Return FALSE; interrompe il flusso, restituendo un risultato nullo
EndIf; fine controllo Aiuto
CancellaChiave (CORRENTE, BARRA_STATO, sNome); rimuove l'eventuale chiave
Let sElenco = LeggeChiavi (CORRENTE, BARRA_STATO); rileva le chiavi dei dati registrati
For i = 1 To StringSegmentCount (sElenco, PIPE); scorre i dati rilevati
Let sChiave = StringSegment (sElenco, PIPE, i); estrae una singola chiave dall'elenco
If !StringStartsWith (sChiave, TESTO) ; se il dato non corrisponde ad una delle zone
&& sChiave != SEPARATORE Then; e nemmeno al carattere separatore delle zone,
Let iValidi = iValidi + 1; aggiorna il contatore dei dati da considerare
EndIf; fine controllo dati
EndFor; fine ciclo scansione dati
If sDivide == DIVIDE_ZONE Then; se il separatore  quello standard,
; trasmette la posizione aggiungendo il numero base a quello rilevato
Let iPosiz = iValidi + BASE_ZONE
Else; altrimenti,
Let iPosiz = iValidi + 1; la trasmette aggiungendovi solo un'unit
EndIf; fine controllo separatore
Let sInfo = IntToString (iPosiz); trasmette per riferimento la sola posizione del dato,
ScriveDato (CORRENTE, BARRA_STATO, sNome, sInfo); trascrive i dati rilevati,
Return TRUE; e restituisce l'esito positivo
EndIf; fine controllo presenza voci
EndFunction

String Function InfoStato (string sNome, int iAiuto)
Var;
String sTesto, ; contenuto della Barra di stato
String sDivide, ; carattere di separazione delle voci nella Barra di stato
Int i, ; contatore del ciclo
String sInfo, ; informazioni registrate
Int iPosiz, ; numero del segmento da estrarre
String sDato, ; stringa da estrarre
Int iTotali, ; numero complessivo delle voci da analizzare
Int iVoci , ; contatore delle voci analizzate
String sVoce, ; singola informazione registrata
Int iFase; contatore delle fasi di analisi delle voci

Let sTesto = BarraStato (); rileva la riga di stato tramite l'apposita funzione
If !sTesto Then; se nessun testo  stato rilevato,
If iAiuto Then; se  attiva la fase ,
SayFormattedMessage (OT_ERROR, hlpAttivaBarra, hlpAttivaBarra_corto); legge l'avviso
EndIf; fine controllo aiuto
Return NULLO; in ogni caso, restituisce una stringa vuota
EndIf; fine controllo testo
If !ControllaSeparatore (sTesto, sDivide) Then; se nessun carattere separatore  valido,
If iAiuto Then; se  attiva la fase,
If ChiedeConferma (ttlNoSepara, FormatString (msgImmissione, _O)) Then; se lo si vuole inserire,
Let sDivide = DIVIDE_ZONE; preimposta il carattere predefinito per l'inserimento
If InputBox (msgInserisciRiga, ttlSeparatore, sDivide); Then; se il dato  stato immesso,
ScriveDato (CORRENTE, BARRA_STATO, SEPARATORE, sDivide); trascrive il separatore,
CancellaChiave (CORRENTE, BARRA_STATO, TESTO); e rimuove un'eventuale trascrizione lineare
EndIf; fine controllo inserimento
EndIf; fine controllo conferma
If !sDivide Then; se non vi  alcun separatore,
; trascrive nel file di configurazione Personale:
ScriveDato (CORRENTE, BARRA_STATO, TESTO, sTesto); il testo rilevato,
ScriveDato (CORRENTE, BARRA_STATO, SEPARATORE, NESSUNO); l'assenza del separatore,
Return NULLO; e restituisce una stringa vuota
EndIf; fine controllo presenza dato
EndIf; fine controllo aiuto
EndIf; fine controllo separatore
For i = 1 To StringSegmentCount (sTesto, sDivide); scorre le porzioni del testo separate dal carattere individuato
Let sDato = TagliaSpazi (StringSegment (sTesto, sDivide, i)); estrae la singola zona,
ScriveDato (CORRENTE,BARRA_STATO, FormatString (msg2, TESTO, i), sDato); e la trascrive
EndFor; fine scansione segmenti
If !DatiStato (sNome, sDivide, sInfo, iPosiz, iAiuto) Then; se i dati non sono stati rilevati,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayMessage (OT_ERROR, hlpNoAutoDati, hlpNoAutoDati_corto)
EndIf; fine controllo aiuto
Return NULLO; in ogni caso, interrompe il flusso restituendo una stringa vuota
EndIf; fine controllo informazioni sul dato
; rileva il segmento relativo al dato richiesto, rendendolo minuscolo e togliendo spazi inutili
Let sDato = StringLower (TagliaSpazi (StringSegment (sTesto, sDivide, iPosiz)))
If !sDato Then; se non  stata rilevata alcuna stringa relativa al tipo di dato,
If iAiuto Then; se  attiva la fase, legge l'avviso
SayMessage (OT_ERROR, hlpInfoErrate, hlpInfoErrate_corto)
EndIf; fine controllo Aiuto
Return NULLO; in ogni caso, interrompe il flusso restituendo una stringa vuota
EndIf; fine controllo rilevamento zona
Let iTotali = StringSegmentCount (sInfo, PIPE); conta il numero delle voci per estrarre il dato
If iTotali < CICLO_VOCI Then; se il numero di analisi  inferiore al minimo,
Let iTotali = CICLO_VOCI; aggiorna il valore
EndIf; fine controllo voci rilevate
Let iFase = SECONDA; predispone la fase di analisi delle voci per partire dalla terza
Let iVoci = PRIMA; e il contatore delle voci per iniziare dalla seconda
While iFase || iVoci < iTotali; continua se una fase  impostata e ci sono voci da elaborare
Let iVoci = iVoci + 1; aggiorna il contatore
Let sVoce = StringSegment (sInfo, PIPE, iVoci); estrae la singola voce
Let iFase = iFase + 1; aggiorna il contatore della fase di estrazione
If iFase == PRIMA Then; se la voce  relativa al separatore,
If sVoce Then; se la stringa non  vuota,
Let sDivide = sVoce; imposta il separatore della zona del dato
Else; altrimenti,
Let sDivide = SPACE; imposta il carattere Spazio
EndIf; fine controllo voce
ElIf iFase == SECONDA Then; se invece si estrae il valore numerico,
Let iPosiz = StringToInt (sVoce); converte e salva la posizione del dato nel segmento estratto
If !iPosiz Then; se nessun valore  stato rilevato,
Let iPosiz = PRIMA; imposta la parte del dato da estrarre
EndIf; fine controllo posizione
; estrae il sottodato, rimuovendo gli spazi in eccesso
Let sDato = TagliaSpazi (StringSegment (sDato, sDivide, iPosiz))
ElIf iFase == TERZA Then; se infine si tratta di una stringa da rimuovere,
If sVoce Then; se tale stringa non  vuota,
; rimuove la parte di dato non necessaria, eliminando anche gli spazi in eccesso
Let sDato = TagliaSpazi (StringReplaceSubstrings (sDato, sVoce, NULLO))
EndIf; fine controllo rimozione stringa
Let iFase = FALSE; e azzera il valore per poter iniziare da capo
EndIf; fine controllo fasi
EndWhile; fine scansione voci
Return sDato; restituisce il testo estratto
EndFunction

String Function NoZero (int iValore)
If iValore Then; se un valore  stato specificato,
Return IntToString (iValore); lo restituisce in forma testuale
Else; altrimenti,
Return NULLO; restituisce una stringa vuota
EndIf; fine controllo valore
EndFunction

Void Function PronunciaDato (string sTitolo, string sDato, int iAiuto)
If sDato Then; se una posizione  stata rilevata,
SayMessage (OT_ERROR, sTitolo, CR); legge il termine solo in caso di messaggi lunghi
SayFormattedMessage (OT_HELP, msg1, NULLO, sDato); legge comunque il dato
ElIf iAiuto Then; se invece non vi  alcun dato, e si  nell'omonima fase,
SayFormattedMessage (OT_ERROR, hlpNoDato, hlpNoDato_corto, sTitolo); legge un avviso
EndIf; fine controllo dato
EndFunction

Void Function GestisceDato (string sAzione, string sOggetto)
If !SiamoNellaFinestra (EDITING) Then; se non si  nella finestra corretta,
If !(sAzione + sOggetto) Then; se non sono stati specificati dei parametri,
TypeCurrentScriptKey (); ripete i tasti premuti,
EndIf; fine controllo parametri
Return; interrompe il flusso
EndIf; fine controllo finestra
Var
Int iAiuto, ; stato di attivazione della fase Aiuto
Int iNoVoce, ; imposta la disattivazione della fase Aiuto
String sProg, ; eventuale numero progressivo indicato tramite il nome dello script
String sCategoria, ; tipologia dell'azione da compiere
String sDato, ; dato testuale da sottoporre all'azione
String sNomeFile, ; nome completo del documento aperto
String sSuffisso; dato suppletivo da passare come parametro

Let iAiuto = IsSameScript (); rileva l'eventuale doppia pressione dei tasti di attivazione
If !sAzione Then; se l'azione da compiere non  stata specificata come parametro,
Let sProg = SeparaParole (sAzione, sCategoria, sOggetto); estrae i dati dal nome script
Else; altrimenti
Let iNoVoce = SALTA; imposta la successiva disattivazione della fase Aiuto
EndIf; fine controllo parametro
If sAzione == PRONUNCIA Then; se si sono chieste azioni di lettura,
If sCategoria == STATO Then; se si sono richiesti dati dalla barra di stato,
Let sDato = InfoStato (sOggetto, iAiuto); rileva il dato dalla funzione generica
Else; altrimenti, in tutti gli altri casi,
; Rileva il dato dalla funzione di cui si compone il nome
Let sDato = NoZero (CallFunctionByName (sCategoria + sOggetto))
EndIf; fine controllo categoria
CallFunctionByName (sAzione + DATO, sOggetto, sDato, iAiuto); esegue l'azione
ElIf sAzione == CERCA Then; se invece si sono chieste delle ricerche,
CercaDato (sCategoria, sOggetto, iAiuto); esegue l'azione
Else; se invece servono operazioni su documenti,
If !DocumentoCorrente (sNomeFile, sSuffisso) Then; se non vi sono dati sul file aperto,
If iAiuto Then; se  attiva la fase Aiuto,
SayFormattedMessage (OT_ERROR, hlpNoDato, hlpNoDato_corto, msgTitolo); legge l'avviso
EndIf; fine controllo aiuto
Return; in ogni caso, interrompe il flusso
EndIf; fine controllo documento
If sAzione == SALVA; se si vuole il salvataggio di un contrassegno,
|| sAzione == TORNA ; o si vuole ritornarvi,
|| sAzione == ESEGUE Then; o, infine, se si vuole attivare uno script a gestione personale,
If !iNoVoce Then; se l'impostazione non  disattivata,
Let iAiuto = TRUE; imposta la fase
EndIf; fine controllo disattivazione
CallFunctionByName (sAzione + DATO, sNomeFile, sOggetto, sProg, iAiuto); esegue l'azione
Else; altrimenti, in tutti i casi in cui  necessario un suffisso,
If sCategoria == SCRIPTS Then; se si stanno elaborando gli script a gestione personale,
Let sSuffisso = sNomeFile; passa il nome del file parametro al posto dell'estensione
ElIf !sSuffisso Then; se un suffisso non  stato rilevato,
If iAiuto Then; se  attiva la fase,
SayMessage (OT_ERROR, hlpNoEst, hlpNoEst_corto); legge l'avviso
EndIf; fine controllo aiuto
Return; in ogni caso, interrompe il flusso
EndIf; fine controllo suffisso
; rende globali i dati rilevati
Let gsCategoria = sCategoria
Let gsOggetto = sOggetto
If sAzione == MUOVE ; se si  chiesto di muoversi ad un elemento,
|| sAzione == METTE Then; oppure, di inserire del testo nel documento corrente,
CallFunctionByName (sAzione + DATO, sSuffisso, sProg, iAiuto); esegue l'azione
ElIf sAzione == ELABORA Then; se invece si  chiesto di avviare una procedura guidata,
If gsCategoria == ELEMENTO Then; se si stanno configurando gli elementi di ricerca,
Let gsOggetto = NULLO; resetta il dato
EndIf; fine controllo oggetto
CallFunctionByName (sAzione + DATO, sSuffisso, iAiuto); esegue l'azione
Else; se invece l'azione non  stata riconosciuta,
If iAiuto Then; se la fase  attiva,
SayFormattedMessage (OT_ERROR, hlpNoAzione, hlpNoAzione_corto, sAzione); legge l'avviso
EndIf; fine controllo Aiuto
EndIf; fine controllo azioni con suffisso
EndIf; fine controllo azioni su documenti
EndIf; fine controllo generale azioni
EndFunction

Int Function ValoreRiga ()
Return GetCursorRow (); restituisce il dato della funzione nativa
EndFunction

Int Function ValoreColonna ()
Return GetCursorCol (); restituisce il valore della funzione nativa
EndFunction

Int Function ValoreLunghezza ()
If SiamoNellaFinestra (MANAGER) Then; se ci si trova nella finestra dell'Editor di Script,
; restituisce il valore numerico, convertito dal risultato dell'apposita funzione
Return StringToInt (InfoStato (LUNGHEZZA, IsSameScript ()))
ElIf SiamoNellaFinestra (RIGHE) Then; se invece si  in un applicativo gestito a righe,
Return GetLineCount (); restituisce il valore rilevato dalla funzione nativa per le righe
ElIf SiamoNellaFinestra (POSIZIONE) Then; se infine si basa sulla posizione assoluta,
Return GetCurrentDocumentLength (); restituisce la posizione tramite la funzione nativa
Else; altrimenti, nelle altre finestre,
If IsSameScript () Then; se  stata attivata la fase Aiuto,
SayMessage (OT_ERROR, hlpNoFinestra, hlpNoFinestra_corto); legge l'avviso
EndIf; fine controllo Aiuto
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo finestre
EndFunction

Script PronunciaValoreRiga ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script PronunciaValoreColonna ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script PronunciaValoreLunghezza ()
GestisceDato (); chiama l'apposita funzione
EndScript

Int Function NumeroVersione ()
; restituisce il valore corrispondente alle prime due cifre della versione di Jaws
Return StringToInt (StringLeft (IntToString (GetJFWVersion ()), 2))
EndFunction

Int Function PosizioneCursore ()
Return GetCursorRow (); restituisce il valore dalla funzione nativa
EndFunction

Int Function ScrivePuntatore (string sNomeFile, string sProg, int iValore)
Return ScriveDato (; restituisce l'esito della scrittura di puntatore o contrassegni numerati
SEGNI, ; valore che identifica l'archivio in cui scrivere
CTS + sNomeFile, ; sezione dell'archivio
CHIAVE_SEGNI + sProg, ; chiave del dato
IntToString (iValore)); dato da scrivere, convertito in forma testuale
EndFunction

Int Function LeggeSegni (string sNomeFile, string sProg, string sOggetto)
Var String sPrefisso; termine da premettere nella sezione
If sProg ; se  stato specificato un numero progressivo,
&& sOggetto == CONTRASSEGNO Then; e se si vuole un contrassegno numerato o l'ultimo,
If sProg == ZERO Then; se  stata indicata la cifra del valore 0,
Let sProg = NULLO; cancella il dato
EndIf; fine controllo cifra progressiva
Let sPrefisso = CTS; inserisce comunque un prefisso per il nome della sezione in cui scrivere
EndIf; fine controllo preliminare
Return LeggeValore (SEGNI, sPrefisso + sNomeFile, CHIAVE_SEGNI + sProg); legge il dato
EndFunction

Int Function PuntatoreSegni (string sNomeFile, int iValore)
If iValore >= FALSE Then; se un valore non  negativo,
; reimposta il puntatore dei contrassegni e ne restituisce l'esito
Return ScrivePuntatore (sNomeFile, NULLO, iValore)
Else; altrimenti,
Return LeggeSegni (sNomeFile, ZERO, CONTRASSEGNO); ritorna il valore del puntatore
EndIf; fine controllo valore
EndFunction

Int Function AggiornaSegni (string sNomeFile, int iValore, string sProg)
Var
int i, ; il contatore del ciclo
String sChiavi, ; l'elenco delle chiavi dei contrassegni registrati
Int iContrassegni, ; il numero dei contrassegni
Int iPrima; il valore del contrassegno precedente

If sProg Then; se un numero progressivo  stato specificato,
; restituisce l'esito della scrittura nell'apposita sezione, interrompendo il flusso
Return ScrivePuntatore (sNomeFile, sProg, iValore)
EndIf; fine controllo numero progressivo
Let sChiavi = LeggeChiavi (SEGNI, sNomeFile); rileva le chiavi dei contrassegni registrati
Let iContrassegni = StringSegmentCount (sChiavi, PIPE); conta i contrassegni rilevati
If iContrassegni Then; se vi  almeno un dato registrato,
For i = iContrassegni To 1 Descending; fa scalare le precedenti registrazioni
If i <= MAX_SEGNI Then; se il contatore  inferiore o uguale al loro numero massimo,
; rileva il dato del contrassegno precedente,
Let iPrima = LeggeValore (SEGNI, sNomeFile, CHIAVE_SEGNI + NoZero (i - 1))
; e sovrascrive, o crea, un contrassegno con il valore appena rilevato
ScriveValore (SEGNI, sNomeFile, CHIAVE_SEGNI + NoZero (i), iPrima)
EndIf; fine controllo numero massimo
EndFor; fine ciclo di sovrascrittura
EndIf; fine controllo numero contrassegni
If ScriveValore (SEGNI, sNomeFile, CHIAVE_SEGNI, iValore) Then; se la scrittura riesce,
Return PuntatoreSegni (sNomeFile, FALSE); inizializza il puntatore dei contrassegni
Else; altrimenti,
Return FALSE; restituisce un valore nullo
EndIf; fine controllo scrittura
EndFunction

Int Function SalvaDato (string sNomeFile, string sOggetto, String sProg, int iAiuto)
Var
Int iValore; posizione da registrare

If NumeroVersione () >= NUOVE Then; se quella in uso  una versione di Jaws dalla 2018,
SpeechOff (); spegne la sintesi
PerformScript DefineATempPlaceMarker(); esegue lo script nativo
SpeechOn (); riattiva la sintesi
Else; Altrimenti, per le versioni precedenti,
SaveCurrentLocation (); registra la posizione per i puntatori interni di Jaws
EndIf; fine controllo versione
If sOggetto == ESCE Then; se si  usciti dall'applicazione,
DeleteFile (NomeArchivio (TEMPORANEO)); si cancella l'intero file con le aperture
ElIf sOggetto == CHIUDE Then; se invece si  chiuso solo il documento corrente,
CancellaChiave (TEMPORANEO, APERTURA, sNomeFile); rimuove solo la nota sul file
EndIf; fine controllo tipo di azione
Let iValore = PosizioneCursore (); rileva il dato da registrare
If !iValore Then; se il valore  nullo,
Return FALSE; interrompe il flusso, restituendo un risultato nullo
EndIf; fine controllo valore
; se il nuovo contrassegno  uguale all'ultimo registrato,
If iValore == LeggeSegni (sNomeFile, sProg, sOggetto) Then
If iAiuto Then; se  attiva la fase,
SayMessage (OT_ERROR, hlpGiaSegno, hlpGiaSegno_corto); legge l'avviso
EndIf; fine controllo aiuto
Return FALSE; interrompe il flusso, restituendo un risultato nullo
ElIf AggiornaSegni (sNomeFile, iValore, sProg) Then; se invece la registrazione riesce,
If iAiuto Then; se  attiva la fase, avvisa dell'esito
SayFormattedMessage (OT_ERROR, hlpOkSegno, hlpOkSegno_corto, sProg)
EndIf; fine controllo Aiuto
Return TRUE; in ogni caso, restituisce l'esito positivo
Else; Altrimenti, se la scrittura fallisce,
If iAiuto Then; se  attiva la fase, segnala l'errore
SayFormattedMessage (OT_ERROR, hlpNoCts, hlpNoCts_corto, sProg)
EndIf; fine controllo Aiuto
Return FALSE; in ogni caso, restituisce un risultato nullo
EndIf; fine controllo scrittura
EndFunction

Int Function ScorreSegni (string sNomeFile, string sOggetto, ; prima riga d'intestazione,
string sChiavi, int iConta, string ByRef sProg); seconda riga, con gli altri tre parametri
Var
Int iAttuale, ; valore del puntatore dei contrassegni
Int iPosiz; posizione del contrassegno nell'archivio

Let iAttuale = PuntatoreSegni (sNomeFile, -1); rileva l'attuale puntatore dei contrassegni
If sOggetto == PRIMO Then; se si  chiesto il contrassegno pi vecchio,
Let iPosiz = iConta; imposta il valore relativo
ElIf sOggetto == ULTIMO Then; se invece si  richiesto l'ultimo registrato,
Let iPosiz = FALSE; azzera il valore
ElIf sOggetto == PRECEDENTE Then; se si  chiesto il contrassegno prima,
Let iPosiz = iAttuale + 1; aumenta il valore
ElIf sOggetto == SUCCESSIVO Then; se infine si  chiesto il contrassegno dopo,
Let iPosiz = iAttuale - 1; diminuisce il valore
EndIf; fine controllo tipo azione
If iPosiz == iAttuale ; se il contrassegno chiesto  quello gi sul puntatore,
|| iPosiz > iConta ; o se quello chiesto  oltre il primo registrato,
|| iPosiz < FALSE Then; oppure se il valore  inferiore a zero,
Suona (ERRORE1); emette un suono di avviso,
Return FALSE; e restituisce un risultato nullo
Else; se invece la posizione  valida,
Let sProg = NoZero (iPosiz); aggiorna il valore da trasmettere
PuntatoreSegni (sNomeFile, iPosiz); aggiorna anche il contatore
If iPosiz == FALSE Then; se si  sul contrassegno pi recente,
Suona (ULTIMO_SEGNO); emette il suono relativo
ElIf iPosiz == iConta Then; se invece si  sul contrassegno meno recente,
Suona (PRIMO_SEGNO); emette il suono relativo
Else; altrimenti
Suona (Nota (iPosiz)); emette la nota corrispondente
EndIf; fine controllo suoni
Return TRUE; consente di proseguire il flusso nella funzione chiamante
EndIf; fine controllo valore
EndFunction

Int Function MuoveAllaRiga (int iValore)
Var Int iStato; indica lo stato di attivazione della sintesi
Let iStato = ControllaSintesi (FALSE); verifica se la sintesi  spenta, salvandone l'esito
TypeKey (CONTROL_G); richiama il comando di spostamento alla riga
Pause ()
TypeString (IntToString (iValore)); immette la riga a cui portarsi
EnterKey ()
Pause ()
ControllaSintesi (iStato); verifica se riattivare la sintesi
EndFunction

Void Function SpostaCursore (int iPosiz, string sProg, int iAiuto)
If SiamoNellaFinestra (RIGHE) Then; se l'applicativo corrente funziona a righe,
MuoveAllaRiga (iPosiz); effettua lo spostamento con il comando dell'applicativo
If iAiuto Then; se  attiva la fase,
SayFormattedMessage (OT_ERROR, msgTornaA, msgSecondo, RIGA, iPosiz)
EndIf; fine controllo Aiuto
ElIf SiamoNellaFinestra (POSIZIONE) Then; se invece conta la posizione assoluta,
MoveToDocumentOffset (iPosiz ); si sposta alla posizione memorizzata
If iAiuto Then; se  attiva la fase,
If !sProg Then; se non  indicato alcun numero, avvisa di portarsi all'ultimo contrassegno
SayFormattedMessage (OT_ERROR, msg2, msg1, ULTIMO, CONTRASSEGNO)
Else; altrimenti, se un valore  stato rilevato, avvisa di portarsi al contrassegno numerato
SayFormattedMessage (OT_ERROR, msg2, msgSecondo, CONTRASSEGNO, sProg)
EndIf; fine controllo tipo contrassegno
EndIf; fine controllo messaggi
Else; se la finestra non  stata riconosciuta,
SayMessage (OT_ERROR, hlpNoRegistra, hlpNoRegistra_corto); legge l'avviso
EndIf; fine controllo finestre
EndFunction

Int Function TornaDato (string sNomeFile, string sOggetto, String sProg, int iAiuto)
Var
Int iPosiz, ; posizione del cursore
Int iTotale, ; lunghezza del file aperto
Int iAperto, ; indicatore di una nuova apertura
String sChiavi, ; elenco dei contrassegni registrati
Int iConta; numero dei contrassegni rilevati

If sOggetto == APERTURA Then; se si deve verificare l'apertura del documento,
If LeggeDato(TEMPORANEO, APERTURA, sNomeFile) Then; se il file  gi aperto,
Return FALSE; interrompe il flusso, restituendo un risultato nullo
Else; altrimenti, se si  al primo ingresso nel documento, ne annota l'apertura
Let iAperto = ScriveDato (TEMPORANEO, APERTURA, sNomeFile, ZERO)
EndIf; fine controllo apertura
ElIf sOggetto != CONTRASSEGNO Then; se invece non si  chiesto l'ultimo contrassegno,
Let sChiavi = LeggeChiavi (SEGNI, sNomeFile); rileva i contrassegni
Let iConta = StringSegmentCount (sChiavi, PIPE) - 1; conta i contrassegni, meno un'unit
If iConta Then; se vi sono almeno due contrassegni registrati, lo 0 e l'1,
If !ScorreSegni (sNomeFile, sOggetto, sChiavi, iConta, sProg) Then; se non  valido,
Return; interrompe il flusso
Else; altrimenti, se il flusso pu proseguire,
Let iAiuto = FALSE; disattiva l'omonima fase
EndIf; fine controllo scorrimento
EndIf; fine controllo numero contrassegni
EndIf; fine controllo oggetto
Let iPosiz = LeggeSegni (sNomeFile, sProg, sOggetto); rileva il valore del contrassegno
If !iPosiz Then; se nessun valore  stato rilevato,
If iAiuto Then; se  attiva la fase, segnala l'errore
SayFormattedMessage (OT_ERROR, hlpNoSegno, hlpNoSegno_corto, sProg)
EndIf; fine controllo Aiuto
Return; in ogni caso, interrompe il flusso
EndIf; fine controllo valore
If sOggetto == CONTRASSEGNO Then; se si  chiesto l'ultimo contrassegno registrato,
PuntatoreSegni (sNomeFile, FALSE); resetta il puntatore dei contrassegni
EndIf; fine controllo tipo ritorno
If !iAperto ; se non si  appena rientrati nel file,
&& iPosiz == PosizioneCursore () Then; e se il cursore  gi sul contrassegno,
If iAiuto Then; se  attiva la fase,
SayMessage (OT_ERROR, hlpSulPosto, hlpSulPosto_corto); legge l'avviso
EndIf; fine controllo aiuto
Return; in ogni caso, interrompe il flusso
EndIf; fine controllo contrassegno
Let iTotale = ValoreLunghezza (); tenta di rilevare la lunghezza del documento aperto
If !iTotale ; se la lunghezza totale non  stata rilevata,
|| (iTotale && iPosiz <= iTotale) Then; oppure se il valore c', ma non inferiore all'esistente,
SpostaCursore (iPosiz, sProg, iAiuto); esegue lo spostamento del cursore nel documento
Refresh (); resetta la schermata
SayLine (); legge la riga corrente
Else; se invece il numero memorizzato  superiore alla lunghezza complessiva,
If iTotale > 1 Then; se vi sono pi di una riga nel file,
JAWSBottomOfFile (); si porta alla fine del documento
EndIf; fine controllo lunghezza
If iAiuto Then; se  attiva la fase,
SayMessage (OT_ERROR, hlpFineFile, hlpFineFile_corto); legge l'avviso
EndIf; fine controllo Aiuto
EndIf; fine controllo lunghezza documento
EndFunction

Script TornaContrassegno ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script TornaPrimo ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script TornaUltimo ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script TornaPrecedente ()
GestisceDato (); chiama l'apposita funzione
EndScript

Script TornaSuccessivo ()
GestisceDato (); chiama l'apposita funzione
EndScript

Void Function ComandoTrova ()
TypeKey (CONTROL_F); apre la finestra di dialogo per la ricerca
EndFunction

Script MetteMacroTesto3 ()
MetteTesto (MARK_PLACE, TRUE); inserisce la riga di codice, andando poi a capo
EndScript

Script MetteMacroTesto4 ()
MetteTesto (FOCUS_CHANGED, TRUE); inserisce la riga di codice, andando poi a capo
EndScript

Script EsceProgramma ()
GestisceDato (SALVA, ESCE) ; esegue il salvataggio, annotando l'uscita dal documento
PronunciaEsegue (ALT_F4, TRUE); forza l'invio dei tasti specificati, leggendo lo script attivo
EndScript

Script ChiudeFinestra ()
GestisceDato (SALVA, CHIUDE) ; salva la posizione simulando la chiusura del documento
PronunciaEsegue (); ripete i tasti premuti, leggendo il nome dello script
EndScript

Void Function VaiEstremi (string sOggetto)
If sOggetto == PRIMO Then; se si  chiesta la prima occorrenza,
JAWSTopOfFile (); si porta all'inizio del documento
ElIf sOggetto == ULTIMO Then; se invece si  chiesta l'ultima occorrenza,
JAWSBottomOfFile (); si porta alla fine del documento
EndIf; fine controllo spostamento
Pause ()
EndFunction

Int Function EsegueRicerca (string ByRef sTesto, string sOggetto)
Var
Int iStato, ; indica lo stato di attivazione della sintesi
Int iErrore; esito della ricerca

Let iStato = ControllaSintesi (); verifica se spegnere la sintesi vocale, salvandone l'esito
ComandoTrova (); attiva la finestra di ricerca testo
Pause ()
If sTesto Then; se un qualche testo  stato specificato,
TypeString (sTesto); lo immette nel campo di ricerca
Pause ();
Else; altrimenti,
Let sTesto = GetObjectValue (); trasmette per riferimento la stringa da cercare
EndIf; fine controllo testo
; se si  richiesta la ricerca dall'inizio oppure in avanti,
If sOggetto == PRIMO || sOggetto == SUCCESSIVO Then
TypeKey (ALT_G); attiva la ricerca all'ingi
Else; altrimenti,
TypeKey (ALT_S); attiva la ricerca all'ins
EndIf; fine controllo direzione indietro
EnterKey ();
EscapeKey ()
Delay (ATTESA); ritarda il flusso per i decimi di secondo impostati
If GetObjectSubTypeCode () == PULSANTE_RADIO Then; se si resta nella finestra,
EscapeKey (); ne esce,
Let iErrore = TRUE; e imposta la conclusione anomala
EndIf; fine controllo esito
ControllaSintesi (iStato); verifica se riattivare la sintesi
If !iErrore Then; se non si sono verificate anomalie,
Return TRUE; restituisce l'esito positivo
Else; altrimenti,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo esito
EndFunction

Int Function EstremiDocumento (string sTesto, string ByRef sOggetto)
Var
String sTitolo, ; intestazione della finestra di dialogo
String sMessaggio; testo per la finestra di dialogo

SpeechOn (TRUE); riattiva la sintesi, con lo svuotamento del buffer
If sOggetto == SUCCESSIVO Then; se si era chiesta l'occorrenza seguente,
Let sTitolo = FormatString (ttlContinuaCerca, _A, msgFine); formatta il titolo
Let sMessaggio = FormatString (msgContinuaCerca, msgInizio); formatta anche la conferma
Let gsPartenza = PRIMO; si assegna al tipo di azione la ricerca dall'inizio
Else; se invece si era chiesta l'occorrenza precedente,
Let sTitolo = FormatString (ttlContinuaCerca, _O, msgInizio); formatta il titolo
Let sMessaggio = FormatString (msgContinuaCerca, msgFine); formatta anche la conferma
Let gsPartenza = ULTIMO; imposta il tipo di azione per la ricerca dalla fine
EndIf; fine controllo tipo richiesta
; propone se continuare o meno la ricerca dalla parte opposta
If ChiedeConferma (sTitolo, sMessaggio, FALSE, FALSE, TRUE) Then; se si conferma di proseguire,
VaiEstremi (gsPartenza); esegue lo spostamento per continuare la ricerca,
Return EsegueRicerca (sTesto, sOggetto);poi riprende la ricerca e ne restituisce l'esito
Else; se invece la ricerca  stata interrotta,
Return TRUE; restituisce comunque la prosecuzione del flusso
EndIf; fine controllo scelta
EndFunction

Int Function InizioDocumento ()
If SiamoNellaFinestra (RIGHE) Then; se l'applicativo corrente funziona a righe,
Return TRUE; restituisce un'unit come prima posizione del file
Else; se invece l'applicativo funziona con la posizione assoluta,
Return FALSE; restituisce uno zero come prima posizione
EndIf; fine controllo finestra
EndFunction

Int Function MossoDaPrima (string sOggetto)
Var Int iAttuale; posizione del cursore
Pause ()
Let iAttuale = PosizioneCursore (); memorizza la posizione corrente del cursore
If iAttuale == gnUltima ;se questa  uguale a quella memorizzata nell'ultimo contrassegno,
|| (sOggetto == PRIMO && iAttuale == InizioDocumento (); o, se si  partiti e rimasti all'inizio,
|| (sOggetto == ULTIMO && iAttuale == ValoreLunghezza ())) Then; o, partiti e rimasti alla fine,
Return FALSE; restituisce un risultato nullo
Else; altrimenti, in tutti gli altri casi,
Return TRUE; restituisce la conferma dello spostamento
EndIf; fine controllo cursore
EndFunction

Void Function CercaDato (string sCategoria, string sOggetto, int iAiuto)
Var
Int iStato, ; stato di attivazione della sintesi
String sTesto; stringa da cercare

; verifica lo spegnimento della sintesi, azzerando il buffer
Let iStato = ControllaSintesi (FALSE, TRUE)
Let gnUltima = PosizioneCursore (); registra la posizione di partenza
VaiEstremi (sOggetto); effettua l'eventuale spostamento agli estremi del documento
If sCategoria == CODICE Then; se si  chiesto di cercare l'etichetta di inizio codice,
Let sTesto = INIZIO_PERSONALE; imposta la stringa relativa
EndIf; fine controllo categoria
If !EsegueRicerca (sTesto, sOggetto) Then; se la ricerca ha avuto un esito anomalo,
If !EstremiDocumento (sTesto, sOggetto) Then; se poi si  verificato un nuovo errore,
; si propone una finestra con un avviso da poter solo confermare, senza icone e suoni
ChiedeConferma (FormatString (msgNoTesto, sTesto), NULLO, OK, FALSE, TRUE)
Let sOggetto = gsPartenza; imposta l'ultima partenza come oggetto dello spostamento
EndIf; fine controllo estremi
EndIf; fine controllo ricerca
ControllaSintesi (iStato, TRUE); verifica l'eventuale riattivazione della sintesi
If !MossoDaPrima (sOggetto) ; se il cursore non si  spostato,
&& (sOggetto == PRIMO || sOggetto == ULTIMO) Then; e si  cercato dalle estremit del file,
SpostaCursore (gnUltima); ritorna al punto di partenza
EndIf; fine controlli esito ricerca
Refresh (); resetta la schermata
SayLine (); legge la riga corrente
EndFunction

Script CercaCodicePrimo ()
GestisceDato (); chiama la funzione generica
EndScript

Script CercaCodiceUltimo ()
GestisceDato (); chiama la funzione generica
EndScript

Script CercaCodicePrecedente ()
GestisceDato (); chiama la funzione generica
EndScript

Script CercaCodiceSuccessivo ()
GestisceDato (); chiama la funzione generica
EndScript

String Function ToglieTab (string sTesto)
Return StringReplaceSubstrings (sTesto, A9, NULLO); restituisce il testo senza caratteri di tabulazione
EndFunction

Void Function ImpostaPipe (string ByRef sSeparatore)
If !sSeparatore Then; se non si  indicato alcun carattere o stringa di separazione,
Let sSeparatore = PIPE; imposta il carattere Ascii 124
EndIf; fine controllo caratteri
EndFunction

String Function TroncaTesto (string sTesto, string sSeparatore, int iValore, int iRimuovi)
Var
Int i, ; contatore del ciclo
String sOrigine, ; copia del testo da cercare
Int iCerca, ; numero di occorrenze da trovare
Int iPartenza, ; punto della stringa da cui iniziare a cercare
Int iLungo, ; lunghezza della stringa di origine
Int iRipeti, ; contatore delle ripetizioni
Int iPosiz, ; punto d'interruzione della stringa
String sDato; stringa temporanea

ImpostaPipe (sSeparatore); se non lo si  specificato, imposta come separatore il carattere Pipe
If iValore >= FALSE Then; se la ricerca va fatta a partire dall'inizio,
If iValore < 1 Then; se non si sono specificati parametri, o il valore Zero,
Let iCerca = PRIMA; imposta di cercare la prima occorrenza
Else; altrimenti, se un valore positivo  specificato,
Let iCerca = iValore; lo imposta come numero di occorrenze da trovare
EndIf; fine controllo occorrenze
Let sOrigine = sTesto; duplica la stringa per la ricerca
Else; Altrimenti, se la ricerca va fatta dalla fine,
Let iCerca = Abs (iValore); porta il parametro negativo al valore assoluto
Let sOrigine = StringReverse (sTesto); inverte la stringa dove cercare
Let sSeparatore = StringReverse (sSeparatore); inverte anche la stringa cercata
EndIf; fine controllo direzione ricerca
Let iPartenza = 1; inizializza la colonna da cui partire
Let iLungo = StringLength (sOrigine); lunghezza della stringa in cui cercare
While !iPosiz && iRipeti < iCerca; continua finch i caratteri non siano stati trovati, o quando si raggiunge il numero necessario di ripetizioni
Let iRipeti = iRipeti + 1; aggiorna il contatore delle ripetizioni
Let sDato = SubString (sOrigine, iPartenza, iLungo - (iPartenza -1)); crea il segmento in cui cercare
Let iPosiz = StringContains (sDato, sSeparatore); cerca la stringa indicata
If iPosiz ; se  la stringa  stata trovata,
&& iRipeti < iCerca Then; ma ancora non si  giunti al numero di occorrenze richiesto,
Let iPartenza = iPartenza + iPosiz; sposta di un'unit in avanti il punto d'inizio del successivo segmento da controllare,
Let iPosiz = FALSE; ed azzera il valore
EndIf; fine controllo ritrovamento
EndWhile; fine ciclo ricerca
If iPosiz Then; se il ritrovamento  avvenuto,
If !iRimuovi Then; se la parte  da mantenere,
; Calcola la lunghezza della stringa da ottenere, sommando i valori rilevati
Let iPosiz = (iPosiz + iPartenza) - 2
If iValore >= FALSE Then; se la ricerca era dall'inizio,
Return StringLeft (sTesto, iPosiz); preleva la stringa da sinistra
Else; altrimenti, se era dalla fine,
Return StringRight (sTesto, iPosiz); la preleva da destra
EndIf; fine controllo porzione mantenuta
Else; altrimenti, se la parte  da eliminare,
; calcola la lunghezza della stringa da rimuovere, aggiungendo anche i caratteri del separatore
Let iPosiz = ((iPosiz + iPartenza) - 2) + StringLength (sSeparatore)
If iValore >= FALSE Then; se la ricerca era dall'inizio,
Return StringChopLeft (sTesto, iPosiz); rimuove la stringa a sinistra
Else; altrimenti, se era dalla fine,
Return StringChopRight (sTesto, iPosiz); rimuove la stringa da destra
EndIf; fine controllo porzione eliminata
EndIf; fine controllo modifica
Else; altrimenti, se il separatore non  stato trovato,
Return sTesto; restituisce la stringa originale invariata
EndIf; fine controllo esito
EndFunction

Int Function CaricaScript (string ByRef sNome, string ByRef sCodice, int iCompleto)
If !SiamoNellaFinestra (MANAGER) Then; se non ci si trova nell'Editor di Script,
PronunciaEsegue (); ripete i tasti premuti, leggendo il nome dello script,
Return FALSE; e restituisce un risultato nullo, interrompendo il flusso
EndIf; fine controllo finestra
Var
String sTesto, ; eventuale contenuto dello script
Int iLungo, ; lunghezza della parola iniziale degli script
Int iPosiz, ; posizione di fine nome dello script
Int i; contatore del ciclo

SpeechOff (); spegne la sintesi
TypeKey (CONTROL_R); attiva la selezione di un eventuale script sul cursore
Pause ()
; salva l'eventuale contenuto selezionato, cui sono rimossi spazi in eccesso e tabulazioni
Let sTesto = TagliaSpazi (ToglieTab (GetSelectedText ()))
PriorCharacter (); si sposta di un carattere indietro, casomai per togliere la selezione
NextCharacter (); ritorna alla posizione iniziale
Let iLungo = StringLength (CHIAVE_SCRIPT); salva la lunghezza della parola d'inizio script
If !sTesto ; se nessun contenuto  stato rilevato,
|| StringLeft (sTesto, iLungo) != CHIAVE_SCRIPT Then; oppure, se non si tratta di uno script,
SpeechOn (); riattiva la sintesi
SayMessage (OT_ERROR, hlpNoScript, hlpNoScript_corto); legge l'avviso,
Return FALSE; e restituisce un risultato nullo, interrompendo il flusso
EndIf; fine controllo script
Let iPosiz = StringContains (sTesto, APERTA_TONDA); trova la fine del nome dello script
Let iLungo = iLungo + 1; aggiorna il dato di partenza
Let sNome = TagliaSpazi (SubString (sTesto, iLungo, iPosiz - iLungo)); estrae la stringa
If !iCompleto Then; se il contenuto deve escludere la prima e l'ultima riga di codice,
; rimuove le estremit individuate con il carattere di Nuova Linea, Ascii 10
Let sCodice = TroncaTesto (TroncaTesto (sTesto, LF, 1, TRUE), LF, -1, TRUE)
Else; altrimenti,
Let sCodice = sTesto; lascia la forma rilevata
EndIf; fine controllo estrazione codice
SpeechOn (); riattiva la sintesi
Return TRUE; restituisce l'esito positivo
EndFunction

String Function ImpostaConfigurazione (string ByRef sArchivio)
If PathRemoveExtension (sArchivio) == sArchivio Then; se il nome indicato  privo d'estensione,
Let sArchivio = sArchivio + JCF; aggiunge l'estensione predefinita dei file di configurazione
EndIf; fine controllo estensione
EndFunction

String Function SezioniUtente (string sArchivio)
ImpostaConfigurazione (sArchivio); se non presente, aggiunge l'estensione dei file configurazione
; Dalle impostazioni per l'Utente, restituisce le sezioni dell'archivio indicato
Return IniReadSectionNamesEx (UTENTE, sArchivio)
EndFunction

String Function ChiaviUtente (string sArchivio, string sSezione)
ImpostaConfigurazione (sArchivio); se non presente, aggiunge l'estensione dei file configurazione
; Dalle impostazioni per l'Utente, restituisce le chiavi di archivio e sezione indicati
Return IniReadSectionKeysEx (sSezione, UTENTE, sArchivio)
EndFunction

String Function LeggeUtente (string sArchivio, string sSezione, string sChiave)
ImpostaConfigurazione (sArchivio); se non presente, aggiunge l'estensione dei file configurazione
; Dalle impostazioni per l'Utente, restituisce il dato di archivio, e sezione e chiave indicati
Return IniReadStringEx (sSezione, sChiave, NULLO, UTENTE, sArchivio)
EndFunction

Int Function TrovaSezione (string sFile, string sNome, ; intestazione con i primi due parametri
string ByRef sSezione, string ByRef sTasti); seconda riga con gli altri due
Var
string sSezioni, ; elenco delle sezioni
Int j, ; contatore del ciclo primario
Int k, ; contatore del secondo ciclo
String sChiavi, ; elenco delle chiavi della sezione
String sDato; dato testuale

Let sSezioni = SezioniUtente (sFile); raccoglie le sezioni dall'archivio
For j = 1 To StringSegmentCount (sSezioni, PIPE); scorre le sezioni rilevate
Let sSezione = StringSegment (sSezioni, PIPE, j); estrae la singola sezione da elaborare
Let sChiavi = ChiaviUtente (sFile, sSezione); legge i dati per l'Utente
For k = 1 To StringSegmentCount (sChiavi, PIPE); scorre le chiavi rilevate
Let sTasti = StringSegment (sChiavi, PIPE, k); estrae la combinazione tasti che funge da chiave
Let sDato = LeggeUtente (sFile, sSezione, sTasti); legge il dato
If sDato == sNome Then; se il dato estratto ed il nome di script coincidono,
Return TRUE; restituisce l'esito positivo
EndIf; fine controllo confronto
EndFor; fine ciclo chiavi
EndFor; fine ciclo sezioni
Return FALSE; se il flusso non si  interrotto prima, restituisce un risultato nullo
EndFunction

String Function CambiaCampo (string sRecord, string sTermine, int iPosiz, string sSeparatore)
Var
Int iLungo, ; lunghezza del separatore
Int iCampi, ; numero dei campi rilevati nel record
String sDato; dato temporaneo

ImpostaPipe (sSeparatore); se non lo si  specificato, imposta come separatore il carattere Pipe
Let iLungo = StringLength (sSeparatore); conta i caratteri del separatore
Let iCampi = StringSegmentCount (sRecord, sSeparatore); conta i campi presenti nel record
If !iPosiz Then; se il numero dell'campo da elaborare non  specificato,
If !sTermine Then; se non lo  nemmeno la stringa da cercare,
Return sRecord; restituisce la forma originale
Else; altrimenti, se la stringa  indicata,
Let iPosiz = StringSegmentIndex (sRecord, sSeparatore, sTermine, TRUE); cerca la stringa nei campi
If !iPosiz Then; se l'campo non  stato individuato,
Return sRecord; restituisce la forma originale
EndIf; fine controllo campo da rimuovere
EndIf; fine controllo valore numerico
ElIf sTermine Then; se  presente anche il dato da integrare nei campi,
If iPosiz < FALSE Then; se si  specificato di aggiungere il termine in coda,
Let iPosiz = StringSegmentCount (sRecord, sSeparatore) + 1; aggiunge un'unit al numero di campi esistenti
EndIf; fine controllo valore negativo
If iPosiz == PRIMA Then; se il campo da sostituire  il primo,
If iCampi <= PRIMA Then; se anche i campi non sono superiori ad uno,
Let sDato = sTermine; duplica solo la stringa specificata
Else; altrimenti, se ve ne sono pi d'uno,
Let sDato = sTermine + sSeparatore; aggiunge il separatore in coda alla stringa specificata
EndIf; fine controllo numero campi
Else; altrimenti, se il dato  da inserire o aggiungere in coda,
Let sDato = sSeparatore + sTermine; aggiunge il separatore all'inizio
EndIf; fine controllo aggiunta separatore
EndIf; fine controllo posizione campo
If !sTermine ; se nessun termine  stato specificato,
&& iPosiz == ULTIMA Then; ed  stato indicato di aggiungere un campo alla fine,
Return FormatString (msg2, sRecord, sSeparatore); aggiunge il solo separatore senza dato
ElIf iCampi > PRIMA ; se i dati sono pi d'uno,
|| iPosiz > PRIMA Then; oppure, se il campo da elaborare  maggiore di uno,
If iPosiz == PRIMA Then; se quello da aggiornare o rimuovere  il primo campo,
; compone il dato, casomai aggiungendovi il resto del record dal secondo campo in poi
Return FormatString (msg2, sDato, TroncaTesto (sRecord, sSeparatore, PRIMA, TRUE))
ElIf iCampi == iPosiz Then; se il numero di dati e quello dell'campo da elaborare sono uguali,
; compone il dato tagliando dal record l'ultimo campo, e casomai accodandovi il dato
Return FormatString (msg2, TroncaTesto (sRecord, sSeparatore, ULTIMA, TRUE), sDato);
ElIf iPosiz > iCampi Then; se il nuovo dato va posto dopo quelli esistenti,
; compone il dato, casomai accodandolo all'elenco attuale
Return FormatString (msg2, sRecord, sDato);
Else; altrimenti, se l'campo da sostituire si trova in mezzo ad altri campi,
; inserisce il dato tra i campi fino a quello precedente al numero da sostituire e la restante parte del record
Return FormatString (msg4, TroncaTesto (sRecord, sSeparatore, iPosiz - 1), sDato, sSeparatore, TroncaTesto (sRecord, sSeparatore, iPosiz - iCampi))
EndIf; fine controlli composizione dato
EndIf; fine aggiornamento dato
Return sDato; restituisce il termine aggiunto, o una stringa vuota
EndFunction

String Function ElencoSezioni (string sSezione)
Var
String sElenco = lstSezioniTasti, ; imposta le sezioni predefinite
String sNuove = ChiaviUtente (PS_FILE, SEZIONI + TASTI); rileva le eventuali sezioni aggiornate

If sNuove Then; se sono presenti delle sezioni personalizzate,
Let sElenco = CambiaCampo (sElenco, sNuove, ULTIMA); le aggiunge all'elenco
EndIf; fine controllo elenco sezioni
If !StringSegmentIndex (sElenco, PIPE, sSezione, TRUE) Then; se la sezione non  presente,
ScriveValore (PERSONALE, SEZIONI + TASTI, sSezione, TRUE); aggiorna il dato nell'archivio,
Return CambiaCampo (sElenco, sSezione, ULTIMA); e restituisce l'elenco aggiornato
Else; altrimenti, se non vi sono variazioni,
Return sElenco; restituisce la forma registrata
EndIf; fine controllo sezione
EndFunction

String Function ElencoNumeri (int iPartenza)
Var
Int i, ; contatore del ciclo
String sElenco; stringa da restituire

For i = iPartenza + 1 To MAX_VOCI; crea un elenco di valori in forma testuale
Let sElenco = CambiaCampo (sElenco, IntToString (i), ULTIMA); aggiunge il valore del ciclo
EndFor; fine ciclo creazione elenco
Return sElenco; restituisce l'elenco di voci testuali creato
EndFunction

Int Function SceltaValore (string sElenco, string sTitolo, int iPartenza)
Var Int iScelta; valore della scelta effettuata

If !iPartenza Then; se il valore d'ingresso non  stato indicato,
Let iPartenza = PRIMA; imposta la voce di scelta iniziale
EndIf; fine controllo voce all'ingresso
While iPartenza; ripropone la richiesta finch un valore  impostato
Let iScelta = DlgSelectItemInList (sElenco, sTitolo, FALSE, iPartenza); consente la scelta
If iScelta Then; se  stata effettuata una scelta,
Let iPartenza = FALSE; annulla il valore per l'uscita dal ciclo
Else; altrimenti, viene chiesta l'uscita dalla fase
If ChiedeConferma (ttlConfermaUscita, msgConferma) Then; se tale uscita  stata confermata,
Let iPartenza = FALSE; annulla il valore per l'uscita dal ciclo
EndIf; fine controllo conferma
EndIf; fine controllo scelta effettuata
EndWhile; fine del ciclo di scelta
Return iScelta; restituisce la scelta operata
EndFunction

String Function RigaCorrente (int iTipo)
Var String s; variabile temporanea

If !iTipo Then; se non si  indicato nulla, o il valore 0,
Let s = GetLine (); rileva l'intera riga
ElIf iTipo == 1 Then; se invece si  indicato il valore 1,
Let s = GetToEndOfLine (); rileva il testo dal cursore a fine riga
Else; altrimenti, se si  indicato il valore 2,
Let s = GetFromStartOfLine (); rileva il testo dal cursore sino ad inizio riga
EndIf; fine controllo tipo di testo
; restituisce il testo rilevato, senza caratteri di ritorno o nuova linea, e spazi inutili
Return TagliaSpazi (StringReplaceSubstrings (StringReplaceSubstrings (s, CR, NULLO), LF, NULLO))
EndFunction

Void Function CambiaControllo (string sComando, string sTesto)
If sComando Then; se un comando  stato specificato,
TypeKey (sComando, TASTIERA); simula l'esecuzione di una combinazione dalla tastiera del pc
Pause ()
SetLastScriptKey (sComando); imposta il comando specificato come l'ultimo digitato
EndIf; fine controllo comando
If sTesto Then; se un testo  stato specificato,
TypeString (sTesto); simula l'immissione di una stringa testuale
Pause ()
EndIf; fine controllo testo
EndFunction

Script CreaSerie ()
Var
String sNomeFile, ; nome del file script
String sFileTasti, ; nome del file tasti
String sNome, ; nome dello script da duplicare
String sCodice, ; contenuto dello script
String sCifra, ; suffisso numerico al nome
String sNomeBase, ; nome script senza suffisso
String sSezione, ; sezione del file tasti dove  registrata la combinazione abbinata allo script
String sTasti, ; stringa base per le combinazioni da formattare
Int iNoTasti, ; indicatore della scrittura dei tasti di attivazione
Int iPartenza, ; valore iniziale
String sElenco, ; lista di valori testuali
String sTitolo, ; titolo nelle finestre di dialogo
Int iScelta, ; valore della scelta effettuata
Int iValore, ; variabile temporanea
String sNuovo, ; nome aggiornato dello script
String sNuoviTasti, ; nuova combinazione tasti
String sSommario, ; stringa base per il Sommario
String sDescrizione, ; stringa base per la Descrizione
Int i; contatore del ciclo

If !DocumentoCorrente (sNomeFile) Then; se non si  rilevato il nome del file script,
SayMessage (OT_ERROR, hlpNoNomeFile, hlpNoNomeFile_corto); avvisa dell'errore,
Return; e interrompe il flusso
EndIf; fine controllo nome file
Let sFileTasti = StringReplaceSubstrings (sNomeFile, JSS, JKM); compone il nome del file tasti
If !CaricaScript (sNome, sCodice) Then; se non si  rilevato alcuno script sul cursore,
Return; interrompe il flusso
EndIf; fine controllo presenza script
Let sCifra = EstraeNumero (sNomeBase, sNome); individua e toglie dal nome dello script l'eventuale suffisso numerico
If !sCifra Then; se nel nome non  presente alcun suffisso,
SayFormattedMessage (OT_ERROR, hlpNoSuffisso, hlpNoSuffisso_corto, sNome); formatta l'avviso,
Return; e interrompe il flusso
EndIf; fine controllo suffisso
If !TrovaSezione (sFileTasti, sNome, sSezione, sTasti) Then; se i dati non sono stati rilevati,
If !ChiedeConferma (FormatString (ttlNoTasti, sNome), msgNoTasti) Then; se non si vuole continuare,
Return; interrompe il flusso
EndIf; fine conferma prosecuzione
EndIf; fine controllo rilevamento dati
If sTasti Then; se i tasti di attivazione sono stati trovati,
EstraeNumero (sTasti); rimuove dalla combinazione tasti il suffisso numerico
If StringRight (sTasti, 1) != SEGNO_PIU Then; se la base dei tasti non finisce con un Pi,
Let sTasti = sTasti + SEGNO_PIU; lo aggiunge
EndIf; fine controllo tasti
Let sTasti = sTasti + msg1; aggiunge il carattere segnaposto alla base per i tasti
Else; altrimenti, se non si vogliono trascrivere i tasti di attivazione,
Let iNoTasti = TRUE; annota il valore
EndIf; fine controllo presenza tasti
Let iPartenza = StringToInt (sCifra); converte la cifra testuale come valore iniziale
Let sElenco = ElencoNumeri (iPartenza); genera un elenco di valori in forma testuale
Let sTitolo = FormatString (ttlSelezione, msgUltimoScript); compone il titolo della finestra
; imposta la voce selezionata all'ingresso nella finestra di dialogo
Let iValore = StringSegmentIndex (sElenco, PIPE, IntToString (MAX_SEGNI), TRUE)
Let iScelta = SceltaValore (sElenco, sTitolo, iValore); imposta il suffisso dell'ultimo script
If !iScelta Then; se nessun valore  stato impostato,
Return; interrompe il flusso
EndIf; fine controllo scelta
Let iValore = iScelta + iPartenza; aggiunge al valore scelto quello iniziale
If !ChiedeConferma (FormatString (ttlCreaScript, sNome, iValore), msgConfermaScelta) Then; se non si  confermata la prosecuzione,
Return; interrompe il flusso
EndIf; fine controllo conferma
; compone dei messaggi base da formattare per Sommario e Descrizione degli script
Let sSommario = StringReplaceSubstrings (GetScriptSynopsis (sNome), sCifra, msg1);
Let sDescrizione = StringReplaceSubstrings (GetScriptDescription (sNome), sCifra, msg1);
For i = iPartenza + 1 To iValore; scorre gli script da duplicare
SayFormattedMessage (OT_ERROR, msg1, NULLO, i); pronuncia il numero del suffisso elaborato
SpeechOff (); spegne la sintesi
JAWSBottomOfFile (); si porta alla fine del documento
If TagliaSpazi (ToglieTab (RigaCorrente ())) Then; se la riga non  vuota,
EnterKey (); crea una nuova riga
Else; altrimenti,
CambiaControllo (BACKSPACE); cancella il carattere precedente
If TagliaSpazi (RigaCorrente ()) Then; se nemmeno ora la riga  vuota,
EnterKey (); crea una nuova riga
EndIf; fine controllo riga precedente
EndIf; fine controllo ultima riga
Let sNuovo = FormatString (msg2, sNomeBase, i); compone il nuovo nome dello script
If !iNoTasti Then; se la scrittura dei tasti di attivazione non  stata disattivata,
Let sNuoviTasti = FormatString (sTasti, i); formatta la nuova combinazione
IniWriteStringEx (sSezione, sNuoviTasti, sNuovo, UTENTE, sFileTasti); trascrive i tasti
EndIf; fine controllo scrittura tasti
Pause ()
; avvia la procedura di creazione script, e ne immette il nome aggiornato
CambiaControllo (CONTROL_E, sNuovo)
CambiaControllo (TAB); preme il tasto Tab
CambiaControllo (BARRA_SPAZIO); imposta di creare uno script
; si porta nel campo sommario, e ne immette il contenuto aggiornato
CambiaControllo (ALT_S, FormatString (sSommario, i))
; si porta al campo Descrizione, e ne aggiorna il contenuto
CambiaControllo (ALT_D, FormatString (sDescrizione, i))
; avanza di tre controlli, passando per:
CambiaControllo (TAB); il campo Categoria
CambiaControllo (TAB); il campo Assegna A
CambiaControllo (TAB); il pulsante Ok
CambiaControllo (INVIO); chiude la procedura guidata
PriorLine (); si sposta alla riga sopra
CambiaControllo (DELETE); cancella la riga vuota sul cursore
CambiaControllo (DELETE); ne cancella un'altra
Delay (RITARDA); sospende temporaneamente il flusso
MetteTesto (sCodice, FALSE); trascrive il contenuto dello script
SpeechOn (); riattiva la sintesi,
StopSpeech (); e ne resetta il buffer
EndFor; fine scorrimento script
SayMessage (OT_ERROR, msgAttesa); pronuncia un avviso
Refresh ()
TypeKey (CONTROL_S); salva e compila gli script creati
EndScript

Script SalvaContrassegno1 ()
GestisceDato (); richiama la funzione generica
EndScript

Script TornaContrassegno1 ()
GestisceDato (); richiama la funzione generica
EndScript

String Function NoAmpersand (string sTesto)
Return StringReplaceSubstrings (sTesto, AMPERSAND, NULLO); rimuove il carattere
EndFunction

String Function PremeTasto (string sNome)
Return FormatString (lstPremiTasto, sNome); restituisce il testo formattato con il nome dei tasti
EndFunction

Void Function ComponeAiuto ()
Var
String sInfo, ; il testo delle informazioni in linea
Int i, ; contatore dei cicli
String sNome, ; dati del singolo pulsante
String sCaldo, ; nome del tasto caldo che attiva il pulsante
String sTesto; descrizione della funzione svolta dal pulsante

EnsureNoUserBufferActive (); chiude eventuali schermate del Visualizzatore Virtuale
; Inizializza le informazioni, inviando al buffer la prima parte del titolo memorizzato
UserBufferAddText (FormatString (ttlInfoDialogo, StringSegment (gsTitolo, PIPE, PRIMA)))
For i = 1 To StringSegmentCount (gsEtichette, PIPE); scorre i pulsanti opzionali impostati
Let sNome = StringSegment (gsEtichette, PIPE, i); estrae l'etichetta sul pulsante
; rileva anche la lettera della scelta rapida, formattandola assieme al prefisso del tasto
Let sCaldo = FormatString (msg2Piu, ALT, StringUpper (SubString (sNome, StringContains (sNome, AMPERSAND) + 1, 1)))
Let sNome = NoAmpersand (sNome); rimuove il carattere E Commerciale dall'etichetta
If !StringContains (sNome, SPACE) Then; se l'etichetta del pulsante  di una sola parola,
Let sTesto = FormatString (msg2Spazi, sNome, gsTermine); vi formatta anche il soggetto
Else; altrimenti, se vi sono gi due o pi parole,
Let sTesto = sNome; utilizza la forma originale
EndIf; fine controllo parole etichetta
; aggiorna il contenuto del buffer, aggiungendo il comando ed il contenuto del link
UserBufferAddLink (FormatString (msg2Punto, sTesto, sCaldo), PremeTasto (sCaldo), sTesto)
EndFor; fine scansione tasti
Let sTesto = StringSegment (gsTitolo, PIPE, SECONDA); estrae anche la seconda parte del titolo,
UserBufferAddLink (sTesto, PremeTasto (ALT_O), TroncaTesto (sTesto, PUNTO)); e la aggiunge al buffer
; Chiude la serie di comandi nel buffer con il testo predefinito per il tasto Escape
UserBufferAddLink (lstEscape, PremeTasto (ALT_A), TroncaTesto (lstEscape, PUNTO))
UserBufferActivate (); visualizza il contenuto del visualizzatore virtuale
; formatta infine le righe conclusive, citando il comando d'ingresso e di uscita dalle informazioni,
Let sInfo = FormatString (hlpUltimaInfo, GetCurrentScriptKeyName (), hlpFineInfo);
; poi, le trasmette al Buffer, avviandone la lettura.
RedirectToUserBuffer (sInfo)
EndFunction

String Function ApplicativoCorrente ()
Var String sNome = GetActiveConfiguration (); dichiara e rileva il nome dell'applicazione attiva
If sNome == EDITOR_ITA ; se il nome corrisponde alla versione italiana dell'Editor di Jaws,
|| sNome == EDITOR_ENU Then; oppure se corrisponde a quella standard inglese,
Return JAWS_FILE; restituisce il nome dei file standard di Jaws
Else; altrimenti,
Return sNome; restituisce il nome rilevato
EndIf; fine controllo nome
EndFunction

Int Function ScriptPersonale (string sNome, string ByRef sSuffisso)
Var
Int iValore, ; valore temporaneo
Int iLungo; lunghezza dell'eventuale suffisso rilevato

; estrae le differenze del nome rispetto a quello base degli script personali
Let sSuffisso = StringDiff (sNome, FormatString (msgPersonalScript))
Let iValore = StringToInt (sSuffisso); verifica l'eventuale valore numerico della stringa,
Let iLungo = StringLength (sSuffisso); e ne misura comunque la lunghezza
If (iValore && iLungo == 1) ; se la differenza  una cifra con una lunghezza di un carattere,
|| (iValore > 9 && iLungo == 2) ; oppure, il valore  superiore a nove e una lunghezza di 2,
Return TRUE; restituisce l'esito positivo
Else; altrimenti,
Let sSuffisso = NULLO; resetta il dato,
Return FALSE; e restituisce un risultato nullo
EndIf; fine controllo suffisso
EndFunction

Int Function CampoGlobale ()
If gnCampo Then; se la variabile globale  gi stata impostata,
Return gnCampo; ne restituisce il valore
Else; altrimenti, se  ancora nulla,
Return PRIMA; restituisce il valore Uno
EndIf; fine controllo campo
EndFunction

Int Function ScriveRecord (string sArchivio, string sSezione, string sChiave, string sDato)
Let sDato = FormatString (msgVirgolette, sDato); inserisce il dato in una stringa tra virgolette
If sChiave Then; se la chiave del dato  specificata, restituisce l'esito della scrittura
Return WriteSettingString (sSezione, sChiave, sDato, FT_CURRENT_JCF, FALSE, sArchivio)
Else; altrimenti, se una chiave non c',
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo chiave
EndFunction

String Function LeggeRecord (string sArchivio, string sSezione, string sChiave)
; restituisce il dato eventualmente letto , sulla base dei dati specificati, nel file di configurazione.
Return ReadSettingString (sSezione, sChiave, NULLO, FT_CURRENT_JCF, FALSE, sArchivio)
EndFunction

Int Function ScriveNumerico (string sArchivio, string sSezione, string sChiave, int iValore)
If sChiave Then; se la chiave del dato  specificata, restituisce l'esito della scrittura
Return WriteSettingInteger (sSezione, sChiave, iValore, FT_CURRENT_JCF, FALSE, sArchivio);
Else; altrimenti, se una chiave non c',
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo chiave
EndFunction

Int Function LeggeNumerico (string sArchivio, string sSezione, string sChiave)
; restituisce il valore eventualmente letto , sulla base dei dati specificati, nel file di configurazione.
Return ReadSettingInteger (sSezione, sChiave, FALSE, FT_CURRENT_JCF, FALSE, sArchivio);
EndFunction

String Function LeggeCampo (string sArchivio, string sSezione, string sChiave, int iCampo)
Var String sRecord; il record di dati estratto

If! iCampo Then; se non  stato specificato alcun parametro,
Let iCampo = CampoGlobale (); imposta un valore, quello della variabile globale o il valore Uno
EndIf; fine controllo campo
; estrae il record di dati dall'archivio, dell'applicativo corrente o del nome impostato
Let sRecord = LeggeRecord (sArchivio, sSezione, sChiave)
Return StringSegment (sRecord, PIPE, iCampo); restituisce il solo campo richiesto
EndFunction

String Function ImpostaNomi (string sNome, string ByRef sAlias)
Var String sSuffisso; l'eventuale suffisso numerico del nome

If ScriptPersonale (sNome, sSuffisso) Then; se il nome  di uno script a gestione personale,
; estrae il nome virtuale dello script dal relativo record di dati
Let sAlias = LeggeCampo (NULLO, PERSONALI, sSuffisso, PRIMA)
Else; altrimenti, in tutti gli altri casi,
Let sAlias = sNome; copia il nome reale in quello virtuale
EndIf; fine controllo nome script
Return sNome; restituisce comunque il parametro nella forma originale
EndFunction

String Function GetScriptSynopsis (string sNome)
Var String sSuffisso; eventuale suffisso numerico degli script a gestione personale
If ScriptPersonale (sNome, sSuffisso) Then; se lo script  uno di quelli a gestione personale,
; estrae il sommario dello script dai corrispondenti dati per l'applicazione corrente
Return LeggeCampo (NULLO, PERSONALI, sSuffisso, TERZA)
Else; altrimenti, in tutti gli altri casi,
Return GetScriptSynopsis (sNome); restituisce il dato proveniente dalla funzione nativa
EndIf; fine controllo
EndFunction

Int Function TrovaSerie (string sBufferTasto, string sBufferInfo, ; prima riga con due parametri,
string sTasto, string sInfo, string ByRef s1, string ByRef s2, int ByRef iSerie); e seconda riga
Var Int i1

; salva la prima stringa nel parametro per riferimento, portandola in minuscolo
Let s1 = StringLower (sBufferTasto)
; salva in minuscolo la seconda stringa nel parametro
Let s2 = StringLower (sTasto)
; porta in minuscolo il primo testo della seconda coppia, rimuovendo eventuali caratteri Punto
Let sBufferInfo = StringReplaceSubstrings (StringLower (sBufferInfo), PUNTO, NULLO)
; confronta anche il secondo testo
Let sInfo = StringReplaceSubstrings (StringLower (sInfo), PUNTO, NULLO)
StringTrimCommon (s1, s2); confronta le combinazioni tasti
StringTrimCommon (sBufferInfo, sInfo); confronta le informazioni sugli script
Let i1 = GetCharacterValue (s1); memorizza il codice Ascii del primo carattere rilevato
; se la lunghezza del primo testo variabile  diversa da 1, o  diversa da quella del secondo carattere
If (StringLength (s1) != 1 || StringLength (s1) != StringLength (s2))
; se il primo carattere variabile  diverso dalla cifra 9, ma il secondo non ha un Ascii aumentato di 1,
|| (i1 != 57 && GetCharacterValue (s2) != (i1 + 1))
|| s1 != sBufferInfo ; infine, se i primi caratteri variabili delle due coppie sono diversi,
|| s2 != sInfo Then; oppure, lo sono i secondi caratteri variabili,
If iSerie Then; se la serie di voci era gi stata individuata,
Let iSerie = 2; imposta il valore per lo svuotamento del buffer
EndIf; fine controllo stato delle serie
Return FALSE; restituisce un risultato nullo
Else; altrimenti, se il flusso ha superato tutti i controlli,
Return TRUE; restituisce l'esito positivo
EndIf; fine controllo differenze
EndFunction

String Function TogliePunto (string sTesto)
Let sTesto = StringTrimTrailingBlanks (sTesto); rimuove eventuali spazi finali
If StringRight (sTesto, 1) == PUNTO Then; se l'ultimo carattere  un Punto fermo,
Return StringTrimTrailingBlanks (StringChopRight (sTesto, 1)); restituisce la stringa senza
Else; altrimenti,
Return sTesto; restituisce la stringa originale, ma almeno ripulita degli spazi finali
EndIf; fine controllo carattere finale
EndFunction

String Function ToglieUltimo (string sTesto)
; restituisce la stringa senza l'ultimo carattere, al netto di eventuali punti finali
Return StringChopRight (TogliePunto (sTesto), 1)
EndFunction

Void Function AggiornaVisualizzatore (string sTasto, string sNome, ; riga con i primi due,
string sAlias, string sInfo, string sPrimo, string sUltimo); seconda riga con gli altri quattro
If !sPrimo Then; se si stanno aggiornando le normali voci,
UserBufferAddText ( ; compone la riga d'informazioni, comprensiva del link,
FormatString (hlpInfoScript, sInfo, sTasto), ; formatta il testo da visualizzare,
FormatString (hlpInfoLink, sNome), ; formatta anche il comando da eseguire,
sAlias); e aggiunge il nome virtuale per l'elenco dei link
Else; altrimenti, per le serie di voci,
UserBufferAddText ( ; compone la riga d'informazioni, formattando i caratteri variabili
FormatString (hlpInfoSerie, ToglieUltimo (sInfo), ToglieUltimo (sTasto), sPrimo, sUltimo))
EndIf; fine controllo parametri
EndFunction

String Function AggiungePunto (string ByRef sTesto)
Let sTesto = StringTrimTrailingBlanks (sTesto); toglie eventuali spazi finali alla riga
If StringRight (sTesto, 1) != PUNTO Then; se l'ultimo carattere della stringa non  un punto,
Return sTesto + PUNTO; la restituisce aggiungendolo
Else; altrimenti,
Return sTesto; restituisce la forma originale
EndIf; fine controllo carattere finale
EndFunction

String Function ConverteInBell (string sTesto, string sCarattere)
Return StringReplaceSubstrings (sTesto, sCarattere, BELL); restituisce il testo convertito
EndFunction

Int Function ConfigurazioneCampi ()
Var
Int iCampi, ; numero dei campi del record
Int i, ; contatore del ciclo
String sNome, ; nome dell'archivio di configurazione
String sTitoli, ; titoli delle finestre di dialogo
String sPulsanti, ; elenco delle impostazioni relative
String sInfo, ; informazioni per le fasi d'aggiunta o modifica testo
String sPrefissi, ; parti iniziali dei nomi di funzioni
Int j, ; contatore del ciclo iniziale
String sSezione, ; etichetta della sezione in cui scrivere
Int k, ; contatore del secondo ciclo
String sDato; singolo dato estratto

If gsCategoria == ELEMENTO Then; se la procedura deve scegliere elementi di ricerca,
Let gnTipo = PRIMA; imposta la scelta iniziale
ElIf gsCategoria == MACRO Then; se invece sono da scegliere i testi delle Macro,
Let gnTipo = SECONDA; imposta l'opzione alternativa
ElIf gsCategoria == SCRIPTS Then; se, ancora, sono da elaborare gli script a gestione personale,
Let gnTipo = TERZA
Else; altrimenti, se la categoria non  stata riconosciuta, consente di sceglierne il tipo
Let gnTipo = SceltaValore (ConverteInBell (lstTipoGuidata, LF), msgTipoGuidata)
If !gnTipo Then; se non si  effettuata alcuna scelta,
Return; interrompe il flusso
EndIf; fine controllo esito scelta
EndIf; fine controllo tipo procedura
If gnTipo <= SECONDA Then; se si  impostata una delle prime due scelte,
Let iCampi = 1; imposta un unico campo per il record
Let sNome = PS_FILE; imposta il nome dell'archivio di configurazione personale
Let gnMaxVoci = MAX_SEGNI; imposta le voci di scelta da 1 a 9
Let gnNumerico = TRUE; imposta la presenza di un prefisso numerico davanti alle voci
Else; altrimenti, se  infine impostato il terzo tipo di procedura,
If gsCategoria == SCRIPTS Then; se sono da elaborare gli script a gestione personale,
Let iCampi = 5; imposta i campi necessari
For i = 1 To StringSegmentCount (lstArchivioTasti, PIPE); scorre i tasti predefiniti come validi
; trascrive i tasti, predisposti nell'apposita sezione del file di configurazione personale
ScriveNumerico (PS_FILE, ARCHIVIO + TASTI, StringSegment (lstArchivioTasti, PIPE, i), TRUE)
EndFor; fine scansione tasti
Else; altrimenti, se la categoria  da definire,
Let iCampi = SceltaValore (lstCifre1_9, FormatString (ttlSelezione,msgCampiGuidate, gsOggetto, gsCategoria))
If !iCampi Then; se non  stata operata nessuna scelta,
Return; interrompe il flusso
EndIf; fine controllo scelta
EndIf; fine controllo impostazione campo
Let sNome = NULLO; resetta il dato per far impostare il file per l'applicazione
Let gnNumerico = FALSE; lascia le voci di scelta senza alcun prefisso numerico
EndIf; fine controllo tipo impostato
If sNome Then; se il nome dell'archivio di configurazione  stato impostato,
ScriveRecord (gsCategoria, ELABORA, ARCHIVIO, sNome); inizializza il file configurazione
EndIf; fine controllo nome archivio
If !ScriveNumerico (gsCategoria, ELABORA, TIPO, gnTipo) Then; se la scrittura fallisce,
If IsSameScript () Then; se i tasti di attivazione sono stati premuti due volte,
SayFormattedMessage (OT_ERROR, hlpNoScriveJCF, NULLO, gsCategoria); pronuncia l'avviso
EndIf; fine controllo doppia pressione
Return; in ogni caso, interrompe il flusso
EndIf; fine controllo scrittura
; Converte i dati in un elenco, dalla forma su pi righe, per i seguenti tipi di dati:
Let sTitoli = ConverteInBell (lstTitoliGuidate, LF); titoli delle finestre di dialogo
Let sInfo = ConverteInBell (lstInfoGuidate, LF); informazioni per le fasi di immissione o modifica testo
Let sPrefissi = ConverteInBell (lstChiamaGuidate, LF); prefissi dei nomi delle funzioni da chiamare
For j = 1 To iCampi; scorre il numero di campi scelto
Let sSezione = CAMPO + IntToString (j); fissa l'etichetta per la sezione dove scrivere
ScriveRecord (gsCategoria, sSezione, TITOLO, StringSegment (sTitoli, BELL, gnTipo + (j - 1)))
If gnTipo <= SECONDA Then; se si  nei primi due tipi di procedura,
Let sPulsanti = lstPulsantiGuidate1; imposta i pulsanti modifica, Aggiunge, Elimina, Sposta Su e Gi
Else; altrimenti, nel caso della elaborazione su pi campi,
If j == PRIMA Then; se si  nel primo campo,
Let sPulsanti = lstPulsantiGuidata2; imposta quelli con avanti e indietro, e Duplica script
Let gnMaxVoci = MAX_VOCI; imposta fino ad un massimo di 99 voci
ElIf j == iCampi Then; se invece si  sull'ultimo,
Let sPulsanti = lstPulsantiGuidata4; imposta quelli con i pulsanti Avanti, Indietro e Torna all'inizio
Let gnMaxVoci = MAX_VOCI; imposta fino ad un massimo di 99 voci
Else; altrimenti, negli altri campi,
Let sPulsanti = lstPulsantiGuidata3; imposta la serie senza Aggiungi ed Elimina
Let gnMaxVoci = PRIMA; riduce ad una sola la voce di scelta visualizzata
EndIf; fine controllo campo
EndIf; fine controllo tipo
Let sPulsanti = ConverteInBell (sPulsanti, LF); converte l'elenco esteso in voci
For k = 1 To StringSegmentCount (sPulsanti, BELL); scorre i dati rilevati
Let sDato = StringSegment (sPulsanti, BELL, k); estrae la prima coppia di chiavi e dati
; utilizza la prima parte fino all'Uguale come chiave, ed il resto della stringa come suo contenuto
ScriveRecord (gsCategoria, sSezione, StringSegment (sDato, UGUALE, PRIMA), StringSegment (sDato, UGUALE, SECONDA))
EndFor; fine scansione pulsanti
ScriveNumerico (gsCategoria, sSezione, VOCI, gnMaxVoci); trascrive le voci massime selezionabili
; trascrive le impostazioni sulla presenza o meno di un prefisso numerico alle voci di scelta
ScriveNumerico (gsCategoria, sSezione, NUMERICO, gnNumerico)
If gsCategoria != SCRIPTS ; se non si stanno elaborando script a gestione personale,
|| j < iCampi Then; oppure, se comunque non ci si trova nell'ultimo campo,
; trascrive le informazioni per le fasi di aggiunta o modifica testo
ScriveRecord (gsCategoria, sSezione, INFO, StringSegment (sInfo, BELL, gnTipo))
Else; altrimenti,
ScriveRecord (gsCategoria, sSezione, INFO, NULLO); trascrive un dato vuoto
EndIf; fine controllo campo
If gsCategoria == MACRO ; se si stanno elaborando le macro,
|| (gsCategoria == SCRIPTS ; oppure, se sono da elaborare gli script a gestione personale,
&& j == QUARTA) Then; ma ci si trova solo nel quarto campo,
Let gnMultiple = TRUE; imposta l'immissione testo su pi righe
Else; altrimenti,
Let gnMultiple = FALSE; la disattiva
EndIf; fine controllo righe multiple
; trascrive l'impostazione attiva per le righe multiple in fase di immissione testo
ScriveNumerico (gsCategoria, sSezione, MULTIPLE, gnMultiple)
If j >= SECONDA Then; se si  un campo dal secondo in poi,
Let gnConferma = TRUE; imposta la richiesta di una conferma all'abbandono
Else; altrimenti, se si  nella schermata iniziale,
Let gnConferma = FALSE; la disattiva
EndIf; fine controllo conferme
; trascrive l'impostazione attiva per la conferma all'uscita dalla fase attiva
ScriveNumerico (gsCategoria, sSezione, CONFERMA, gnConferma)
; trascrive anche i prefissi per le funzioni da chiamare a fine procedura
ScriveRecord (gsCategoria, sSezione, CHIAMA, StringSegment (sPrefissi, BELL, gnTipo + (j - 1)))
EndFor; fine scansione campi
Return TRUE; se nessun altro controllo ha interrotto il flusso, restituisce l'esito positivo
EndFunction

Int Function FileUtente (string sNome)
ImpostaConfigurazione (sNome); se non presente, aggiunge l'estensione dei file configurazione
; restituisce il risultato del controllo sull'esistenza del file specificato
Return FileExists (FormatString (msg2Controbarra, GetUserSettingsDirectory (), sNome))
EndFunction

Int Function ArchivioDati ()
If !FileUtente (gsCategoria) Then; se il file di configurazione per il tipo di procedura non esiste,
If !ConfigurazioneCampi () Then; se la creazione del file non riesce,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo creazione file configurazione
EndIf; fine controllo esistenza file configurazione
If !gnTipo Then; se il tipo di procedura non  stato ancora impostato,
Let gnTipo = LeggeNumerico (gsCategoria, ELABORA, TIPO); legge il dato dal file configurazione
EndIf; fine controllo tipo procedura
Let gsArchivio = LeggeRecord (gsCategoria, ELABORA, ARCHIVIO); legge il nome dell'archivio dei dati
If !gsArchivio Then; se nessun nome  stato rilevato,
Let gsArchivio = GetActiveConfiguration (); salva il nome dell'applicazione corrente
EndIf; fine controllo presenza settaggio
Return TRUE; restituisce l'esito positivo
EndFunction

String Function PersonaFemminile (int iValore)
If iValore == PRIMA Then; se si deve completare un termine singolare,
Return _A; restituisce l'omonima costante
Else; altrimenti, con tutti gli altri valori, che indicano un termine plurale,
Return _E; restituisce l'omonima costante
EndIf; fine controllo valore
EndFunction

String Function PersonaMaschile (int iValore)
If iValore == PRIMA Then; se si deve completare un termine singolare,
Return _O; restituisce l'omonima costante
Else; altrimenti, con tutti gli altri valori, che indicano un termine plurale,
Return _I; restituisce l'omonima costante
EndIf; fine controllo valore
EndFunction

Void Function ScambiaTitoli (string sTitolo, ; intestazione con il primo parametro,
string ByRef sBufferTitolo, string ByRef sBufferEtichette); seconda riga con gli altri due
If sTitolo Then; se il primo parametro  stato indicato,
Let sBufferTitolo = gsTitolo; salva l'eventuale titolo gi registrato,
Let gsTitolo = sTitolo; e assegna alla variabile globale il parametro indicato
Let sBufferEtichette = gsEtichette ; memorizza le eventuali etichette impostate,
Let gsEtichette = NULLO; e azzera la variabile globale, per impedire la lettura dell'Aiuto in linea
Else; altrimenti, se il primo parametro non  stato indicato,
Let gsTitolo = sBufferTitolo; riassegna il titolo precedentemente salvato
Let gsEtichette = sBufferEtichette; riassegna anche le etichette casomai registrate
EndIf; fine controllo titolo
EndFunction

Int Function ProsegueFlusso (string sCategoria, string sSuffisso)
Var
String sFinale, ; lettera conclusiva di un termine
String sTermine, ; oggetto da elaborare
String sDato, ; tipologia di suffisso
String sTitolo; titolo della finestra di dialogo

If sCategoria == MACRO Then; se si elaborano delle macro,
Let sFinale = PersonaFemminile (PRIMA); imposta la desinenza singolare femminile
ElIf sCategoria == SCRIPTS Then; se invece si elaborano gli script a gestione personale,
Let sFinale = PersonaMaschile (PRIMA); imposta la desinenza singolare maschile
EndIf; fine controllo categoria
If gnTipo == TERZA Then; se si stanno elaborando procedure su pi campi,
Let sTermine = sCategoria; imposta come oggetto il solo nome della categoria,
; imposta come suffisso il nome dell'applicazione corrente
Let sSuffisso = GetActiveConfiguration ()
Else; altrimenti,
Let sTermine = sCategoria + gsOggetto; compone categoria e oggetto globale
EndIf; fine controllo tipo procedura
Let sDato = StringSegment (lstTipiDato, PIPE, gnTipo); estrae il tipo di suffisso,
Let sTitolo = FormatString (ttlNoElementi, sFinale, sTermine, sDato, sSuffisso); e crea il titolo
If sCategoria == ELEMENTO Then; se si stanno elaborando gli elementi di ricerca,
Let sFinale = PersonaMaschile (PRIMA); la mette al maschile
EndIf; fine controllo prefisso
Return ChiedeConferma (sTitolo, FormatString (msgImmissione, sFinale)); restituisce la scelta
EndFunction

String Function ComponeTermine ()
If gnTipo <= SECONDA Then; se ci si trova nei primi due tipi di procedura,
Return gsChiave; restituisce il valore testuale della chiave come termine da formattare
Else; altrimenti, nelle procedure del terzo tipo,
Return gsAttiva; restituisce la voce corrente del campo principale
EndIf; fine controllo termine da formattare
EndFunction

String Function ChiaveCorrente (int iValore)
If gnTipo <= SECONDA Then; se si stanno elaborando i primi due tipi di procedura,
Return IntToString (iValore); restituisce la forma testuale del valore corrente
Else; altrimenti, se si  nel terzo tipo di procedura,
Return StringSegment (gsElenco, PIPE, iValore); restituisce la chiave attiva nell'elenco
EndIf; fine controllo tipo procedura
EndFunction

String Function CreaElenco (string sArchivio, string sSezione, ; primi due parametri,
int iCampo, string sSeparatore); seconda riga con gli altri due
Var
Int iValide, ; numero delle voci da inserire nell'elenco
Int i, ; contatore del ciclo
String sRecord, ; dati registrati
String sChiave, ; chiave del record
String sVoci; elenco da restituire

If !iCampo Then; se nessun numero di campo  stato specificato,
Let iCampo = CampoGlobale (); viene usato il valore nella variabile globale, o il numero 1
EndIf; fine controllo campo
If !sSeparatore Then; se nessun separatore delle voci di elenco  stato specificato,
Let sSeparatore = BELL; viene usato il carattere Bell, Ascii 7
EndIf; fine controllo separatore
If gnTipo <= SECONDA Then; se si  nei primi due tipi di elaborazione,
Let iValide = StringToInt (LeggeRecord (sArchivio, sSezione, ZERO)); legge il dato sull'ultima impostazione
If !iValide ; se il valore non  stato rilevato,
&& gnTotali >= CICLO_VOCI Then; e le voci sono maggiori o uguali al valore predefinito,
Let iValide = CICLO_VOCI; lo imposta
EndIf; fine primo controllo voci
EndIf; fine controllo tipo elaborazione
If !iValide Then; se il valore non  ancora stato definito,
Let iValide = gnTotali; imposta il numero totale delle voci registrate
EndIf; fine controllo impostazione valore
For i = 1 To iValide; scorre il numero di voci impostato
Let sChiave = ChiaveCorrente (i); ricava la chiave attiva dall'apposita funzione
Let sRecord = LeggeRecord (sArchivio, sSezione, sChiave); rileva l'intero record di dati
; aggiunge all'elenco delle voci da comporre il dato riferito al campo attivo
Let sVoci = CambiaCampo (sVoci, StringSegment (sRecord, PIPE, iCampo), ULTIMA, sSeparatore)
EndFor; fine scansione chiavi
Return sVoci; restituisce il nuovo elenco con i dati
EndFunction

String Function InverteForma (string sTesto, int iTipo, string sRitorno)
If !sRitorno Then; se non  stata specificata alcuna stringa di fine riga alternativa,
Let sRitorno = RN; imposta come fine riga la sequenza classica, Ascii 13 e 10
EndIf; fine controllo caratteri di fine riga
If iTipo Then; se si  richiesta la conversione dai separatori di voce ai caratteri di fine riga,
Return StringReplaceSubstrings (sTesto, SPV,sRitorno); sostituisce i primi con i secondi
Else; altrimenti,
Return StringReplaceSubstrings (sTesto, sRitorno, SPV); cambia i fine riga con i separatori di voce
EndIf; fine controllo tipo conversione
EndFunction

String Function InserisceTesto (string sTitolo, string sTesto, ; primi due parametri,
int iMultiple, string sVietati, int iPipe); seconda riga con gli altri tre
Var
Int iStato, ; stato di attivazione della sintesi
String sPrefisso, ; testo da premettere al messaggio
String sMessaggio, ; testo informativo
String sBufferTitolo, ; eventuale precedente contenuto del titolo predefinito
String sBufferEtichette, ; eventuale precedente contenuto delle etichette dei pulsanti
Int iScelta, ; l'esito delle finestre di dialogo
String sDato; variabile temporanea

Let iStato = ControllaSintesi (TRUE, TRUE); riattiva la sintesi, annotandone il precedente stato
; cambia la forma della stringa da estesa a quella con ritorni a capo
Let sTesto = InverteForma (sTesto, TRUE)
If iMultiple Then; se il testo pu essere scritto su pi righe,
Let sPrefisso = msgRigheMultiple; imposta il prefisso da formattare nel messaggio
EndIf; fine controllo righe immissione
Let sMessaggio = FormatString (msgMettiTesto, sPrefisso); formatta il testo del messaggio
; memorizza i contenuti del titolo, e delle etichette dei pulsanti, della finestra di dialogo
ScambiaTitoli (FormatString (msg2Spazi, sTitolo, sMessaggio), sBufferTitolo, sBufferEtichette)
While iScelta <= FALSE ; continua finch il valore di controllo rimane non superiore a 0
Let sDato = sTesto; duplica la stringa, per non compromettere l'originale
Suona (INGRESSO_CAMPO); emette un suono di avvio editazione
Let iScelta = InputBox (sMessaggio, sTitolo, sDato); consente l'immissione o la modifica di una stringa
Suona (USCITA_CAMPO); emette un suono di uscita dall'editazione
If !sDato Then; se la stringa  vuota, anche per l'abbandono dell'inserimento,
Let iScelta = ChiedeConferma (ttlNoModifica, msgConferma, FALSE, SECONDA); propone la conferma
ElIf StringSegmentIndex (sVietati, BELL, StringLower (sDato), TRUE) Then; se il dato immesso  gi presente,
ChiedeConferma (FormatString (ttlPresenzaDato, gsTermine, sDato), msgAggiornaTesto, OK)
Let iScelta = FALSE; imposta il valore per il ritorno nel campo d'immissione
ElIf !iPipe && StringContains (sDato, PIPE) Then; se  stato inserito anche il carattere Pipe,
ChiedeConferma (ttlNoPipe, msgAggiornaTesto, OK)
Let iScelta = FALSE; imposta il valore per il ritorno nel campo d'immissione
Else; altrimenti, se un testo  stato immesso,
ControllaSintesi (iStato, TRUE); ripristina lo stato della sintesi all'ingresso nell'inserimento
ScambiaTitoli (NULLO, sBufferTitolo, sBufferEtichette); ripristina le variabili globali
If !iMultiple Then; se il dato  disposto su una riga,
Return TroncaTesto (sDato, CR); interrompe la stringa sino ad un eventuale primo ritorno a capo, erroneamente presente
Else; altrimenti, restituisce la stringa con gli eventuali ritorni a capo convertiti in separatori
Return InverteForma (sDato)
EndIf; fine controllo righe multiple
EndIf; fine controllo presenza stringa
EndWhile; fine ciclo immissione
ControllaSintesi (iStato, TRUE); ripristina lo stato della sintesi all'ingresso nell'inserimento
ScambiaTitoli (NULLO, sBufferTitolo, sBufferEtichette); ripristina le variabili globali,
Return NULLO; e restituisce una stringa vuota
EndFunction

Int Function ConfermaAzioni (string sTesto)
Var
String sValidi, ; elenco dei tasti archiviati come validi
String sDati, ; elenco dei dati immessi
Int j, ; contatore del ciclo principale
String sDato, ; singolo dato da controllare
Int k, ; contatore del secondo ciclo
String s, ; singolo frammento tra i segni di congiunzione
String sErrori, ; elenco degli errori riscontrati
String sTitolo, ; testo per la finestra di dialogo
Int x; contatore dell'ultimo ciclo

; rileva i tasti presenti nell'archivio dei validi, portandoli in caratteri minuscoli
Let sValidi = StringLower (LeggeChiavi (PERSONALE, ARCHIVIO + TASTI))
; mette dei caratteri di Nuova Linea, Ascii 10, al posto di eventuali separatori di voce
Let sDati = InverteForma (sTesto, TRUE, LF)
For j = 1 To StringSegmentCount (sDati, LF); scorre i dati passati tramite parametro
Let sDato = StringSegment (sDati, LF, j); estrae il singolo dato
If StringLength (sDato) > 1 Then; se il dato estratto  pi lungo di un carattere,
If !IsScriptKey (sDato) Then; se non  riconosciuto come un tasto utilizzato da qualche script,
; scorre i frammenti eventualmente divisi dal segno di congiunzione
For k = 1 To StringSegmentCount (sDato, SEGNO_PIU)
Let s = StringSegment (sDato, SEGNO_PIU, k); estrae il singolo frammento tra segni Pi
If StringLength (s) > 1 Then; se il frammento  pi lungo di un carattere,
If !StringSegmentIndex (sValidi, PIPE, StringLower (s), TRUE) Then; infine, se il frammento non  tra i tasti validi,
; aggiorna l'elenco dei tasti o frammenti non riconosciuti
Let sErrori = CambiaCampo (sErrori, s, ULTIMA, BELL)
EndIf; fine controllo tasti validi
EndIf; fine controllo lunghezza frammento
EndFor; fine scansione frammenti
EndIf; fine controllo tasti script
EndIf; fine controllo lunghezza dato
EndFor; fine scansione dati
If !sErrori Then; se i tasti sono stati tutti riconosciuti,
Return TRUE; restituisce l'esito positivo
Else; altrimenti, se vi sono dei tasti non riconosciuti,
; formatta il titolo, inserendo l'elenco degli errori riscontrati
Let sTitolo = FormatString (ttlArchiviaTasti, StringReplaceSubstrings (sErrori, PIPE, VIRGOLA_SPAZIO))
If ChiedeConferma (sTitolo, msgOkDati, FALSE, SECONDA) Then; se si confermano i dati immessi,
For x = 1 To StringSegmentCount (sErrori, BELL); scorre gli errori rilevati,
; e aggiorna l'archivio dei termini validi
ScriveNumerico (PS_FILE, ARCHIVIO + TASTI, StringSegment (sErrori, BELL, x), TRUE)
EndFor; fine scansione errori
Return TRUE; restituisce l'esito positivo
Else; altrimenti, se si annulla l'aggiornamento,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo conferma
EndIf; fine controllo presenza errori
EndFunction

String Function ChiaveGlobale ()
If gsChiave Then; se un dato  registrato,
Return gsChiave; lo restituisce
ElIf gsElenco Then; se un elenco di chiavi  impostato,
Return StringSegment (gsElenco, PIPE, PRIMA); restituisce la prima chiave di tale elenco,
Else; altrimenti, se il dato  ancora da impostare,
Return UNO; restituisce il primo valore in forma testuale
EndIf; fine controllo chiave
EndFunction

Int Function ScriveCampo (string sArchivio, string sSezione, string sChiave, string sDato)
Var String sRecord = LeggeRecord (sArchivio, sSezione, sChiave); dichiara e Legge i dati del record
Let gnCampo = CampoGlobale (); controlla l'impostazione del numero di campo
If !StringSegment (sRecord, PIPE, gnCampo) ; se il dato da scrivere non esiste,
&& gnTipo == TERZA Then; e se si sta operando su pi campi,
Let gnSalta = TRUE; imposta di saltare la successiva schermata di scelta
EndIf; fine controllo presenza dato
Let sRecord = CambiaCampo (sRecord, sDato, gnCampo); aggiorna il record inserendovi il dato
If ScriveRecord (sArchivio, sSezione, sChiave, sRecord) Then; se la scrittura riesce,
Return TRUE; restituisce l'esito positivo
Else; altrimenti, se la scrittura fallisce,
Let gnSalta = FALSE; cancella l'eventuale indicatore di salto impostato,
Return FALSE; e restituisce un risultato nullo
EndIf; fine controllo scrittura
EndFunction

Int Function AggiornaCampo (string sNome, string sSezione, ; primi due parametri,
string sChiave, string sDato); seconda riga con gli altri due
Var
String sPrefisso, ; stringa che nel messaggio precede l'oggetto della modifica
String sTesto, ; dato temporaneo
String sSuffisso, ; stringa che segue l'oggetto
String sTitolo, ; titolo per la finestra di input
String sVideo, ; elenco delle voci a video,
String sVietati, ; lista di termini da non inserire
Int iModifica; valore per l'uscita dal ciclo

; determina il prefisso del messaggio, sulla base del tipo di procedura e del campo attivi
Let sPrefisso = StringSegment (lstPrefissiTesto, PIPE, gnTipo + (gnCampo - 1))
; imposta anche il suffisso, con il criterio precedente, formattandovi il termine attivo
Let sSuffisso = FormatString (StringSegment (lstSuffissiTesto, PIPE, gnTipo + (gnCampo -1)), ComponeTermine ())
If !gsTermine Then; se nessun oggetto delle modifiche  stato impostato,
Let gsTermine = gsCategoria; inizializza il termine con la categoria
If gsTermine == MACRO Then; se si stanno elaborando delle macro,
Let gsTermine = gsTermine + gsOggetto; aggiunge anche l'oggetto
EndIf; fine controllo macro
EndIf; fine controllo oggetto delle modifiche
; crea il titolo della finestra d'inserimento testo
Let sTitolo = FormatString (ttlInputDato, sNome, sPrefisso, gsTermine, sSuffisso)
Let sTesto = sDato; duplica il testo inserito per il successivo confronto
If gnCampo == PRIMA Then; se si  nella schermata iniziale,
Let sVideo = StringLower (CreaElenco (gsArchivio, sSezione)); rileva le voci da non immettere,
Let sVietati = CambiaCampo (sVideo, StringLower (sDato), FALSE, BELL); e vi toglie il dato
EndIf; fine controllo campo
While !iModifica; continua finch il valore rimane a zero
Let sTesto = InserisceTesto (sTitolo, sTesto, gnMultiple, sVietati); memorizza il dato eventualmente immesso
SpeechOff (); spegne comunque la sintesi,
Let gnStato = TRUE; e ne imposta la riattivazione programmata
If !sTesto ; se nessun dato  presente,
|| sTesto == sDato Then; oppure, se il dato non  stato modificato,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo presenza dato
Let iModifica = TRUE; imposta il valore per l'uscita dal ciclo
If gsCategoria == SCRIPTS ; se si stanno elaborando gli script personali,
&& gnCampo == QUARTA Then; e si stanno modificando le azioni da compiere,
If !ConfermaAzioni (sTesto) Then; se i dati inseriti non sono stati riconosciuti,
Let iModifica = FALSE; annulla il valore per tornare all'inserimento
EndIf; fine controllo tasti validi
EndIf; fine controllo campo
EndWhile; fine ciclo modifica
If !sChiave Then; se una chiave non  stata specificata,
Let sChiave = ChiaveGlobale (); prende il valore dall'eventuale variabile, o dalla prima chiave nell'elenco
EndIf; fine controllo chiave
If !ScriveCampo (gsArchivio, sSezione, sChiave, sTesto) Then; se la scrittura fallisce,
Return FALSE; restituisce un risultato nullo
Else; altrimenti, se il dato  trascritto,
If gnCampo == PRIMA Then; se si  nella schermata iniziale,
Let gsChiave = sChiave; allinea il dato utilizzato,
; e aggiorna anche il puntatore dell'ultima voce elaborata
ScriveRecord (gsArchivio, sSezione, ZERO, gsChiave)
EndIf; fine controllo campo
Return TRUE; restituisce l'esito positivo
EndIf; fine controllo scrittura
EndFunction

Int Function CercaVoci (string sSezione, string sSuffisso)
Var String sChiavi; elenco delle chiavi rilevate

Let sChiavi = ChiaviUtente (gsArchivio, sSezione); rileva i dati registrati
If !sChiavi ; se nessuna chiave  ancora registrata nella sezione,
|| !StringSegmentIndex (sChiavi, PIPE, ZERO, TRUE) Then; oppure, se la chiave testuale Zero non  ancora stata registrata,
If !ScriveNumerico (gsArchivio, sSezione, ZERO, FALSE) Then; se la scrittura fallisce,
SayFormattedMessage (OT_ERROR, hlpErroreDato, SALVA); formatta e pronuncia l'avviso,
Return FALSE; e interrompe il flusso, restituendo un risultato nullo
EndIf; fine controllo scrittura chiave Zero
EndIf; fine controllo chiavi
Let gsElenco = CambiaCampo (sChiavi, ZERO); rende globale l'elenco delle chiavi, senza la zero
Let gnTotali = StringSegmentCount (gsElenco, PIPE); conta i campi ancora presenti
Let gsChiave = ChiaveGlobale (); imposta o ribadisce il dato registrato
Let gnCampo = CampoGlobale (); controlla l'impostazione del numero di campo
If LeggeCampo (gsArchivio, sSezione, gsChiave) ; se esiste un dato per il campo,
|| (gsCategoria == SCRIPTS ; oppure, se si stanno elaborando gli script personali,
&& gnCampo == gnMaxCampi) Then; e ci si trova nell'ultimo campo,
Return TRUE; restituisce l'esito positivo
ElIf gsCategoria == SCRIPTS; se si stanno solo elaborando gli script Personali,
&& gnCampo == SECONDA Then; ma si  nel secondo campo,
suona (Nota (gnCampo - 1), RITARDA); emette una nota ascendente
Let gnFerma = CATTURA; imposta il valore per l'attesa dei tasti,
Return FALSE; e torna alla funzione chiamante
Else; altrimenti, negli altri casi in cui manca il dato,
If gnTipo != TERZA ; se non si stanno elaborando pi campi,
|| gnCampo == PRIMA Then; oppure, se si  in ogni caso al primo campo,
If !ProsegueFlusso (gsCategoria, sSuffisso) ; se non si vuole proseguire,
Return FALSE; interrompe il flusso, restituendo un risultato nullo
EndIf; fine controllo conclusione
EndIf; fine controllo campo valido
suona (Nota (gnCampo - 1), RITARDA); emette una nota ascendente
If AggiornaCampo (AGGIUNGE, sSezione, gsChiave, NULLO); se l'aggiornamento riesce,
Pause ()
Let sChiavi = ChiaviUtente (gsArchivio, sSezione); rileva nuovamente i dati registrati, rimuovendo la chiave zero
Let gsElenco = CambiaCampo (sChiavi, ZERO);
Let gnTotali = StringSegmentCount (gsElenco, PIPE); quindi, riconta i campi dell'elenco,
Return TRUE; e restituisce l'esito positivo
EndIf; fine controllo aggiornamento
EndIf; fine controllo dato
Return FALSE; se nessun altro controllo ha interrotto il flusso, restituisce un risultato nullo
EndFunction

Int Function InizioRiga ()
Var String s; singolo carattere

; rileva il carattere iniziale della stringa, ottenuta controllando quello precedente
Let s = StringLeft (GetPriorCharacter (), PRIMA)
If !s ; se il carattere  vuoto,
|| s == CR; oppure,  un Ritorno a Capo,
|| s == LF Then; o, infine, un carattere di Nuova Linea,
Return TRUE; restituisce l'esito positivo
Else; altrimenti,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo posizione cursore
EndFunction

Int Function MisuraMovimento (int iVerso, int ByRef x)
Var
Int iStato, ; stato di attivazione della sintesi
Int c, ; prima rilevazione colonna
Int r, ; prima rilevazione riga
Int y, ; seconda rilevazione riga
String s; primo carattere della stringa ottenuta rilevando quello precedente

Let iStato = ControllaSintesi (FALSE); spegne la sintesi, memorizzandone lo stato
Let c = ValoreColonna (); registra il numero della colonna di partenza
Let r = ValoreRiga (); memorizza anche il numero di riga
If iVerso == AVANTI Then; Se ci si deve muovere in avanti,
NextCharacter (); chiama la funzione nativa
Else; altrimenti, per muoversi all'indietro,
PriorCharacter (); chiama l'altra funzione originale
EndIf; fine controllo direzione
Refresh (); resetta la schermata
Let x = ValoreColonna (); registra la nuova posizione orizzontale
Let y = ValoreRiga (); memorizza anche la nuova posizione verticale
ControllaSintesi (iStato); ripristina lo stato di attivazione precedente
If x != c ; se il cursore si  mosso in orizzontale,
|| y != r Then; oppure, se ha soltanto cambiato riga,
If (r == y && (x == (c +1) || x == (c - 1))) ; se la riga non  cambiata, e la colonna  diversa d 1,
|| (x == c && (r == (y + 1) || r == (y - 1))) Then; o invariata  la colonna, e la riga  spostata di 1,
Let gnRilevamento = FALSE; azzera il valore sulle modalit di rilevazione
ElIf InfoStato (RIGA, TRUE) Then; se invece i dati si possono rilevare dalla Barra di Stato,
Let gnRilevamento = PRIMA; annota di usare tale metodo
Else; altrimenti, se non si pu rilevare la posizione orizzontale,
Let gnRilevamento = SECONDA; imposta di portare comunque il cursore ad inizio riga
EndIf; fine controllo modalit rilevazione
If InizioRiga (); se ci si trova nella prima colonna,
Let x = 1; omologa la posizione di partenza, a prescindere dalla modalit di rilevazione
EndIf; fine controllo carattere precedente
Return TRUE; in ogni caso, restituisce l'esito positivo
Else; altrimenti, se il cursore non si  mosso,
Suona (ERRORE1); emette un segnale acustico
If iVerso == AVANTI Then; se ci si doveva spostare in avanti,
SayMessage (OT_ERROR, hlpFineFile, hlpFineFile_corto); pronuncia l'avviso,
Else; altrimenti, se ci si doveva muovere all'indietro,
SayMessage (OT_ERROR, hlpInizioFile, hlpInizioFile_corto); pronuncia l'avviso,
EndIf; fine controllo direzione
Return FALSE; in ogni caso, restituisce un risultato nullo
EndIf; fine controllo movimento cursore
EndFunction

Void Function PosizioneDocumento ()
Var Int iPosiz; percentuale nel documento corrente

SpeechOn (); riattiva la sintesi
If !gnPrimo Then; se si  al primo passaggio,
SayMessage (OT_ERROR, hlpPremiEsc); avvisa di fermare la ricerca premendo il tasto Escape,
Let gnPrimo = TRUE; e imposta il valore per impedirne la rilettura
Else; altrimenti,
Let iPosiz = GetDocumentPercentage (); rileva la posizione in percentuale rispetto al documento
If iPosiz Then; se una percentuale  stata rilevata,
; formatta e pronuncia il valore rilevato
SayFormattedMessage (OT_ERROR, msgPercento, NULLO, iPosiz)
Else; altrimenti,
; formatta e pronuncia il numero della riga corrente
SayFormattedMessage (OT_ERROR, msg1, NULLO, gnValore)
EndIf; fine controllo percentuale
EndIf; fine controllo avvisi
SpeechOff (); spegne la sintesi
EndFunction

String Function CercaElementi (string sTesto, int iPartenza)
Var
Int i, ; contatore del ciclo
String sElemento, ; stringa da cercare
Int iTipo; modalit di ricerca

For i = 1 To gnTotali; scorre gli elementi rilevati
Let sElemento = StringSegment (gsElenco, BELL, i); estrae il singolo termine da cercare
; controlla che il primo carattere dell'elemento non sia quello che indica di cercare dentro alla riga
If !StringStartsWith (sElemento, RICERCA_INTERNA) Then; se tale carattere non ,
Let iTipo = INIZIO; imposta di cercare ad inizio riga
Else; altrimenti, se il carattere segnalatore  presente,
Let iTipo = INTERNO; imposta il valore per la ricerca all'interno,
Let sElemento = StringChopLeft (sElemento, StringLength (RICERCA_INTERNA)); e lo rimuove
EndIf; fine controllo tipo ricerca
If iPartenza <= PRIMA ; se la ricerca pu partire dalla prima colonna,
&& iTipo == INIZIO Then; ed  da l che bisogna cercare,
If StringStartsWith (sTesto, sElemento) Then; se il termine  coincide,
Return sElemento; restituisce l'elemento trovato
EndIf; fine controllo presenza all'inizio
ElIf iTipo == INTERNO Then; se l'elemento va cercato invece dentro alla riga,
If StringContains (sTesto, sElemento) Then; se l'elemento  stato trovato,
Return sElemento; lo restituisce
EndIf; fine controllo ritrovamento interno
EndIf; fine controllo ritrovamenti
EndFor; fine scansione elementi
Return NULLO; se nessun altro controllo  intervenuto, restituisce una stringa vuota
EndFunction

Void Function AnnullaProgrammato ()
If gnProgrammato Then; se l'avvio programmato era stato impostato,
UnScheduleFunction (gnProgrammato); lo annulla,
Let gnProgrammato = FALSE; e resetta il valore
EndIf; fine controllo programmazione
EndFunction

Void Function SpostaAElemento (string sElemento, int iPartenza)
Var
Int iPosiz, ; posizione dell'elemento da sinistra nella riga
Int iContraria, ; posizione dell'elemento da destra
Int iAttuale, ; posizione corrente del cursore
Int i; contatore del ciclo

If gnVerso == AVANTI Then; se  attiva la ricerca verso il basso,
; registra la posizione dell'elemento, aggiungendo il valore di partenza
Let iPosiz = iPartenza + StringContains (gsRiga, sElemento)
Else; altrimenti, se si sta cercando verso l'alto,
; registra la posizione, invertendo la stringa in cui cercare
Let iContraria = StringContains (StringReverse (gsRiga), StringReverse (sElemento))
; calcola l'effettiva posizione del cursore, partendo da sinistra
Let iPosiz = StringLength (gsRiga) - ((iContraria + StringLength (sElemento)) - 2)
EndIf; fine controllo posizione
If !iPosiz Then; se per qualche motivo il valore  a zero,
Let iPosiz = PRIMA; imposta il valore alla prima colonna
EndIf; fine controllo colonna finale
If !gnRilevamento Then; se il dato pu essere rilevato direttamente,
Let iAttuale = ValoreColonna (); memorizza il numero della colonna corrente
ElIf gnRilevamento == 1 Then; se invece si  impostata la prima modalit alternativa,
Let iAttuale = StringToInt (InfoStato (COLONNA, IsSameScript ())); lo prende dalla Barra di Stato
EndIf; fine controllo rilevazione dati
If gnRilevamento == SECONDA Then; se si  impostato di portarsi comunque ad inizio riga,
If !InizioRiga () Then; se non si  gi sulla prima colonna,
JawsHome (); si sposta ad inizio riga
EndIf; fine controllo posizione cursore
ElIf iAttuale != iPosiz Then; se invece la posizione corrente e quella definitiva sono diverse,
For i = 1 To Abs (iAttuale - iPosiz); esegue il numero assoluto degli spostamenti
If iAttuale < iPosiz Then; se la posizione corrente  minore della definitiva,
NextCharacter (); si muove di un carattere in avanti
Else; altrimenti,
PriorCharacter (); torna di un carattere all'indietro
EndIf; fine controllo direzione
EndFor; fine ciclo movimenti
EndIf; fine controllo posizioni
Suona (ARRIVO); avvisa dello spostamento
SpeechOn (); riattiva la sintesi
SayFromCursor (); legge dal cursore sino a fine riga
EndFunction

Void Function ScorreRighe (int iPartenza)
Var
Int iStart, ; tempo d'inizio della procedura
String sTesto, ; testo senza spazi e tabulazioni
String sElemento, ; singolo elemento di ricerca
Int iEstremi; indicatore di raggiunto limite del documento

If !iPartenza Then; se non si  all'inizio della ricerca,
PosizioneDocumento (); legge la percentuale o le righe del documento corrente, oppure altri tipi di avviso
ElIf gnVerso == INDIETRO Then; se in ogni caso la ricerca  verso l'alto,
Let iPartenza = FALSE; resetta il valore
EndIf; fine controllo parametri
Let iStart = GetTickCount (); registra il momento d'inizio della procedura
; lancia l'eventuale nuovo avvio programmato della funzione
AnnullaProgrammato (); resetta la programmazione di una nuova ricerca
Let gnProgrammato = ScheduleFunction (SCORRE_RIGHE, MAX_RICERCA / 100)
; continua il ciclo finch la programmazione non sia interrotta o si superi il tempo massimo
While gnProgrammato && (GetTickCount () - iStart) < MAX_RICERCA
; rimuove dalla stringa memorizzata spazi iniziali e finali, e caratteri di tabulazione
Let sTesto = TagliaSpazi (ToglieTab (gsRiga))
If sTesto Then; se vi  ancora del contenuto nella riga,
Let sElemento = CercaElementi (sTesto, iPartenza); esegue la ricerca degli elementi
If sElemento Then; se un elemento  stato trovato,
AnnullaProgrammato (); resetta la programmazione di una nuova ricerca
SpostaAElemento (sElemento, iPartenza); sposta il cursore all'inizio dell'elemento trovato,
Return; e interrompe il flusso
EndIf; fine controllo esito
EndIf; fine controllo testo
If gnProgrammato Then; se nessun elemento  stato ancora trovato,
If GetCurrentScriptKeyName () == ESC Then; se si  premuto il tasto Escape,
SpeechOn (); riattiva la sintesi
SayMessage (OT_ERROR, msgStopRicerca); avvisa dell'azione,
AnnullaProgrammato (); e resetta la programmazione di una nuova ricerca, interrompendo il ciclo
Else; altrimenti, se la ricerca continua,
If gnVerso == AVANTI Then; se la ricerca avviene verso il basso,
NextLine (); si muove alla riga successiva
Else; Altrimenti,
PriorLine (); torna alla riga precedente
EndIf; fine controllo direzione
Refresh (); resetta la schermata
Let gsRiga = StringLower (RigaCorrente ()); registra la riga sul cursore, portandola in minuscolo
If gsRiga == gsPrecedente Then; se la riga attuale  la stessa della precedente,
Let gnRipeti = gnRipeti + 1; aggiorna il contatore
Else; altrimenti,
Let gsPrecedente = gsRiga; aggiorna la variabile globale
Let gnRipeti = FALSE; e resetta il contatore
EndIf; fine controllo riga precedente
If gnRipeti < MAX_RIGHE Then; se non si  raggiunto il limite massimo delle ripetizioni,
If iPartenza Then; se il valore  impostato,
Let iPartenza = FALSE; lo resetta
EndIf; fine controllo impostazione iniziale
Else; Altrimenti, se si  raggiunta una delle due estremit del documento,
AnnullaProgrammato (); resetta la programmazione di una nuova ricerca
Let iEstremi = TRUE; annota la situazione
EndIf; fine controllo posizione
EndIf; fine controllo prosecuzione ricerca
EndIf; fine controllo ritrovamento e tasti premuti
EndWhile; fine ciclo ricerca
If !gnProgrammato Then; se non  impostato alcun riavvio della funzione,
SpeechOn (); riattiva la sintesi
If iEstremi Then; se  stata raggiunta un'estremit del documento,
If gnVerso == AVANTI Then; se ci si doveva muovere verso il basso, formatta e legge l'avviso
SayFormattedMessage (OT_ERROR, ttlContinuaCerca, StringChopLeft (msgFine, 3), _A, msgFine)
Else; altrimenti, in caso di ricerca verso l'alto, formatta e pronuncia l'avviso
SayFormattedMessage (OT_ERROR, ttlContinuaCerca, StringChopLeft (msgInizio, 2), _O, msgInizio)
EndIf; fine controllo direzione
EndIf; fine controllo estremi documento
SayLine ()
EndIf; fine controllo funzioni
EndFunction

Void Function MuoveDato (string sEstensione, string sProg, int iAiuto)
Var
String sSezione, ; nome della sezione da elaborare
Int iPartenza; colonna da dove  partita la ricerca

If gsCategoria == COMMENTO Then; se si sta cercando un commento ad inizio riga,
Let gsElenco = PUNTO_VIRGOLA; pone il carattere omonimo come unico elemento da cercare
Let gnTotali = 1; Imposta il valore
ElIf gsCategoria == SINGOLO Then; ancora, se il dato da cercare  un singolo elemento di ricerca,
Let gsCategoria = ELEMENTO; imposta la categoria reale
If !ArchivioDati () Then; se il file di configurazione  mancante o incompleto,
Return; interrompe il flusso
EndIf; fine controllo file configurazione
Let sSezione = gsCategoria + sEstensione; compone la sezione dove leggere i dati
Let gsElenco = StringLower (LeggeRecord (gsArchivio, sSezione, sProg)); tenta di rilevare il dato, portandolo casomai in minuscolo
If !gsElenco Then; se il dato non  registrato,
TypeCurrentScriptKey (); ripete i tasti premuti,
Return; e interrompe il flusso
EndIf; fine controllo dati
Let gnTotali = 1; Imposta il valore
ElIf SiamoNellaFinestra (MANAGER) ; se si  nell'Editor di Script,
&& sEstensione == JSS Then; e se si sta elaborando un file script,
If gsOggetto == SUCCESSIVO Then; se la ricerca   verso il basso,
TypeKey (F2); richiama il relativo comando originale
Else; altrimenti, se la ricerca  verso l'alto,
TypeKey (SHIFT_F2); richiama il relativo comando originale
EndIf; fine controllo direzione
Refresh (); resetta la schermata
SayLine (); legge la riga corrente,
Return; e interrompe il flusso
ElIf gsCategoria == ELEMENTO Then; se invece si deve cercare tra gli elementi registrati per l'estensione corrente,
If !ArchivioDati () Then; se il file di configurazione  mancante o errato,
Return; interrompe il flusso
EndIf; fine controllo archivio dati
Let sSezione = gsCategoria + sEstensione; compone la sezione dove leggere i dati
CercaVoci (sSezione, sEstensione); raccoglie i dati
If !gnTotali Then; se nessuna voce  ancora registrata,
Return; interrompe il flusso
EndIf; fine controllo numero voci
; compone la lista delle voci da cercare, portandole in caratteri minuscoli
Let gsElenco = StringLower (CreaElenco (gsArchivio, sSezione, PRIMA))
Let gnTotali = StringSegmentCount (gsElenco, BELL); aggiorna il numero delle voci valide per la ricerca
EndIf; fine controllo categorie
If gsOggetto == SUCCESSIVO Then; se la ricerca   verso il basso,
Let gnVerso = AVANTI; imposta il valore corrispondente alla direzione indicata
Else; altrimenti, se si deve cercare verso l'alto,
Let gnVerso = INDIETRO; imposta il valore corrispondente alla direzione indicata
EndIf; fine controllo direzione
If !MisuraMovimento (gnVerso, iPartenza) Then; se il cursore  fermo a fine o inizio documento,
Return; interrompe il flusso
EndIf; fine controllo spostamento
Let gsRiga = RigaCorrente (gnVerso); rileva il testo sulla base del verso impostato
Let gnPrimo = FALSE; azzera il valore per far leggere le istruzioni su come interrompere la ricerca
SpeechOff (); spegne la sintesi
ScorreRighe (iPartenza); chiama l'apposita funzione, specificando i parametri della ricerca iniziale
EndFunction

Script MuoveCommentoPrecedente ()
GestisceDato ()
EndScript

Script MuoveCommentoSuccessivo ()
GestisceDato ()
EndScript

Void Function ResettaCampi ()
; annulla il contenuto delle variabili globali per:
Let gnAggiorna = FALSE; indicatore d'uscita dal ciclo interno
Let gnCampo = FALSE; campo di elaborazione
Let gnConferma = FALSE; conferme all'uscita
Let gnConta = FALSE; contatore delle chiavi temporanee
Let gnEcoTastiera = FALSE; valore corrente dell'omonima impostazione
Let gnFerma = FALSE; indicatore del tipo d'interruzione
Let gnLivello = FALSE; ultimo campo trattato
Let gnMaxCampi = FALSE; numero complessivo dei campi
Let gnMaxVoci = FALSE; numero delle voci possibili
Let gnMultiple = FALSE; inserimento su pi righe
Let gnNumerico = FALSE; prefisso numerico alle voci di scelta
Let gnNuovoScript = FALSE; indicatore di un nuovo script
Let gnProgrammato = FALSE; identificativo di un avvio programmato
Let gnSalta = FALSE; indicatore di salto dei controlli
Let gnScriveTasto = FALSE; trascrizione dei tasti premuti
Let gnStato = FALSE; stato di attivazione della sintesi vocale
Let gnTasto = FALSE; numero del tasto opzionale
Let gnTipo = FALSE; tipologia di procedura
Let gnTotali = FALSE; voci complessive registrate
Let gnValore = FALSE; valore temporaneo
Let gnVoce = FALSE; valore della voce attiva
Let gsAmbito = NULLO; ultimo ambito registrato
Let gsArchivio = NULLO; nome del file di configurazione
Let gsAttiva = NULLO; chiave della voce attiva
Let gsAvviso = NULLO; informazioni dalla procedura
Let gsCategoria = NULLO; tipologia di procedura
Let gsChiama = NULLO; prefisso della funzione chiamata a fine procedura
Let gsChiave = NULLO; chiave attiva del record
Let gsElenco = NULLO; chiavi valide del record
Let gsEtichette = NULLO; elenco dei pulsanti validi
Let gsInfo = NULLO; testo per i messaggi della procedura
Let gsMassimi = NULLO; elenco dei valori massimi per una voce
Let gsMinimi = NULLO; elenco dei possibili valori minimi
Let gsNuoviTasti = NULLO; chiavi dei record con Tasti di attivazione modificati
Let gsOggetto = NULLO; soggetto dell'azione da compiere

Let gsSezione = NULLO; sezione dell'archivio in cui operare
Let gsSuffisso = NULLO; estensione o nome file del documento corrente
Let gsTastiScript = NULLO; Tasti di attivazione dello script
Let gsTermine = NULLO; termine da formattare nei messaggi
Let gsTitolo = NULLO; titolo per la finestra di dialogo
Let gsVoce = NULLO; contenuto della voce attiva
EndFunction

Void Function PronunciaUscita ()
suona (ULTIMO_SEGNO); emette un arpeggio discendente
If IsSpeechOff () Then; se la sintesi  spenta,
SpeechOn (TRUE); la riattiva
EndIf; fine controllo stato sintesi
ResettaCampi (); ripulisce la memoria dalle impostazioni,
Refresh (); resetta anche la schermata,
SayLine (); e pronuncia il contenuto della riga corrente
EndFunction

Int Function RilevaCampi ()
Var
String sSezioni, ; elenco delle sezioni rilevate
Int iSezioni, ; numero delle sezioni
Int i, ; contatore del ciclo
String sSezione, ; singola sezione estratta
String sSuffisso, ; suffisso numerico in forma testuale
String sTesto, ; prima parte del nome di sezione
Int iValore, ; variabile temporanea
Int iMassimo, ; valore massimo di un campo valido rilevato
String sNumeri, ; elenco dei valori abbinati alle etichette dei campi
String sMessaggio; eventuale avviso per errore nei dati dei campi

While !sNumeri; continua finch l'elenco dei campi rimane vuoto
Let sSezioni = SezioniUtente (gsCategoria); memorizza tutte le sezioni presenti
Let iSezioni = StringSegmentCount (sSezioni, PIPE); conta le sezioni rilevate
For i = 1 To iSezioni; scorre le sezioni nell'archivio
Let sSezione = StringSegment (sSezioni, PIPE, i); estrae la singola sezione
If sSezione != ELABORA Then; se i dati non sono per le impostazioni della singola procedura,
; estrae un eventuale suffisso numerico dalla stringa
Let sSuffisso = EstraeNumero (sTesto, sSezione)
Let iValore = StringToInt (sSuffisso); prova a convertire in numero il suffisso testuale
If sTesto != CAMPO ; se la prima parte della sezione e del prefisso standard sono diverse,
|| !iValore Then; oppure, il suffisso numerico non  un numero valido,
Let i = iSezioni + 1; cambia il contatore, per l'uscita immediata dal ciclo
Else; altrimenti, se il controllo  regolare,
Let sNumeri = CambiaCampo (sNumeri, sSuffisso, ULTIMA); ne aggiunge il dato in coda
If iValore > iMassimo Then; se il suffisso ha un valore maggiore tra quelli rilevati,
Let iMassimo = iValore; aggiorna la variabile
EndIf; fine controllo valore massimo
EndIf; fine controllo ripetizioni
EndIf; fine controllo sezione
EndFor; fine scansione sezioni
Let gnMaxCampi = StringSegmentCount (sNumeri, PIPE); conta i campi validi rilevati
If !gnMaxCampi ; se nessuna sezione  stata trovata,
|| iMassimo != gnMaxCampi Then; oppure, se il numero massimo rilevato non  il totale dei campi,
If !gnMaxCampi && !sSezioni Then; se, oltre ai campi, manca pure il file configurazione,
Let sMessaggio = msgNoFileCampi; imposta la base per segnalarne l'assenza
Else; altrimenti, se non vi sono campi validi, o non in numero sufficiente,
Let sMessaggio = msgNoCampiValidi; imposta la relativa base
EndIf; fine controllo tipo errore
; se si conferma di avviarne la creazione,
If ChiedeConferma (FormatString (sMessaggio, gsCategoria)) Then
; cancella l'eventuale versione esistente del file,
DeleteFile (FormatString (msg2Controbarra, GetUserSettingsDirectory (), gsCategoria + JCF))
Let sNumeri = NULLO; e resetta il dato per riavviare il ciclo di inserimento
If !ConfigurazioneCampi () Then; se i campi non sono stati impostati,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo impostazione campi
Else; altrimenti, se non si conferma la configurazione dei campi,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo conferma
Else; altrimenti, se tutti i controlli sono regolari,
Return TRUE; restituisce l'esito positivo
EndIf; fine controllo esito
EndWhile; fine del ciclo principale
EndFunction

Int Function NumeroDati (string sChiave, string ByRef sRecord)
Let sRecord = LeggeRecord (gsArchivio, gsSezione, sChiave); rileva il record di dati
; se il numero dei campi del record coincide con quelli rilevati nell'archivio,
If StringSegmentCount (sRecord, PIPE) == gnMaxCampi Then
Return TRUE; restituisce l'esito positivo
Else; altrimenti,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo numero dati
EndFunction

Int Function CampoTrovato (string sRecord, string sCampo, ; primi due parametri,
int ByRef iPosiz, string ByRef sSeparatore); seconda riga con gli altri due
ImpostaPipe (sSeparatore); se non lo si specifica, imposta come separatore il carattere Pipe
; cerca il contenuto del campo richiesto
Let iPosiz = StringSegmentIndex (StringLower (sRecord), sSeparatore, StringLower (sCampo), TRUE)
If iPosiz Then; se un campo  stato trovato,
Return TRUE; restituisce l'esito positivo
Else; altrimenti,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo esito ricerca
EndFunction

Int Function AggiornaTasti (int iTipo, string sChiave)
Var
String sElenco, ; elenco delle chiavi rilevate
Int i, ; contatore di un primo ciclo
String sSezTasti, ; sezione del file tasti
Int j, ; contatore del ciclo generale per le sezioni
Int k, ; contatore del ciclo secondario per le chiavi
Int l, ; contatore del ciclo secondario sugli script
String sRecord, ; Dati dello script
String sTasti, ; tasti di attivazione degli script personali
String sNomi, ; nomi reali degli script
String sChiavi, ; elenco delle combinazioni tasti
String sSezioni, ; elenco delle sezioni del file tasti da elaborare
String sTasto, ; singola combinazione di tasti
String sNome, ; nome dello script
String sDato, ; eventuale nome precedente
Int iPosiz, ; posizione del campo nel record
Int iCambiare, ; numero degli script da aggiornare
Int iModificati, ; script effettivamente cambiati
Int iScript, ; numero degli script personali rilevati
String sElaborati; script personali gi trattati

If iTipo == TUTTI Then; se si devono controllare le combinazioni tasti di tutti gli script,
Let sElenco = LeggeChiavi (CORRENTE, gsSezione); rileva le chiavi dall'archivio
ElIf iTipo == CANCELLA Then; se invece ci sono da rimuovere i tasti dello script corrente,
If sChiave Then; se si  specificata una chiave come parametro,
Let sElenco = sChiave; la imposta
Else; altrimenti,
Let sElenco = gsChiave; imposta la chiave attiva
EndIf; fine controllo chiave
Else; altrimenti, se si devono aggiornare gli script modificati durante la sessione,
Let sElenco = gsNuoviTasti; imposta il contenuto dell'apposita variante globale
EndIf; fine controllo elenco chiavi
If !sElenco ; se nessuna chiave  stata rilevata,
&& iTipo != TUTTI Then; e non si  prevista un'analisi globale del file tasti,
Return; interrompe il flusso
EndIf; fine controllo chiavi
If iTipo == CANCELLA Then; se si deve soltanto rimuovere una voce,
Let sTasti = gsRimuoviTasti;imposta la combinazione salvata
; e compone anche il relativo nome reale di script
Let sNomi = FormatString (msgPersonalScript, sElenco)
Else; altrimenti, negli altri casi,
For i = 1 To StringSegmentCount (sElenco, PIPE); scorre le chiavi relative agli script personali
Let sChiave = StringSegment (sElenco, PIPE, i); estrae la singola chiave
If NumeroDati (sChiave, sRecord) Then; se i dati sono presenti nel numero corretto,
; aggiorna gli elenchi, aggiungendo la nuova voce in coda, relativi a:
Let sTasti = CambiaCampo (sTasti, StringSegment (sRecord, PIPE, SECONDA), ULTIMA); tasti
Let sNomi = CambiaCampo (sNomi, FormatString (msgPersonalScript, sChiave), ULTIMA); nomi reali
EndIf; fine controllo numero dati
EndFor; fine scansione chiavi
EndIf; fine controllo tipo aggiornamento
Let iScript = StringSegmentCount (sTasti, PIPE); conta gli eventuali script personali rilevati
Let sSezioni = ElencoSezioni (); imposta le sezioni del file tasti da elaborare,
For j = 1 To StringSegmentCount (sSezioni, PIPE); e le scorre
Let sSezTasti = StringSegment (sSezioni, PIPE, j); estrae la singola sezione da elaborare
If iTipo == CANCELLA Then; se si deve solo cancellare una combinazione tasti,
Let sDato = LeggeDato (APP, sSezTasti, sTasti); rileva il dato dal file tasti corrente
If sDato ; se un nome script abbinato  stato rilevato,
&& sDato == sNomi Then; e coincide con il nome da cancellare,
If CancellaChiave (APP, sSezTasti, sTasti) Then; se la rimozione riesce,
Return TRUE; restituisce l'esito positivo
Else; altrimenti,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo cancellazione
EndIf; fine controllo dato
Else; altrimenti, se si devono comunque controllare tutte le combinazioni tasti,
Let sChiavi = LeggeChiavi (APP, sSezTasti); rileva l'elenco delle combinazioni tasti
Let sElaborati = NULLO; resetta il dato
For k = 1 To StringSegmentCount (sChiavi, PIPE); scorre le combinazioni di tasti
Let sTasto = StringSegment (sChiavi, PIPE, k); estrae la singola chiave delle assegnazioni
Let sDato = LeggeDato (APP, sSezTasti, sTasto); rileva il nome dello script abbinato
; se la combinazione  tra quelle degli script personali,
If CampoTrovato (sTasti, sTasto, iPosiz) Then
Let sElaborati = CambiaCampo (sElaborati, IntToString (iPosiz), ULTIMA); la aggiunge ad un elenco
Let sNome = StringSegment (sNomi, PIPE, iPosiz); estrae anche il nome reale dello script personale
If sNome != sDato Then; se il nome abbinato  diverso da quello da scrivere,
Let iCambiare = iCambiare + 1; aggiorna il contatore dei dati da aggiornare
If ScriveDato (APP, sSezTasti, sTasto, sNome) Then; se la nuova combinazione  salvata,
Let iModificati = iModificati + 1; aggiorna il contatore dei dati cambiati
EndIf; fine controllo scrittura
EndIf; fine controllo nome
ElIf iTipo == TUTTI Then; se invece l'analisi  estesa a tutti gli script,
If ScriptPersonale (sDato) Then; se si tratta di uno script personale,quindi non valido,
If sTasto Then; se un tasto di cui eliminare l'assegnazione  impostato,
CancellaChiave (APP, sSezTasti, sTasto); rimuove l'assegnazione
EndIf; fine controllo presenza chiave
EndIf; fine controllo validit nome
EndIf; fine controllo combinazioni tasti
EndFor; fine scansione chiavi
If StringSegmentCount (sElaborati, PIPE) < iScript Then; se non tutti gli script sono gi presenti,
For l = 1 To iScript; scorre i dati degli script personali
If !CampoTrovato (sElaborati, IntToString (l)) Then; se lo script non  gi stato trattato,
Let iCambiare = iCambiare + 1; aggiorna il contatore dei dati da aggiornare
Let sTasto = StringSegment (sTasti, PIPE, l); estrae la chiave con i tasti
Let sNome = StringSegment (sNomi, PIPE, l); estrae anche il nome reale dello script
If ScriveDato (APP, sSezTasti, sTasto, sNome) Then; se la nuova combinazione  salvata,
Let iModificati = iModificati + 1; aggiorna il contatore dei dati cambiati
EndIf; fine controllo scrittura
EndIf; fine controllo presenza elaborati
EndFor; fine scansione script
EndIf; fine controllo numero elaborati
EndIf; fine controllo tipo azione
EndFor; fine scansione sezioni
If iCambiare == iModificati Then; se il numero delle modifiche coincide con quelle da effettuare,
Return iModificati; restituisce il numero dei tasti di attivazione aggiornati
Else; altrimenti,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo esito aggiornamento

EndFunction

Int Function InizializzaProcedura (string sSuffisso)
If gnSalta Then; se si  dopo la procedura di attesa tasti,
If gnFerma Then; se dei tasti sono stati specificati,
Let gnCampo = gnCampo + 1; consente di passare alla schermata successiva
Let gnFerma = FALSE; annulla il valore
Else; altrimenti,
Let gnSalta = FALSE; annulla il valore per il salto della schermata di scelta
EndIf; fine controllo aggiornamenti
Else; altrimenti, in tutti gli altri casi, inizializza il lavoro
If !RilevaCampi () Then; se il rilevamento dei campi ha generato un errore,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo campi validi
Let gsSuffisso = sSuffisso; rende globale anche il suffisso specificato
Let gnCampo = PRIMA; imposta il valore per la schermata iniziale
If gsCategoria == SCRIPTS Then; se si stanno elaborando gli script a gestione personale,
Let gsSezione = gsCategoria + gsOggetto; compone la sezione nell'archivio dati
AggiornaTasti (TUTTI); Controlla che le assegnazioni degli script personali siano corrette
Else; altrimenti, in tutti gli altri casi, la compone aggiungendovi l'estensione
Let gsSezione = gsCategoria + gsOggetto + gsSuffisso
EndIf; fine controllo categoria
EndIf; fine controllo impostazioni
Return TRUE; restituisce l'esito positivo
EndFunction

Void Function AvviaHook ()
Suona (INGRESSO_CAMPO); emette un suono di avvio editazione
SetJcfOption(OPT_TYPING_ECHO, 1); imposta lecho di digitazione nello stato di Caratteri.
AddHook (HK_SCRIPT, TASTI_HOOK) ; attiva l'hook per la cattura dei tasti
SetLastScriptKey (NULLO); azzera i tasti appena premuti
TrapKeys (TRUE); indica a JAWS di ignorare qualsiasi tasto non collegato a script
; cancella la sezione con i dati nell'archivio temporaneo
IniRemoveSection (TASTI, NomeArchivio (TEMPORANEO))
Let gnConta = FALSE; resetta il valore
Let gnScriveTasto = TRUE; attiva la cattura dei tasti
; formatta e legge il messaggio che invita a premere i tasti di attivazione dello script
SayFormattedMessage (OT_HELP, msgAttivazione, NULLO, gsAttiva)
EndFunction

Void Function FermaHook ()
Suona (USCITA_CAMPO); emette un suono di uscita dall'editazione
Let gnScriveTasto = FALSE; ferma la cattura dei tasti
RemoveHook (HK_SCRIPT, TASTI_HOOK) ; disattiva lhook
TrapKeys(FALSE) ; ritorna a far riconoscere a Jaws tutti i tasti
SetJcfOption(OPT_TYPING_ECHO,gnEcoTastiera); ripristina l'eco tastiera originale
EndFunction

String Function ConverteTasti (string sTasti)
Var
Int j, ; contatore del ciclo principale
Int k, ; contatore del secondo ciclo
String sTasto, ; singolo tasto
String sPrefisso, ; singolo prefisso
String sNuova; la combinazione tasti espressa nella forma valida

; scorre le parti del nome separate dal segno unificatore
For j = 1 To StringSegmentCount (sTasti, SEGNO_PIU)
Let sTasto = StringSegment (sTasti, SEGNO_PIU, j); estrae il singolo tasto
If sTasto != FRECCIA_DESTRA ; se quello estratto non  il tasto indicato,
&& sTasto != FRECCIA_SINISTRA Then; e neppure il tasto freccia speculare,
For k = 1 To 2; scorre i due possibili prefissi errati
Let sPrefisso = StringSegment (lstPrefissiTasti, PIPE, k); estrae il singolo prefisso
If StringStartsWith (sTasto, sPrefisso) Then; se il tasto inizia con il prefisso elaborato,
Let sTasto = StringChopLeft (sTasto, StringLength (sPrefisso)); elimina il prefisso dal tasto
EndIf; fine controllo presenza prefisso
EndFor; fine scansione prefissi
EndIf; fine controllo tasti
Let sNuova = CambiaCampo (sNuova, sTasto, ULTIMA, SEGNO_PIU); frappone un segno Pi tra i tasti
EndFor; fine scansione tasti
Return sNuova; restituisce la stringa eventualmente modificata
EndFunction

String Function OrigineScript (string sNome, int ByRef iTipo)
Var
String sTasti, ; combinazione tasti che attiva lo script
String sFileOrigine, ; elenco dei file con le assegnazioni dei tasti
Int iFile, ; numero dei file tasti
String sArchivio, ; nome completo del file tasti da elaborare
String sSezioni, ; elenco delle sezioni del file tasti da elaborare
Int iNumSezioni, ; numero delle sezioni da elaborare
Int i, ; contatore del ciclo
Int k, ; numero progressivo della sezione elaborata
String sDato, ; dato temporaneo
String sChiave; suffisso numerico dello script

Let sTasti = GetScriptKeyName (sNome); rileva i tasti di attivazione dello script
Let sFileOrigine = ApplicativoCorrente () ; inizializza l'elenco con il nome del file tasti per l'applicazione attiva
If sFileOrigine != JAWS_FILE Then; se il nome non  quello dei file predefiniti di Jaws,
Let sFileOrigine = CambiaCampo (sFileOrigine, JAWS_FILE, ULTIMA); aggiunge il nome predefinito all'elenco
EndIf; fine controllo nome archivio
Let iFile = StringSegmentCount (sFileOrigine, PIPE); conta gli elementi dell'elenco appena creato
Let sSezioni = ElencoSezioni (); imposta le sezioni del file tasti da elaborare,
Let iNumSezioni = StringSegmentCount (sSezioni, PIPE); e ne conta il numero
Let i = PRIMA; inizializza il contatore dei file di origine dei tasti
While !sDato && i <= iFile ; continua finch non si trovi un dato, o vi siano file tasti da elaborare
; compone il nome del file tasti da leggere
Let sArchivio = StringSegment (sFileOrigine, PIPE, i) + JKM
Let k = PRIMA; inizializza il contatore delle sezioni
While !sDato && k < iNumSezioni; continua finch non si trovi un dato, o vi siano sezioni da elaborare
; tenta di leggere un dato dalla sezione estratta del file tasti nelle impostazioni personali
Let sDato = LeggeUtente (sArchivio, StringSegment (sSezioni, PIPE, k), sTasti)
Let k = k + 1; aggiorna il contatore
EndWhile; fine analisi sezioni
Let i = i +1; aggiorna il contatore
EndWhile; fine analisi file tasti
If sDato Then; se un dato  stato trovato,
If ScriptPersonale (sNome, sChiave) Then; se si tratta di uno script a gestione personale,
Let iTipo = GESTIONE; imposta un valore che identifica il tipo di script
Let sNome = LeggeCampo (NULLO, PERSONALI, sChiave, PRIMA); e rileva il nome virtuale dello script
Else; altrimenti, negli altri script creati dall'Utente,
Let iTipo = PERSONALE; imposta il valore relativo
EndIf; fine controllo tipo personale
Else; altrimenti, se si tratta di uno script originale di Jaws
Let iTipo = NATIVO ; ne imposta il valore
EndIf; fine controllo ricerca
Return FormatString (ttlTastiUtilizzati, StringSegment (lstTipiScript, PIPE, iTipo), sNome)
EndFunction

Void Function TastiHook (string sNomeScript)
Var
String sTasti, ; ultimi tasti premuti
String sTitolo, ; titolo per la schermata di scelta
Int iTipo, ; tipo di script rilevato
Int iOpzioni, ; scelte possibili nella finestra di dialogo
String sMessaggio, ; testo per il corpo della schermata di scelta
String sPrecedente; eventuale dato preesistente

Let gnFerma = FALSE; annulla l'eventuale valore impostato per attivare la funzione
Let sTasti = LeggeDato (TEMPORANEO, TASTI, IntToString (gnConta)); rileva gli ultimi tasti premuti
If GetScriptKeyName (sNomeScript) == INVIO ; se si  attivato uno script con Invio,
|| sTasti == INVIO Then; oppure, il tasto Invio  stato comunque premuto,
If !sTasti Then; se  presente solo un nome di script,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo presenza tasti
FermaHook (); disattiva l'hook
If gnConta <SECONDA Then; se non si sono specificati dei tasti,
If ChiedeConferma (ttlNoPremuti, msgTornaImmissione) Then; se si  deciso di riprovare l'immissione,
AvviaHook (); riavvia la funzione,
Return FALSE; e interrompe il flusso
Else; altrimenti, se si abbandona l'immissione,
suona (ERRORE2); emette un segnale acustico,
Let sTasti = NULLO; e resetta il dato
EndIf; fine controllo scelta
Else; altrimenti, se la conclusione  regolare,
Let sTasti = LeggeDato (TEMPORANEO, TASTI, IntToString (gnConta - 1))
EndIf; fine controllo pressione tasti
ElIf GetScriptKeyName (sNomeScript) == ESC ; se invece si  attivato uno script con Esc,
|| sTasti == ESC Then; oppure, il tasto Esc  stato comunque premuto,
If !sTasti Then; se  presente solo un nome di script,
Return FALSE; restituisce un risultato nullo
EndIf; fine controllo presenza tasti
FermaHook (); disattiva l'hook
If !ChiedeConferma (ttlAbbandono, NULLO, FALSE, SECONDA) Then; se si si riprova l'immissione,
AvviaHook (); riavvia la funzione,
Return FALSE; e interrompe il flusso
Else; altrimenti, se si abbandona l'immissione,
suona (ERRORE2); emette un segnale acustico,
Let sTasti = NULLO; e resetta il dato
EndIf; fine controllo scelta
ElIf sTasti == INSERT_T ; se si sono premuti i tasti per la lettura del titolo,
|| sTasti == JAWSKEY_T Then; oppure, si sono premuti gli altri tasti per lo script,
SayFormattedMessage (OT_HELP, msgAttivazione, NULLO, gsAttiva); legge il titolo,
CancellaChiave (TEMPORANEO, TASTI, IntToString (gnConta)); rimuove la registrazione dei tasti,
Let gnConta = gnConta - 1; toglie un'unit al contatore,
Return FALSE; E interrompe il flusso
Else; altrimenti, alla pressione di tasti abbinati ad un qualsiasi altro script,
FermaHook (); disattiva temporaneamente l'hook
; formatta il titolo della schermata controllandone l'origine
Let sTitolo = OrigineScript (sNomeScript, iTipo)
If iTipo == GESTIONE Then; se si tratta di uno script a gestione personale,
Let iOpzioni = OK; imposta di proporre una sola conferma senza scelta
Let sMessaggio = msgCambiaTasti; e imposta anche il messaggio invitando a modificare i tasti
Else; altrimenti, in tutti gli altri casi,
Let iOpzioni = FALSE; lascia le scelte predefinite, con Ok e Annulla,
Let sMessaggio = msgTastiUtilizzati; e imposta l'avviso di sovrascrittura
EndIf; fine controllo tipo script
; propone una finestra di scelta dove confermare la sovrascrittura dei tasti gi presenti
If !ChiedeConferma (sTitolo, sMessaggio, iOpzioni, SECONDA) ; se non la si conferma,
|| iTipo == GESTIONE Then; o i tasti premuti appartengono ad uno script a gestione personale,
AvviaHook (); riavvia la funzione,
Return FALSE; e interrompe il flusso
EndIf; fine controllo scelta
EndIf; fine controllo tasti premuti
; registra l'eventuale dato gi presente
Let sPrecedente = LeggeCampo (gsArchivio, gsSezione, gsChiave)
If !sTasti Then; se nessun tasto valido  stato rilevato,
If !sPrecedente Then; se nessun tasto  registrato,
Let gnCampo = PRIMA; torna alla schermata iniziale
EndIf; fine controllo tasti registrati
Else; altrimenti, se dei tasti sono stati specificati,
Let gsTastiScript = ConverteTasti (sTasti); converte I TASTI rilevati nella forma valida per i file JKM
; tenta di salvare i tasti definiti nell'archivio di dati
If ScriveCampo (gsArchivio, gsSezione, gsChiave, gsTastiScript) Then; se la scrittura riesce,
SayMessage (OT_ERROR, msgOkTasti); avvisa dell'esito positivo,
Let gnCambiati = TRUE; e attiva il controllo nell'archivio degli script a gestione personale
If !sPrecedente Then; se il dato non esisteva,
Let gnFerma = CATTURA; ripristina il valore, per consentire il passaggio diretto alla schermata successiva
EndIf; fine controllo preesistenza dato
If sTasti != sPrecedente Then; se in ogni caso i tasti sono cambiati,
Let gsNuoviTasti = CambiaCampo (gsNuoviTasti, gsChiave, ULTIMA); aggiunge la chiave corrente
EndIf; fine controllo modifica tasti
Else; altrimenti, in caso di errore,
Let gnCampo = PRIMA; torna alla schermata iniziale
EndIf; fine controllo scrittura
EndIf; fine controllo presenza dato
Let gnSalta = TRUE; consente di rientrare nei cicli senza resettare le impostazioni,
CallFunctionByName (ELABORA + DATO, gsSuffisso, TRUE); e torna alla procedura principale
EndFunction

Void Function InterrompeAttesa (string sTasti)
If gnScriveTasto Then; se la cattura dei tasti premuti  stata avviata,
Let gnConta = gnConta + 1; aggiorna il contatore delle chiavi,
ScriveDato (TEMPORANEO, TASTI, IntToString (gnConta), sTasti); e vi annota i tasti rilevati
If sTasti== INVIO ; se si  premuto il tasto Invio,
|| sTasti== ESC Then; oppure, se si  premuto il tasto Escape,
CallFunctionByName (TASTI_HOOK); esegue le azioni conseguenti
EndIf; fine controllo tasti
EndIf; fine controllo trascrizione
EndFunction

Script MetteMacroTesto5 ()
MetteTesto (PRE_PROCESS_KEY, TRUE); inserisce la riga di codice, andando poi a capo
EndScript

Void Function CatturaDato ()
Let gsTastiScript = NULLO; resetta il dato da impostare
Let gnEcoTastiera = GetJCFOption(OPT_TYPING_ECHO);salva le impostazioni dell'echo tastiera
Let gnVoce = PRIMA; reimposta la voce corrente sull'unica possibile
Let gnLivello = SECONDA; aggiorna il livello corrente del campo
SpeechOn (TRUE); riattiva comunque la sintesi
AvviaHook (); chiama la funzione per avviare l'hook di cattura tasti
EndFunction

Int Function DatiSchermata ()
Var
String sSezione, ;sezione dell'archivio della procedura
Int i, ; contatore del ciclo
String sDati, ; dati rilevati
Int iPrimo, ; indicatore del primo pulsante
String sDato; variabile temporanea

; compone il nome della sezione di cui leggere dall'archivio della procedura
Let sSezione = FormatString (msgCampo, gnCampo)
If !ChiaviUtente (gsCategoria, sSezione) Then; se nessun dato  stato trovato,
; formatta e pronuncia l'avviso,
SayFormattedMessage (OT_ERROR, hlpNoDato, hlpNoDato_corto, FormatString (msgSezioni, sSezione, gsCategoria))
PronunciaUscita (); esegue delle operazioni di chiusura, leggendo la riga corrente,
Return FALSE; e interrompe il flusso, restituendo un risultato nullo
EndIf; fine controllo dati
Let gnTipo = LeggeNumerico (gsCategoria, ELABORA, TIPO); rileva il tipo di procedura impostato
Let sDati = LeggeRecord (gsCategoria, sSezione, TITOLO); rileva l'eventuale titolo memorizzato
If gnTipo == TERZA Then; se si sta operando su pi campi,
Let gsTermine = StringSegment (sDati, SPACE, TERZA); estrae la terza parola del titolo
Else; altrimenti, se si  nei primi due tipi di procedura,
; lo prende formattando categoria e oggetto della procedura
Let gsTermine = FormatString (msg2, gsCategoria, gsOggetto)
EndIf; fine controllo termine da formattare
If sDati Then; se un titolo  stato rilevato,
If gnCampo == PRIMA Then; se si  nella schermata iniziale,
Let gsTitolo = FormatString (sDati, gsTermine); personalizza il titolo con l'apposito termine
Else; altrimenti, nei campi dal secondo in poi,
; personalizza il titolo con la voce della schermata iniziale
Let gsTitolo = FormatString (sDati, gsAttiva)
EndIf; fine controllo campi
Else; altrimenti, se il titolo non c',
Let gsTitolo = FormatString (ttlSelezione); imposta un titolo generico
EndIf; fine controllo titolo
; resetta i dati per:
Let gsEtichette = NULLO; etichette dei pulsanti
Let gsMinimi = NULLO; valori minimi per attivare un pulsante
Let gsMassimi = NULLO; valori massimi per attivare un pulsante
For i = 1 To MAX_PULSANTI; scorre i possibili dati
; tenta di rilevare le impostazioni
Let sDati = LeggeRecord (gsCategoria, sSezione, FormatString (msgPulsante, i))
If sDati Then; se dei dati sono stati rilevati,
Let sDato = StringSegment (sDati, PIPE, SECONDA); rileva il valore minimo valido per la voce
If !sDato Then; se nessun dato  stato rilevato,
Let sDato = UNO; imposta il valore predefinito in forma testuale
EndIf; fine controllo valore minimo
If !iPrimo Then; se si  al primo passaggio, inizializza gli elenchi per:
Let gsEtichette = StringSegment (sDati, PIPE, PRIMA); etichette dei pulsanti
Let gsMinimi = sDato; valore minimo per attivare il pulsante
Let gsMassimi = StringSegment (sDati, PIPE, TERZA); valore massimo per attivare il pulsante
Let iPrimo = TRUE; valorizza l'indicatore
Else; altrimenti, aggiunge il risultato ai rispettivi elenchi
Let gsEtichette = gsEtichette + FormatString (msgPipe, StringSegment (sDati, PIPE, PRIMA))
Let gsMinimi = gsMinimi + FormatString (msgPipe, sDato)
Let gsMassimi = gsMassimi + FormatString (msgPipe, StringSegment (sDati, PIPE, TERZA))
EndIf; fine controllo passaggi
EndIf; fine controllo dati
EndFor; fine scansione dati pulsanti
; rileva i dati relativi a:
; un prefisso numerico davanti alle voci
Let gnNumerico = LeggeNumerico (gsCategoria, sSezione, NUMERICO)
; le informazioni per i campi di elaborazione testo
Let gsInfo = LeggeRecord (gsCategoria, sSezione, INFO)
; l'assenso all'immissione di voci su pi righe
Let gnMultiple = LeggeNumerico (gsCategoria, sSezione, MULTIPLE)
; la conferma all'uscita dalla procedura
Let gnConferma = LeggeNumerico (gsCategoria, sSezione, CONFERMA)
; il prefisso della funzione da chiamare alla fine della procedura
Let gsChiama = LeggeRecord (gsCategoria, sSezione, CHIAMA)
Return TRUE; se i settaggi si sono conclusi, restituisce l'esito positivo
EndFunction

Int Function VociCampo ()
If !CercaVoci (gsSezione, gsSuffisso) Then; se il flusso  stato interrotto,
If gnFerma == CATTURA Then; se si devono specificare i tasti per attivare uno script,
CatturaDato (); chiama l'apposita funzione,
Return FALSE; e restituisce un risultato nullo
ElIf gsCategoria == SCRIPTS ; se si stanno elaborando gli script a gestione personale,
&& !gnTotali Then; e se non  ancora stata definita alcuna voce,
If !DuplicaDati () Then; se non  nemmeno stato scelto uno script dall'archivio,
PronunciaUscita (); esegue delle operazioni di chiusura, leggendo la riga corrente,
Return FALSE; e restituisce un risultato nullo
EndIf; fine controllo duplicazione script
ElIf gnTotali && !NumeroDati (gsChiave) Then; se esistono dei campi, ma non tutti,
Let gnCampo = PRIMA; imposta di tornare alla schermata iniziale,
Let gnSalta = FALSE; resetta il valore per l'avvio delle normali schermate,
; DatiSchermata (); ed aggiorna i dati della finestra di dialogo
Else; altrimenti, se si  scelto di uscire dalla procedura,
If gsNuoviTasti Then; se si sono modificate assegnazioni tasti degli script personali,
AggiornaTasti (); trascrive tali modifiche nel file tasti dell'applicazione
EndIf; fine controllo assegnazioni modificate
PronunciaUscita (); esegue delle operazioni di chiusura, leggendo la riga corrente,
Return FALSE; e restituisce un risultato nullo
EndIf; fine controllo indicazione tasti
EndIf; fine controllo voci registrate
If gnCampo != gnLivello Then; se la procedura arriva da un altro campo,
Let gnStato = FALSE; annulla comunque la programmazione della sintesi
If gnCampo == PRIMA Then; se si arriva nella schermata iniziale,
Suona (PRIMO_SEGNO); emette una scala di note ascendenti,
; e ripristina l'ultimo valore confermato del precedente passaggio
Let gnVoce = StringToInt (LeggeRecord (gsArchivio, gsSezione, ZERO))
Else; altrimenti, in tutte le altre schermate,
If !gnSalta Then; se non si proviene da una immissione di testo,
Suona (Nota (gnCampo - 1), RITARDA); emette la nota abbinata al campo corrente
EndIf; fine controllo immissione testo
Let gnVoce = 1; inizializza il valore
EndIf; fine controllo campo
Let gnLivello = gnCampo; risincronizza i valori controllati dal ciclo
Else; altrimenti, se si  rimasti allo stesso livello,
;Let gnStato = TRUE; imposta comunque la programmazione della sintesi
EndIf; fine controllo livelli
If !gnVoce Then; se un valore non  ancora impostato,
Let gnVoce = 1; lo inizializza
EndIf; fine controllo voce corrente
Return TRUE; restituisce l'esito positivo
EndFunction

String Function CreaVoci ()
Var
Int iStart, ; valore dal quale far partire il ciclo
Int iValide, ; numero delle voci da inserire nell'elenco
Int i, ; contatore del ciclo
String sChiave, ; singola chiave da elaborare
String sRecord, ; dati registrati
String sDato, ; voce temporanea
String sNum, ; prefisso numerico
String sVoci, ; elenco da restituire
String sTipi; tipi di finestra registrati

If gsCategoria != SCRIPTS ; se non si stanno elaborando gli script a gestione personale,
|| gnCampo < gnMaxCampi Then; oppure, se non si  nell'ultimo campo,
If gnNumerico Then; se si deve porre il prefisso numerico,
Let iStart = PRIMA; imposta il valore di partenza
Let iValide = gnTotali; propone tutte le voci dell'elenco
Else; altrimenti, se l'le voci sono senza numeri,
If gnCampo == PRIMA Then; se se si sta elaborando il primo campo,
Let iStart = PRIMA; imposta di partire dalla voce iniziale,
Let iValide = gnTotali; e fa coincidere il numero totale delle voci con quelle da creare
Else; altrimenti, per i campi dal secondo in poi,
Let iStart = StringSegmentIndex (gsElenco, PIPE, gsChiave, TRUE); rileva la posizione della voce attiva,
Let iValide = iStart; e duplica il valore per limitare le voci ad una
EndIf; fine controllo campo
EndIf; fine controllo prefisso
For i = iStart To iValide; scorre il numero di voci definito
Let sChiave = ChiaveCorrente (i); compone la chiave attiva sulla base del tipo di procedura
If gnNumerico Then; se si  indicato di aggiungere il prefisso numerico alle voci,
Let sNum = FormatString (msgNumerico, sChiave); lo imposta
EndIf; fine controllo prefisso
Let sRecord = LeggeRecord (gsArchivio, gsSezione, sChiave); rileva l'intero record di dati
; estrae il dato del solo campo elaborato, casomai premettendovi il prefisso numerico
Let sDato = sNum + StringSegment (sRecord, PIPE, gnCampo)
; e lo aggiunge all'elenco frapponendovi il carattere Bell, Ascii 7
Let sVoci = CambiaCampo (sVoci, sDato, ULTIMA, BELL)
EndFor; fine scansione chiavi
Return sVoci; restituisce il nuovo elenco con i dati
Else; altrimenti, nell'ultimo campo degli script personali,
; rileva i tipi di finestre registrati, rimuovendo il tipo Editing in quanto non selezionabile
Let sTipi = CambiaCampo (LeggeChiavi (PERSONALE, TIPI_FINESTRE), EDITING)
; compone l'elenco con una voce neutra, gli ambiti predefiniti e i tipi di finestra registrati
Let gsElenco = FormatString (msg3Pipe, NESSUNO, lstAmbitiScript, sTipi)
; rileva l'eventuale dato presente nell'ultimo campo del record
Let gsAmbito = LeggeCampo (gsArchivio, gsSezione, gsChiave, gnMaxCampi)
If !CampoTrovato (gsElenco, gsAmbito, gnVoce) Then; se il dato nell'elenco non c',
Let gnVoce = 1; imposta di posizionarsi sulla prima voce dell'elenco
EndIf; fine controllo posizione dato
Return ConverteInBell (gsElenco, PIPE); restituisce l'elenco, sostituendo il separatore
EndIf; fine controllo campo
EndFunction

Void Function AttivaSintesi ()
SpeechOn (TRUE); riattiva la sintesi, resettando il buffer
If gsAvviso Then; se un messaggio  stato impostato,
SayUsingVoice (VCTX_JAWSCURSOR, gsAvviso, OT_HELP); lo pronuncia,
Let gsAvviso = NULLO; e lo resetta
ElIf gsVoce Then; se invece  impostata la voce attiva,
SayUsingVoice (VCTX_PCCURSOR, gsVoce, OT_HELP); la pronuncia
Else; altrimenti, se nessun testo  impostato,
SayLine (); pronuncia il contenuto della riga corrente
EndIf; fine controllo testo da leggere
EndFunction

Void Function ControllaProgrammato ()
If gsAvviso Then; se un avviso  stato impostato,
QueueFunction (ATTIVA_SINTESI); lo pronuncia, impostando l'attesa per la fine del parlato
EndIf; fine controllo avviso
If gnStato Then; se la sintesi va riavviata in modo programmato,
SpeechOff (TRUE); spegne in ogni caso la sintesi
AnnullaProgrammato (); cancella un eventuale avvio programmato gi impostato
Let gnProgrammato = ScheduleFunction (ATTIVA_SINTESI, RITARDA); e ne imposta uno nuovo
Let gnStato = FALSE; annulla il valore
ElIf IsSpeechOff () Then; se la sintesi  ancora spenta,
SpeechOn (TRUE); la riattiva
EndIf; fine controllo stato sintesi
EndFunction

Int Function DatiCompleti (string sIgnora)
Var
Int i, ; contatore del ciclo
String sChiave, ; chiave del singolo record
String sRecord, ; record di dati
String sChiavi, ; record non validi
String sDati, ; dati principali dei record errati
String sDato, ; singolo dato del record
String sTitolo, ; titolo della finestra di conferma
Int k; contatore dei record rimossi

For i = 1 To StringSegmentCount (gsElenco, PIPE); scorre le chiavi dei record
Let sChiave = ChiaveCorrente (i); estrae la singola chiave
If !CampoTrovato (sIgnora, sChiave) Then; se la chiave del record non  da escludere,
If !NumeroDati (sChiave, sRecord) Then; se il numero dei dati  errato,
Let sDato = StringSegment (sRecord, PIPE, PRIMA); estrae il dato iniziale
Let sChiavi = CambiaCampo (sChiavi, sChiave, ULTIMA); aggiunge la chiave in coda
Let sDati = CambiaCampo (sDati, sDato, ULTIMA, VIRGOLA_SPAZIO); pone una virgola tra i dati
EndIf; fine controllo dati validi
EndIf; fine controllo chiavi valide
EndFor; fine scansione chiavi
If !sChiavi Then; se tutti i record sono completi,
Return TRUE; restituisce l'esito positivo
EndIf; fine controllo chiavi valide
If sDati Then; se l'elenco non  vuoto,
Let sDati = FormatString (msgVirgola, sDati); aggiunge una virgola alla fine dell'elenco
EndIf; fine controllo dati principali errati
; formatta il titolo della finestra di dialogo con la conferma
Let sTitolo = FormatString (ttlDatiMancanti, StringSegmentCount (sChiavi, PIPE), sDati)
If !ChiedeConferma (sTitolo, msgRimozioneDati,FALSE, SECONDA) Then;se non si vuole continuare,
; aggiorna la posizione del puntatore della voce attiva
Let gnVoce = StringToInt (TroncaTesto (sChiavi))
Return FALSE; e restituisce un risultato nullo
EndIf; fine controllo conferma
For i = 1 To StringSegmentCount (sChiavi, PIPE); scorre i record da rimuovere
; se la cancellazione riesce,
If CancellaChiave (CORRENTE, gsSezione, StringSegment (sChiavi, PIPE, i)) Then
Let k = k + 1; aggiorna il contatore
EndIf; fine controllo cancellazioni
EndFor; fine scansione record errati
Let i = i - 1; toglie un'unit al contatore per renderlo effettivo
If k == i Then; se tutte le cancellazioni sono riuscite, formatta e legge l'avviso
SayFormattedMessage (OT_ERROR, hlpRimuoviRecord, NULLO, k, PersonaMaschile (k))
Else; altrimenti, se ci sono stati degli errori,
If !k Then; se nessuna cancellazione  riuscita, propone il numero delle mancate rimozioni
SayFormattedMessage (OT_ERROR,hlpErroreRecord, NULLO, CANCELLA, i)
Else; altrimenti, se la cancellazione  stata parziale
; mostra entrambi i valori
SayFormattedMessage (OT_ERROR,hlpErroreRecord, NULLO, CANCELLA, i - k, SU, i)
EndIf; fine controllo tipo errore
EndIf; fine controllo cancellazioni
Return TRUE; restituisce l'esito positivo
EndFunction

Int Function UscitaProcedura ()
If gnCampo > PRIMA Then; se si  dalla seconda schermata in poi,
Let gnCampo = PRIMA; imposta di tornare all'inizio,
Let gnAggiorna = TRUE; e di uscire dal ciclo di aggiornamento campo
ElIf !gnConferma ; se invece non  prevista alcuna conferma all'uscita,
|| ChiedeConferma () Then; oppure, se la conferma all'uscita ha avuto esito positivo,
SpeechOn (TRUE); riattiva comunque la sintesi
; controlla se i dati registrati sono validi, dovendo avere ciascuno il giusto numero di campi
If DatiCompleti (ZERO) Then; se cos ,
If gsNuoviTasti Then; se si sono modificate assegnazioni tasti degli script personali,
AggiornaTasti (); trascrive tali modifiche nel file tasti dell'applicazione
EndIf; fine controllo assegnazioni modificate
PronunciaUscita (); esegue delle operazioni di chiusura, leggendo la riga corrente,
Return TRUE; e restituisce la conferma all'uscita
EndIf; fine controllo validit record
Else; altrimenti, se i dati non sono completi, e si deve tornare alla procedura,
Let gnStato = ControllaSintesi (FALSE, TRUE); spegne la sintesi, con l'azzeramento del buffer
EndIf; fine controllo conferme
EndFunction

